#include "testModulo1.h"
#include "modulo1.c"

int test_leggiFile(int tipo_di_test, int n_argomento)
{
	char testfile[25]={"./testfile.txt"};
	char test[1000];
	char testo[10]={"ok\0"};
	FILE *ts;
	switch(n_argomento)
	{
		case 0:
		{	
			if((tipo_di_test==3)||(tipo_di_test==6)||(tipo_di_test==8)||(tipo_di_test==9)||(tipo_di_test==10)||(tipo_di_test==11)||(tipo_di_test==12))
				return NOT_VALID;
			switch(tipo_di_test)
			{
				case 0:
					//testfile={"./result_ok_txt"};
					ts=fopen(testfile, "w");
					putc('o',ts);
					putc('k',ts);
					fclose(ts);
					//testo[]={"ok\0"};
					if(leggiFile(testfile,3,test)==RESULT_OK){
						if(strcmp(testo,test)==0)
							return TEST_PASSED;
						else
							printf("Test fallito: funzione testata: leggiFile(testfile,3,test)\n\trisultato atteso: RESULT_OK\n\trisultato ottenuto: RESULT_OK\n\tspiegazione: nonostanre il corretto ritorno di codice la stringa testo non contiene la stessa sequenza di caratteri dell'email");
					}
					else
						printf("Test fallito: funzione testata: leggiFile(testfile,3,test)\n\trisultato atteso: RESULT_OK\n\trisultato ottenuto: ERRATO\n\tspiegazione: la funzione da errore nonostante i parametri corretti");
					return TEST_FAILED;
				case 2:
					switch(leggiFile(NULL,3,test))
					{
						case 0:
							printf("Test fallito: funzione testata: leggiFile(NULL,3,test)\n\trisultato atteso: NULL_POINTER\n\trisultato ottenuto: RESULT_OK\n\tspiegazione: La funzione non controlla se il primo argomento e'' un puntatore NULL.");
							return TEST_FAILED;
						case 2:
							return TEST_PASSED;
						default:
							printf("Test fallito: funzione testata: leggiFile(NULL,3,test)\n\trisultato atteso: NULL_POINTER\n\trisultato ottenuto: ERRATO\n\tspiegazione: la funzione rileva un errore diverso da quello reale.");
							return TEST_FAILED;
					}
				case 4:
					//testfile={"./la_probabilita_ke_esista_questo_file_e_nulla.txt\0"};
					switch(leggiFile(testfile,3,testo)){
						case 0:
							printf("Test fallito: funzione testata: leggiFile(testfile,3,test)\n\trisultato atteso: FILE_MISSING\n\trisultato ottenuto: RESULT_OK\n\tspiegazione: La funzione non controlla se il file esiste,");
							return TEST_FAILED;
						case 4:
							return TEST_PASSED;
						case 7:
							printf("Test fallito: funzione testata: leggiFile(testfile,3,test)\n\trisultato atteso: FILE_MISSING\n\trisultato ottenuto: FILE_EMPTY\n\tspiegazione: la funzione probabilmente aprendo un file inesistente in modalita scrittura lascia la liberta alla fopen di crearlo");
							return TEST_FAILED;
						default:
							printf("Test fallito: funzione testata: leggiFile(testfile,3,test)\n\trisultato atteso: FILE_MISSING\n\trisultato ottenuto: ERRATO\n\tspiegazione: la funzione rileva un errore diverso da quello reale.");
							return TEST_FAILED;
					}
				case 5:
					return NOT_IMPLEMENTED; //kome posso farlo??? :'(
				case 7:
					//testfile={"./creo_un_file_vuoto.txt\0"};
					ts=fopen(testfile, "w");
					switch(leggiFile(testfile,3,test)){
						case 0:
							printf("Test fallito: funzione testata: leggiFile(testfile,3,test)\n\trisultato atteso: FILE_EMPTY\n\trisultato ottenuto: RESULT_OK\n\tspiegazione: La funzione non controlla se il file e'' vuoto,");
							return TEST_FAILED;
						case 7:
							return TEST_PASSED;
						default:
							printf("Test fallito: funzione testata: leggiFile(testfile,3,test)\n\trisultato atteso: FILE_EMPTY\n\trisultato ottenuto: ERRATO\n\tspiegazione: la funzione rileva un errore diverso da quello reale.");
					}
				default:
						return NOT_IMPLEMENTED;
			}
		}
		case 2:
		{
			if(n_argomento!=8)
				return NOT_VALID;
			//testfile={"./file_test_buffer"};
			ts=fopen(testfile,"w");
			putc('o',ts);
			putc('k',ts);
			fclose(ts);
			if(leggiFile(testfile,1,test)==BUFFER_TOO_SMALL)
				return TEST_PASSED;
			else
				printf("Test fallito: funzione testata: leggiFile(testfile,1,test)\n\trisultato atteso: BUFFER_TOO_SMALL\n\trisultato ottenuto: ERRATO\n\tspiegazione: La funzione non controlla se il buffer e'' sufficentemente grande,");
			return TEST_FAILED;
		}
		case 3:
		{
			if(n_argomento!=2)
				return NOT_VALID;
			//testfile={"./file_test_buffer"};
			ts=fopen(testfile,"w");
			putc('o',ts);
			putc('k',ts);
			fclose(ts);
			if(leggiFile(testfile,1,NULL)==NULL_POINTER)
				return TEST_PASSED;
			else
				printf("Test fallito: funzione testata: leggiFile(testfile,1,test)\n\trisultato atteso: NULL_POINTER\n\trisultato ottenuto: ERRATO\n\tspiegazione: La funzione non controlla se il buffer e'' un puntatore nullo,");
			return TEST_FAILED;
		}
	}
	remove(testfile);
}
