#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<sys/stat.h>
#include<sys/types.h>
#include <fcntl.h>
#include "testModulo1.h"

int test_leggiFile(int tipo_di_test, int argomento)
{
  FILE* fp;
  char* NULLptr=NULL;
  char emptyString[1]={'\0'};
  char EmailPtr[10]={'e','m','a','i','l','.','t','x','t','\n'};
  char foo[4]={'f','o','o','\n'};
  char* prova;
  int error;

  switch(argomento)
    {
    case 1:
      {
	switch(tipo_di_test)
	  {
	  case 2:
	    {
	      if((error=leggiFile(NULLptr,0,EmailPtr))==NULL_POINTER)return TEST_PASSED;
	      else
		{
		  printf("test fallito:");
		  printf("funzione testata:leggiFile(NULLptr,0,EmailPtr)\n");
		  printf("\t risulato atteso:%d\n",tipo_di_test);
		  printf("\t risulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se il punatore  nullo\n");
		  return TEST_FAILED;
		}
	      break;
	    }
	  case 3:
	    {
	      if((error=leggiFile(emptyString,0,EmailPtr))==EMPTY_STRING)return TEST_PASSED;
	      else
		{
		  printf("test fallito:");
		  printf("funzione testata:leggiFile(emptyString,0,EmailPtr)\n");
		  printf("\t risulato atteso:%d\n",tipo_di_test);
		  printf("\t risulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se la stringa  vuota\n");
		  return TEST_FAILED;
		}
	      break;
	    }
	  case 4:
	    {
	      if((error=leggiFile(foo,0,EmailPtr))==FILE_MISSING)return TEST_PASSED;
	      else 
		{
		  printf("test fallito:");
		  printf("funzione testata:leggiFile(foo,0,EmailPtr)\n");
		  printf("\t risulato atteso:%d\n",tipo_di_test);
		  printf("\t risulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se il file non esiste\n");
		  return TEST_FAILED;
		}	
	      break;
	    }
	  case 5:
	    {
	      creat(EmailPtr,O_WRONLY);
	      if((error=leggiFile(EmailPtr,0,prova))==FILE_UNREADABLE)return TEST_PASSED;
	      else
		{
		  printf("test fallito:");
		  printf("funzione testata:leggiFile(EmailPtr,0,prova)\n");
		  printf("\t risulato atteso:%d\n",tipo_di_test);
		  printf("\t risulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se il file non  leggibile\n");
		  return TEST_FAILED;
		}	
	      break;
	    }
	  case 7:
	    {
	      creat(EmailPtr,O_RDWR);
	      if((error=leggiFile(EmailPtr,0,prova))==FILE_EMPTY)return TEST_PASSED;
	      else 
		{
		  printf("test fallito:");
		  printf("funzione testata:leggiFile(EmailPtr,0,prova)\n");
		  printf("\t risulato atteso:%d\n",tipo_di_test);
		  printf("\t risulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se il file  vuoto\n");
		  return TEST_FAILED;
		}		
	    }
	      break;
	    }
      }
      break;
    case 2:
      {
	switch(tipo_di_test)
	  {
	  case 8: 
	    {
	      if((error=leggiFile(foo,0,prova))==BUFFER_TOO_SMALL)
		return TEST_PASSED;
	      else 
		{
		  printf("test fallito:");
		  printf("funzione testata:leggiFile(foo,0,prova)\n");
		  printf("\t risulato atteso:%d\n",tipo_di_test);
		  printf("\t risulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se il buffer  troppo piccolo\n");
		    return TEST_FAILED;
		}
	      break;
	    }
	  default: 
	    return NOT_IMPLEMENTED;
	    break;
	  }
      }
    case 3:
      {
	switch(tipo_di_test)
	  {
	    case 2:
	      {
		if((error=leggiFile(EmailPtr,0,NULLptr))==NULL_POINTER)return TEST_PASSED;
		else
		  {
		    printf("test fallito:");
		    printf("funzione testata:leggiFile(EmailPtr,0,NULLptr)\n");
		    printf("\t risulato atteso:%d\n",tipo_di_test);
		    printf("\t risulato ottenuto:%d\n",error);
		    printf("\tla funzione non controlla se il buffer c' un puntatore nullo\n");
		    return TEST_FAILED;
		  }
		break;
	      }
	  default:
	    return NOT_VALID;
	  }
	    case 8:
	      {
		
		fp=fopen("test","w");
		fputs("prova",fp);
		prova=(malloc(3*sizeof(char)));
		if((error=leggiFile("test",3,prova))==BUFFER_TOO_SMALL)
		  return TEST_PASSED;
		else 
		   {
		    printf("test fallito:");
		    printf("funzione testata:leggiFile(test,3,prova)\n");
		    printf("\t risulato atteso:%d\n",tipo_di_test);
		    printf("\t risulato ottenuto:%d\n",error);
		    printf("\tla funzione non controlla se il buffer  troppo piccolo\n");
		    return TEST_FAILED;
		  }
		  
		break;	
	      }
	    default: return NOT_VALID;
	    }
	  break;
	}
}

int test_estraiHeaders(int tipo_di_test, int argomento)
{
  char* NULLptr=NULL;
  char emptyString[1]={'\0'};
  char EmailPtr[7]={'b','l','a','b','l','a','\n'};
  char* prova;
  int error;
 
 switch(argomento)
   {
   case 1:
     {
       switch(tipo_di_test)
	 {
	 case 2:
	   {
	     if((error=estraiHeaders(NULLptr,EmailPtr,15))==NULL_POINTER)return TEST_PASSED;
	     else 
	       {
		 printf("test fallito:");
		 printf("funzione testata:estraiHeaders(NULLptr,EmailPtr,15)\n"); 
		 printf("\t risulato atteso:%d\n",tipo_di_test);
		 printf("\t risulato ottenuto:%d\n",error);
		 printf("\tla funzione non controlla  un puntatore nullo\n");
		 return TEST_FAILED;
	       }
	     break;
	   }
	 case 3:
	    {
	      if((error=estraiHeaders(emptyString,EmailPtr,15))==EMPTY_STRING)return TEST_PASSED;
	      else
		{
		  printf("test fallito:");
		  printf("funzione testata:estraiHeaders(emptyString,EmailPtr,15\n");
		  printf("\t risulato atteso:%d\n",tipo_di_test);
		  printf("\t risulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se la stringa  vuota\n");
		  return TEST_FAILED;
		}
	      break;
	    }
	 default: return NOT_VALID;
	 }
     }
   case 2:
     {
       switch(tipo_di_test)
	 {
	 case 2:
	   {
	      if((estraiHeaders(EmailPtr,NULLptr,15))==NULL_POINTER)return TEST_PASSED;
	      else
		{
		  printf("test fallito:");
		  printf("funzione testata:estraiHeaders(EmailPtr,NULLptr,15)\n");
		  printf("\t risulato atteso:%d\n",tipo_di_test);
		  printf("\t risulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla  un puntatore nullo\n");
		  return TEST_FAILED;
		}
	      break;
	   }
	 case 8:
	   {
	     prova=malloc(2*sizeof(char));
	     if((error=estraiHeaders(EmailPtr,prova,2))==BUFFER_TOO_SMALL)return TEST_PASSED;
	     else 
	       {
		 printf("test fallito:");
		 printf("funzione testata:estraiHeaders(EmailPtr,prova,2)\n");
		 printf("\trisulato atteso:%d\n",tipo_di_test);
		 printf("\trisulato ottenuto:%d\n",error);
		 printf("\tla funzione non controlla se il buffer  troppo piccolo \n");
		 return TEST_FAILED;
	       }  
	     break; 
	   }
	 case 9:
	   {
	     prova=malloc(20*sizeof(char));
	     if((error=estraiHeaders(EmailPtr,prova,20))==HEADER_NOT_FOUND)return TEST_PASSED;
	     else 
	       {
		 printf("test fallito:");
		 printf("funzione testata:estraiHeaders(EmailPtr,prova,20)\n");
		 printf("\trisulato atteso:%d\n",tipo_di_test);
		 printf("\trisulato ottenuto:%d\n",error);
		 printf("\tla funzione non controlla se l'header non  stato trovato\n");
		 return TEST_FAILED;
	       }  
	     break;  
	   }
	 }
     }
   case 3:
      {
	switch(tipo_di_test)
	  {
	  case 8:
	    {
	    if((error=estraiHeaders(EmailPtr,prova,-15))==BUFFER_TOO_SMALL)return TEST_PASSED;
	    else 
	      {
		printf("test fallito:");
		printf("funzione testata:estraiHeaders(EmailPtr,prova,-15)\n");
		printf("\trisulato atteso:%d\n",tipo_di_test);
		printf("\trisulato ottenuto:%d\n",error);
		printf("\tla funzione non controlla se il buffer  troppo piccolo \n");
		 return TEST_FAILED;
	      }    
	    }
	  }
   default: 
     return NOT_VALID;
     break;
     //argomento
      }//test_function
   }
}
int test_primoHeader(int tipo_di_test, int argomento)
{
  
  char* NULLptr=NULL;
  char emptyString[1]={'\0'};
  char headerPtr[7]={'b','l','a','b','l','a','\n'};
  char foo[4]={'f','o','o','\n'};
  char* prova;
  int error;
  
  switch(argomento)
    {
    case 1:
      {
	switch(tipo_di_test)  
	  {
	  case 2:
	    {
	      if((error=primoHeader(NULLptr,foo,15))==NULL_POINTER)return TEST_PASSED;
	      else 
		{
		  printf("test fallito");
		  printf("funzione testata:primoHeader(NULLptr,foo,15)\n");
		  printf("\trisulato atteso:%d\n",tipo_di_test);
		  printf("\trisulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se  un puntatore nullo\n");
		  return TEST_FAILED;
		}    
	      break;
	    }
	  case 3:
	    {
	      if((error=primoHeader(emptyString,foo,15))==EMPTY_STRING)return TEST_PASSED;
	      else
		{
		  printf("test fallito");
		  printf("funzione testata:primoHeader(emptyString,foo,15)\n");
		  printf("\trisulato atteso:%d\n",tipo_di_test);
		  printf("\trisulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se  una stringa vuota\n");
		  return TEST_FAILED;
		}	
	      break;
	    }
	  default: return NOT_IMPLEMENTED;
	  }//switch_test
      }//case 1
    case 2:
      {
	switch(tipo_di_test)  
	  {
	  case 2:
	    {
	      if((error=primoHeader(foo,NULLptr,15))==NULL_POINTER)return TEST_PASSED;
	      	
	      else
                {
		  printf("test fallito");
		  printf("funzione testata:primoHeader(foo,NULLptr,15)\n");
		  printf("\trisulato atteso:%d\n",tipo_di_test);
		  printf("\trisulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se  un puntatore nullo\n");
		  return TEST_FAILED;
		}
	      break;
	    }
	  case 8:
	    {
	      prova=malloc(4*sizeof(char));
	      if((error=primoHeader(headerPtr,prova,sizeof(prova)))==BUFFER_TOO_SMALL)return TEST_PASSED;
	      else 
		{
		  printf("test fallito:");
		  printf("funzione testata:primoHeader(headerPtr,prova,sizeof(prova))\n");
		  printf("\trisulato atteso:%d\n",tipo_di_test);
		  printf("\trisulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se il buffer  troppo piccolo \n");
		  return TEST_FAILED;
	      }    
	      break;
	    }
	  case 11:
	    {
	      prova=malloc(15*sizeof(char));
	      if((error=primoHeader(headerPtr,prova,15))==BAD_HEADER)return TEST_PASSED;
	      else 
		{
		  printf("test fallito:");
		  printf("funzione testata:estraiHeaders(headerPtr,prova,15)\n");
		  printf("\trisulato atteso:%d\n",tipo_di_test);
		  printf("\trisulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se l'header non  ben formattato\n");
		  return TEST_FAILED;
		}
	      break;
	    }
	  default:
	    return NOT_VALID;
	    break;
	  }
      }
	  
    case 3:
      {
	switch(tipo_di_test)
	  {
	  case 8:
	    {
	      prova=malloc(4*sizeof(char));
	      if((error=primoHeader(headerPtr,prova,sizeof(prova)))==BUFFER_TOO_SMALL)return TEST_PASSED;
	      else 
		{
		  printf("test fallito:");
		  printf("funzione testata:primoHeader(headerPtr,prova,sizeof(prova))\n");
		  printf("\trisulato atteso:%d\n",tipo_di_test);
		  printf("\trisulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se il buffer  troppo piccolo \n");
		  return TEST_FAILED;
		}    
	      break;
	    }
	  default:
	    return NOT_VALID;
	  }
      }
    default:
      return ARG_MISSING;
    }
}
int test_parseHeader(int tipo_di_test, int argomento)
{
  char* NULLptr=NULL;
  char emptyString[1]={'\0'};
  char* prova;
  int error;

  switch(argomento)
    {
    case 1:
      {
	switch(tipo_di_test)  
	  {
	  case 1:
	    {
	      prova=(char*)malloc(4*sizeof(char));
	      if((error=parseHeader(NULLptr,prova,4,prova,4))==NULL_POINTER)return TEST_PASSED;
	      else
		{
		  printf("test fallito:");
		  printf("funzione testata:leggiFile(NULLptr,0,EmailPtr)\n");
		  printf("\t risulato atteso:%d\n",tipo_di_test);
		  printf("\t risulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se il punatore  nullo\n");
		  return TEST_FAILED;
		}
	      break;
	    }
	  case 3:
	    { 
	      prova=(char*)malloc(4*sizeof(char));
	      if((error=parseHeader(emptyString,prova,4,prova,4))==EMPTY_STRING)return TEST_PASSED;
	      else 
		{
		  printf("test fallito:");
		  printf("funzione testata:leggiFile(emptyString,0,EmailPtr)\n");
		  printf("\t risulato atteso:%d\n",tipo_di_test);
		  printf("\t risulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se la stringa  vuota\n");
		  return TEST_FAILED;
		}
	      break;
	    }	    
	  }
      }
      case 2:
	{
	  switch(tipo_di_test)  
	    {
	    case 1:
	      {
		prova=(char*)malloc(4*sizeof(char));
		if((error=parseHeader(prova,NULLptr,4,prova,4))==NULL_POINTER)return TEST_PASSED;
		else
		  {
		    printf("test fallito:");
		    printf("funzione testata:parseHeader(prova,NULLptr,4,prova,4)\n");
		    printf("\t risulato atteso:%d\n",tipo_di_test);
		    printf("\t risulato ottenuto:%d\n",error);
		    printf("\tla funzione non controlla se il punatore  nullo\n");
		    return TEST_FAILED;
		  }
		break;
	      }
	    }
	}       
	  //buffer_too_small
	case 3:
	  {
	    switch(tipo_di_test)  
	      {
	      case 8:
		{ 
		  prova=(char*)malloc(4*sizeof(char));
		  if((error=parseHeader(prova,prova,0,prova,4))==BUFFER_TOO_SMALL)return TEST_PASSED;
		  else 
		    {
		      printf("test fallito");
		      printf("funzione testata:parseHeader(prova,prova,0,prova,4)\n");
		      printf("\trisulato atteso:%d\n",tipo_di_test);
		      printf("\trisulato ottenuto:%d\n",error);
		      printf("\tla funzione non controlla se il buffer  troppo piccolon");
		      return TEST_FAILED;
		    }	
		  break;
		}
	      }
	  }
	  case 4:
	    {
	      switch(tipo_di_test)  
		{
		case 1:
		  {
		    prova=(char*)malloc(4*sizeof(char));
		    if((error=parseHeader(prova,prova,4,NULLptr,4))==NULL_POINTER)return TEST_PASSED;
		    else
		      {
			printf("test fallito:");
			printf("funzione testata:parseHeader(prova,prova,4,NULLptr,4)\n");
			printf("\t risulato atteso:%d\n",tipo_di_test);
			printf("\t risulato ottenuto:%d\n",error);
			printf("\tla funzione non controlla se il punatore  nullo\n");
			return TEST_FAILED;
		      }
		    break;
		  }
		}
	    } //buffer_too_small
    default :
      return NOT_VALID;
      break;
    }
}  
	    
int test_primaParola(int tipo_di_test, int argomento)
{

  char* NULLptr=NULL;
  char emptyString[1]={'\0'};
  char bodyPtr[7]={'b','l','a','b','l','a','\n'};
  char foo[4]={'f','o','o','\n'};
  char* prova;
  int error;
  switch(argomento)
    {
    case 1:
      {
	switch(tipo_di_test)  
	  {
	  case 1:
	    {
	      if((error=primaParola(NULLptr,foo,15))==NULL_POINTER)return TEST_PASSED;
	      else
		{
		  printf("test fallito:");
		  printf("funzione testata:(primaParola(NULLptr,foo,15))\n");
		  printf("\t risulato atteso:%d\n",tipo_di_test);
		  printf("\t risulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se il punatore  nullo\n");
		  return TEST_FAILED;
		}
	      break;
	    }
	  case 3:
	    {
	      if((error=primaParola(emptyString,foo,15))==EMPTY_STRING)return TEST_PASSED;
	      else 
		{
		  printf("test fallito:");
		  printf("funzione testata:primaParola(emptyString,foo,15)\n");
		  printf("\t risulato atteso:%d\n",tipo_di_test);
		  printf("\t risulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se la stringa  vuota\n");
		  return TEST_FAILED;
		}
	      break;
	    }
	  default: 
	    return NOT_VALID;
	    break;
	  }//switch_test
      }//case 1
    case 2:
      {
	switch(tipo_di_test)  
	  {
	  case 2:
	    {
	      if((error=primaParola(foo,NULLptr,15))==NULL_POINTER)return TEST_PASSED;
	      else 
		{
		  printf("test fallito:");
		  printf("funzione testata:primaParola(foo,NULLptr,15)\n");
		  printf("\t risulato atteso:%d\n",tipo_di_test);
		  printf("\t risulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se il punatore  nullo\n");
		  return TEST_FAILED;
		}
	      break;
	    }
	  case 8:
	    {
	      prova=malloc(4*sizeof(char));
	      if((error=primaParola(bodyPtr,prova,sizeof(prova)))==BUFFER_TOO_SMALL)return TEST_PASSED;
	      else 
		{
		  printf("test fallito:");
		  printf("funzione testata:primaParola(bodyPtr,prova,sizeof(prova))\n");
		  printf("\trisulato atteso:%d\n",tipo_di_test);
		  printf("\trisulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se il buffer  troppo piccolo \n");
		  return TEST_FAILED;
		}    
	      break;
	    }
	  case 11:
	    {
	      prova=malloc(15*sizeof(char));
	      if((error=primaParola(bodyPtr,prova,15))==BODY_NOT_FOUND)return TEST_PASSED;
	      else
		{
		  printf("test fallito:");
		  printf("funzione testata:primaParola(bodyPtr,prova,15)\n");
		  printf("\trisulato atteso:%d\n",tipo_di_test);
		  printf("\trisulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se il corpo del messaggio  presente \n");
		  return TEST_FAILED;
		}    
	      break;
	    }
	  default: 
	    return NOT_VALID;
	    break;
	  }//switch_test
      }
    case 3:
      {
	switch(tipo_di_test)
	  {
	  case 8:
	    {
	      prova=malloc(4*sizeof(char));
	      if((error=primaParola(bodyPtr,prova,sizeof(prova)))==BUFFER_TOO_SMALL)return TEST_PASSED;
	      else
		{
		  printf("test fallito:");
		  printf("funzione testata:primaParola(bodyPtr,prova,sizeof(prova))\n");
		  printf("\trisulato atteso:%d\n",tipo_di_test);
		  printf("\trisulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se il buffer  troppo piccolo \n");
		  return TEST_FAILED;
		}    
	      break;
	    }
	    
	  }
      }
    default :
      return NOT_VALID;
      break;
    }
}

int test_tokenizzaEmail(int tipo_di_test, int argomento)
{
 
  char* NULLptr=NULL;
  char emptyString[1]={'\0'};
  Token foo[15];
  int error;

  switch(argomento)
    {
    case 1:
      {
	switch(tipo_di_test)  
	  {
	  case 2:
	    {
	      if((error=tokenizzaEmail(NULLptr,foo,15))==NULL_POINTER)return TEST_PASSED;
	      else 
		{
		  printf("test fallito:");
		  printf("funzione testata:leggiFile(NULLptr,0,EmailPtr)\n");
		  printf("\t risulato atteso:%d\n",tipo_di_test);
		  printf("\t risulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se il punatore  nullo\n");
		  return TEST_FAILED;
		}
	      break;
	    }
	  case 3:
	    {
	      if((error=tokenizzaEmail(emptyString,foo,15))==EMPTY_STRING)return TEST_PASSED;
	      else 
		{
		  printf("test fallito:");
		  printf("funzione testata:tokenizzaEmail(emptyString,foo,15)\n");
		  printf("\t risulato atteso:%d\n",tipo_di_test);
		  printf("\t risulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se la stringa  vuota\n");
		  return TEST_FAILED;
		}
	      break;
	    }
	  
	  
	  default:
	    return NOT_VALID;
	    break;
	  }
      }
    default: 
      return NOT_IMPLEMENTED;
    }
}

int test_printTokens(int tipo_di_test, int argomento)
{

 int error;
 Token* tokens=NULL;

  switch(argomento)
    {
    case 1:
      {
	switch(tipo_di_test)  
	  {
	  case 2:
	    {
	      if((error=printTokens(tokens,15))==NULL_POINTER)return TEST_PASSED;
	      else 
		{
		  printf("test fallito:");
		  printf("funzione testata:printTokens(NULLptr,15)==NULL_POINTER\n");
		  printf("\t risulato atteso:%d\n",tipo_di_test);
		  printf("\t risulato ottenuto:%d\n",error);
		  printf("\tla funzione non controlla se il punatore  nullo\n");
		  return TEST_FAILED;
		}
	      break;
	    }
	  default:
	    return NOT_VALID;
	    break;
	  }
      }
    default:
      return NOT_IMPLEMENTED;
    }
}
