#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <testModulo1.h>

/*
typedef struct a_token {
	char *parola;
	char *contesto;
}Token;
*/

int test_leggiFile(int tipo_di_test, int argomento)
{
    char *testo; char *nomefile; int cont; FILE *in; char *prova;
    int i = 0; int dim;
    
    in = fopen("mail1.txt", "w");
    
    if (argomento > 3) return (2);
    if (argomento == 0)
    {
	prova = "From:casamia@tin.it\nTo:casatua@tin.it\n\nCiao,questa  casa mia\n\nCiao\0";
	while (prova[i] != '\0')
        {
  		putc(prova[i], in);
                i++;
        }
        fclose(in);
        nomefile = "mail1.txt";
        dim = 5000;
        testo = (char*)malloc(sizeof(char) * 5000);
        cont = leggiFile(nomefile, dim, testo);
	
	if (cont == 0)
	{
		if (strcmp(testo, prova) == 0) return (0);
		printf("Test fallito: funzione testata:  leggiFile(mail1.txt, char* #5000, 5000)\n");
		printf("              risultato atteso:  RESULT_OK\n");
		printf("              risultato ottenuto:RESULT_OK\n");
		printf("	      spiegazione:  il testo non  per quello che dovrebbe\n");
		printf("                            essere, tornando una stringa diversa, quindi\n");
		printf("                            la copia del testo della mail non va a buon\n");
		printf("                            fine, ma la funzione torna sempre RESULT_OK.\n");
		return(1);
	}
    }
    
    if (argomento == 1)
    {
        dim = 10;
        testo = (char*)malloc(sizeof(char) * 1);
        if (tipo_di_test == 2)
        {
                nomefile = NULL;
                cont = leggiFile(nomefile, dim, testo);
		
		if (cont == tipo_di_test) return (0);

		else if(cont == 0)
		{
			printf("Test fallito: funzione testata:  leggiFile(NULL, 10, char*)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il\n");
			printf("                            primo argomento  un puntatore nullo.\n");
		}

		else if(cont == 1)
		{
			printf("Test fallito: funzione testata:  leggiFile(NULL, 10, char*)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il\n");
			printf("                            primo argomento  un puntatore nullo, quindi\n");
			printf("                            quando apre il file ottiene un errore che\n");
			printf("                            non sa interpretare.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  leggiFile(NULL, 10, char*)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione leggiFile interpreta come stringa\n");
			printf("                            vuota un argomento nullo.\n");
		}

		else if(cont == 4)
		{
			printf("Test fallito: funzione testata:  leggiFile(NULL, 10, char*)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:FILE_MISSING\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il\n");
			printf("                            primo argomento  un puntatore nullo, quindi\n");
			printf("                            quando apre il file ottiene un errore che\n");
			printf("                            interpreta come file mancante.\n");
		}

		else if(cont == 5)
		{
			printf("Test fallito: funzione testata:  leggiFile(NULL, 10, char*)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:FILE_UNREADABLE\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il\n");
			printf("                            primo argomento  un puntatore nullo, quindi\n");
			printf("                            quando apre il file ottiene un errore che\n");
			printf("                            interpreta come file non leggibile.\n");
		}
		
		else if(cont == 7)
		{
			printf("Test fallito: funzione testata:  leggiFile(NULL, 10, char*)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:FILE_EMPTY\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il\n");
			printf("                            primo argomento  un puntatore nullo, quindi\n");
			printf("                            quando apre il file ottiene un errore che\n");
			printf("                            interpreta come file vuoto.\n");
		}

		else
		{
			printf("Test fallito: funzione testata:  leggiFile(NULL, 10, char*)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }
        
        else if (tipo_di_test == 3)
        {
                nomefile = (char*)malloc(sizeof(char)*1);
		nomefile[0] = '\0';
                cont = leggiFile(nomefile, dim, testo);
		if (cont == tipo_di_test) return (0);

		else if(cont == 0)
		{
			printf("Test fallito: funzione testata:  leggiFile('\0', 10, char*)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il\n");
			printf("                            primo argomento  una stringa vuota.\n");
		}

		else if(cont == 1)
		{
			printf("Test fallito: funzione testata:  leggiFile('\0', 10, char*)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il\n");
			printf("                            primo argomento  una stringa vuota, quindi\n");
			printf("                            quando apre il file ottiene un errore che\n");
			printf("                            non sa interpretare.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  leggiFile(NULL, 10, char*)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione leggiFile interpreta come argomento\n");
			printf("                            nullo una stringa vuota.\n");
		}

		else if(cont == 4)
		{
			printf("Test fallito: funzione testata:  leggiFile(NULL, 10, char*)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:FILE_MISSING\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il\n");
			printf("                            primo argomento  una stringa vuota, quindi\n");
			printf("                            quando apre il file apre un file che non\n");
			printf("                            c', decidendo che  quello l'errore.\n");
		}

		else if(cont == 5)
		{
			printf("Test fallito: funzione testata:  leggiFile(NULL, 10, char*)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:FILE_UNREADABLE\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il\n");
			printf("                            primo argomento  una stringa vuota, quindi\n");
			printf("                            quando apre il file ottiene un errore che\n");
			printf("                            interpreta come file non leggibile.\n");
		}

		else if(cont == 7)
		{
			printf("Test fallito: funzione testata:  leggiFile(NULL, 10, char*)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:FILE_EMPTY\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il\n");
			printf("                            primo argomento  una stringa vuota, quindi\n");
			printf("                            quando apre il file ottiene un errore che\n");
			printf("                            interpreta come file vuoto.\n");
		}

		else
		{
			printf("Test fallito: funzione testata:  leggiFile(NULL, 10, char*)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
	}
        
        else if (tipo_di_test == 4)
        {
                nomefile = "hfbgkayflaqwfn";
                cont = leggiFile(nomefile, dim, testo);
		
		if (cont == tipo_di_test) return (0);

		else if(cont == 0)
		{
			printf("Test fallito: funzione testata:  leggiFile('hfbgkayflaqwfn', 10, char*)\n");
			printf("              risultato atteso:  FILE_MISSING\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se la\n");
			printf("                            apertura del file da esito positivo o negativo\n");
			printf("                            n controlla se copia il testo della mail, bens\n");
			printf("                            torna sempre RESULT_OK.\n");
		}

		else if(cont == 1)
		{
			printf("Test fallito: funzione testata:  leggiFile('hfbgkayflaqwfn', 10, char*)\n");
			printf("              risultato atteso:  FILE_MISSING\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il\n");
			printf("                            il file esiste, quindi quando apre il file\n");
			printf("                            ottiene un errore che non sa interpretare.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  leggiFile('hfbgkayflaqwfn', 10, char*)\n");
			printf("              risultato atteso:  FILE_MISSING\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione leggiFile interpreta come argomento\n");
			printf("                            nullo il fatto che la funzione non riesca ad aprire\n");
			printf("                            il file.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  leggiFile('hfbgkayflaqwfn', 10, char*)\n");
			printf("              risultato atteso:  FILE_MISSING\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il file\n");
			printf("                            esiste, quindi quando apre il file apre un\n");
			printf("                            file che non esiste, decidendo che la\n");
			printf("                            stringa del suo nome deve essere vuota.\n");
			printf("                            Altrimenti potrebbe fare un controllo sulla\n");
			printf("                            sintassi della stringa completamente errato.\n");
		}

		else if(cont == 5)
		{
			printf("Test fallito: funzione testata:  leggiFile('hfbgkayflaqwfn', 10, char*)\n");
			printf("              risultato atteso:  FILE_MISSING\n");
			printf("              risultato ottenuto:FILE_UNREADABLE\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il\n");
			printf("                            file esiste, quindi quando apre il file\n");
			printf("                            e non ci riesce lo interpreta come file\n");
			printf("                            non leggibile.\n");
		}

		else if(cont == 7)
		{
			printf("Test fallito: funzione testata:  leggiFile('hfbgkayflaqwfn', 10, char*)\n");
			printf("              risultato atteso:  FILE_MISSING\n");
			printf("              risultato ottenuto:FILE_EMPTY\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il\n");
			printf("                            file esiste, o se riesce ad aprire il file,\n");
			printf("                            quindi quando non trova nulla nel buffer\n");
			printf("                            che deve contenere il corpo lo interpreta\n");
			printf("                            come file vuoto.\n");
		}

		else
		{
			printf("Test fallito: funzione testata:  leggiFile('hfbgkayflaqwfn', 10, char*)\n");
			printf("              risultato atteso:  FILE_MISSING\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }
        
        else if (tipo_di_test == 5)
        {
                return(4);
        }
        
        else if (tipo_di_test == 7)
        {
                prova[0] = '\0';
                putc(prova[i], in);

                fclose(in);
                nomefile = "mail1.txt";
                cont = leggiFile(nomefile, dim, testo);
		
  		if (cont == tipo_di_test) return (0);

		else if(cont == 0)
		{
			printf("Test fallito: funzione testata:  leggiFile('mail1.txt', 10, char*)\n");
			printf("              risultato atteso:  FILE_EMPTY\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se la\n");
			printf("                            copia del testo della mail va a buon fine\n");
			printf("                            o se il file  vuoto bens torna sempre\n");
			printf("                            RESULT_OK.\n");
		}

		else if(cont == 1)
		{
			printf("Test fallito: funzione testata:  leggiFile('mail1.txt', 10, char*)\n");
			printf("              risultato atteso:  FILE_EMPTY\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il\n");
			printf("                            il file  vuoto, quindi apre il file e\n");
			printf("                            non copia nulla nel buffer, anche se il file\n");
			printf("                            esiste, un errore che non sa interpretare.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  leggiFile('mail1.txt', 10, char*)\n");
			printf("              risultato atteso:  FILE_EMPTY\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione leggiFile interpreta come argomento\n");
			printf("                            nullo il fatto che il file sia vuoto.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  leggiFile('mail1.txt', 10, char*)\n");
			printf("              risultato atteso:  FILE_EMPTY\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il file\n");
			printf("                             vuoto, quindi quando apre il file non copia\n");
			printf("                            nulla nel buffer, lasciandolo vuoto e interpreta\n");
			printf("                            la mancata scrittura come stringa vuota invece di\n");
			printf("                            file vuoto.\n");
		}

		else if(cont == 4)
		{
			printf("Test fallito: funzione testata:  leggiFile('mail1.txt', 10, char*)\n");
			printf("              risultato atteso:  FILE_EMPTY\n");
			printf("              risultato ottenuto:FILE_MISSING\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il\n");
			printf("                            file  vuoto, quindi apre il file ma non\n");
			printf("                            riesce a copiare nulla nel buffer, quindi\n");
			printf("                            lo interpreta come file non esistente.\n");
		}

		else if(argomento == 5)
		{
			printf("Test fallito: funzione testata:  leggiFile('mail1.txt', 10, char*)\n");
			printf("              risultato atteso:  FILE_EMPTY\n");
			printf("              risultato ottenuto:FILE_UNREADABLE\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se il\n");
			printf("                            file  vuoto, o se riesce ad aprire il\n");
			printf("                            file, quindi quando non trova nulla nel \n");
			printf("                            buffer che deve contenere il corpo lo interpreta\n");
			printf("                            come file non leggibile.\n");
		}

		else
		{
			printf("Test fallito: funzione testata:  leggiFile('mail1.txt', 10, char*)\n");
			printf("              risultato atteso:  FILE_EMPTY\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
	}
        else return(3);
    }
    
    else if (argomento == 2)
    {
        testo = (char*)malloc(sizeof(char) * 10);
        if (tipo_di_test == 8)
        {
                prova = "From:casamia@tin.it\nTo:casatua@tin.it\n\nCiao,questa  casa mia\n\nCiao\0";
		while (prova[i] != '\0')
                {
				putc(prova[i], in);
                                i++;
                }
                fclose(in);
                nomefile = "mail1.txt";
                dim = 1;
                cont = leggiFile(nomefile, dim, testo);
		
		if (cont == tipo_di_test) return (0);

		else if(cont == 0)
		{
			printf("Test fallito: funzione testata:  leggiFile('mail1.txt', 1, char*)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione leggiFile non controlla se la\n");
			printf("                            copia del testo della mail va a buon fine\n");
			printf("                            quindi torna sempre RESULT_OK.\n");
		}

		else if(cont == 1)
		{
			printf("Test fallito: funzione testata:  leggiFile('mail1.txt', 1, char*)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione leggiFile vede che non\n");
			printf("                            riesce a copiare il testo e non sa\n");
			printf("                            perch, oppure scopre prima di uscire\n");
			printf("                            che il buffer di scrittura  vuoto\n");
			printf("                            e non ne capisce il motivo.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  leggiFile('mail1.txt', 1, char*)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione leggiFile interpreta come argomento\n");
			printf("                            nullo il fatto che non riesce a scrivere nulla\n");
			printf("                            nel buffer.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  leggiFile('mail1.txt', 1, char*)\n");
			printf("              risultato atteso:  bUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione leggiFile interpreta come stringan");
			printf("                            vuota il fatto che non riesce a scrivere nulla\n");
			printf("                            nel buffer.\n");
		}

		else if(cont == 4)
		{
			printf("Test fallito: funzione testata:  leggiFile('mail1.txt', 1, char*)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:FILE_MISSING\n");
			printf("	      spiegazione:  la funzione leggiFile apre il file ma non\n");
			printf("                            riesce a copiare nulla nel buffer, quindi\n");
			printf("                            lo interpreta come file non esistente.\n");
		}

		else if(cont == 5)
		{
			printf("Test fallito: funzione testata:  leggiFile('mail1.txt', 1, char*)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:FILE_UNREADABLE\n");
			printf("	      spiegazione:  la funzione leggiFile apre il file ma non\n");
			printf("                            riesce a copiare nulla nel buffer, quindi\n");
			printf("                            lo interpreta come file non leggibile.\n");
		}
		
		else if(cont == 7)
		{
			printf("Test fallito: funzione testata:  leggiFile('mail1.txt', 1, char*)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:FILE_EMPTY\n");
			printf("	      spiegazione:  la funzione leggiFile apre il file ma non\n");
			printf("                            riesce a copiare nulla nel buffer, quindi\n");
			printf("                            lo interpreta come file vuoto.\n");
		}

		else if(cont == 12)
		{
			printf("Test fallito: funzione testata:  leggiFile('mail1.txt', 1, char*)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:MEM_ALLOC_ERROR\n");
			printf("	      spiegazione:  la funzione leggiFile capisce che c' un\n");
			printf("                            problema nella memoria, ma confonde la\n");
			printf("                            decisione di assegnare un buffer piccolo\n");
			printf("                            con la mancata allocazione da parte del\n");
			printf("                            programma di memoria.\n");
		}

		else
		{
			printf("Test fallito: funzione testata:  leggiFile('mail1.txt', 1, b)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }
        else return(3);
    }
    
    else if (argomento == 3) return (3);
}

int test_estraiHeaders(int tipo_di_test, int argomento)
{
    char *testo; int cont; char *prova;
    int i, dim;

    if (argomento > 3) return (2);
    if (argomento == 0)
    {
        prova = "From:casamia@tin.it\nTo:casatua@tin.it\n\nCiao,questa  casa mia\n\nCiao\0";

        dim = 5000;
        testo = (char*)malloc(sizeof(char) * 5000);
        cont = estraiHeaders(prova, testo, dim);
	if (cont == 0)
	{
		prova = "From:casamia@tin.it\nTo:casatua@tin.it\0";
		if (strcmp(testo, prova) == 0) return (0);

		printf("Test fallito: funzione testata:  estraiHeaders(char* , char* #5000, 5000)\n");
		printf("              risultato atteso:  RESULT_OK\n");
		printf("              risultato ottenuto:RESULT_OK\n");
		printf("	      spiegazione:  il testo non  per quello che dovrebbe\n");
		printf("                            essere, tornando una stringa diversa, quindi\n");
		printf("                            l'estrazione degli headers non va a buon\n");
		printf("                            fine, ma la funzione torna sempre RESULT_OK.\n");
		return(1);
	}

    }
    
    if (argomento == 1)
    {
        dim = 10;
        testo = (char*)malloc(sizeof(char) * 1);
        
        if (tipo_di_test == 2)
        {
		prova = NULL;
                cont = estraiHeaders(prova, testo, dim);
		if (cont == tipo_di_test) return (0);
		else if (cont == 0)
		{
			printf("Test fallito: funzione testata:  estraiHeaders(NULL, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla se il\n");
			printf("                            primo argomento  un puntatore nullo.\n");
		}

		else if (cont == 1)
		{
			printf("Test fallito: funzione testata:  estraiHeaders(NULL, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non riesce a\n");
			printf("                            copiare il testo e non sa perch,\n");
			printf("                            oppure scopre prima di uscire che il\n");
			printf("                            buffer di scrittura  vuoto e non\n");
			printf("                            ne capisce il motivo.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  estraiHeaders(NULL, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione interpreta come stringa\n");
			printf("                            vuota un argomento nullo.\n");
		}

		else if(cont == 9)
		{
			printf("Test fallito: funzione testata:  estraiHeaders(NULL, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:HEADER_NOT_FOUND\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  un puntatore nullo, quindi\n");
			printf("                            quando cerca gli headers non li trova\n");
			printf("                            e interpreta che non ci sono.\n");
		}

		else if(cont == 11)
		{
			printf("Test fallito: funzione testata:  estraiHeaders(NULL, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:BAD_HEADER\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  un puntatore nullo, quindi\n");
			printf("                            quando cerca gli headers non li trova\n");
			printf("                            e interpreta che sono formattati male.\n");
		}
		
		else
		{
			printf("Test fallito: funzione testata:  estraiHeaders(NULL, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }
        
        else if (tipo_di_test == 3)
        {
                prova = (char*)malloc(sizeof(char)*1);
		prova[0] = '\0';
                cont = estraiHeaders(prova, testo, dim);
		
		if (cont == tipo_di_test) return (0);

		else if (cont == 0)
		{
			printf("Test fallito: funzione testata:  estraiHeaders('\\0', char*, 10)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla se il\n");
			printf("                            primo argomento  una stringa vuota.\n");
		}

		else if (cont == 1)
		{
			printf("Test fallito: funzione testata:  estraiHeaders('\\0', char*, 10)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non riesce a\n");
			printf("                            copiare il testo e non sa perch,\n");
			printf("                            oppure scopre prima di uscire che il\n");
			printf("                            buffer di scrittura  vuoto e non\n");
			printf("                            ne capisce il motivo.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  estraiHeaders('\\0', char*, 10)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione interpreta argomento nullo\n");
			printf("                            una stringa vuota.\n");
		}

		else if(cont == 9)
		{
			printf("Test fallito: funzione testata:  estraiHeaders('\\0', char*, 10)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:HEADER_NOT_FOUND\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  una stringa vuota, quindi\n");
			printf("                            quando cerca gli headers non li trova\n");
			printf("                            e interpreta che non ci sono.\n");
		}

		else if(cont == 11)
		{
			printf("Test fallito: funzione testata:  estraiHeaders('\\0', char*, 10)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:BAD_HEADER\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  una stringa vuota, quindi\n");
			printf("                            quando cerca gli headers non li trova\n");
			printf("                            e interpreta che sono formattati male.\n");
		}
		else
		{
			printf("Test fallito: funzione testata:  estraiHeaders('\\0', char*, 10)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }

        else if (tipo_di_test == 9)
	{
		prova = (char*)malloc(sizeof(char)* 5);
		prova[0] = '\n';
		prova[1] = '\r';
		prova[2] = 'a';
		prova[3] = 'b';
		prova[4] = '\0';

		cont = estraiHeaders(prova, testo, 10);

		if (cont == tipo_di_test) return (0);

		else if (cont == 0)
		{
			printf("Test fallito: funzione testata:  estraiHeaders('\\n\\rab', char*, 10)\n");
			printf("              risultato atteso:  HEADER_NOT_FOUND\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla presenza\n");
			printf("                            di header e di eventuali errori, bens\n");
			printf("                            torna sempre RESULT_OK\n");
		}

		else if (cont == 1)
		{
			printf("Test fallito: funzione testata:  estraiHeaders('\\n\\rab', char*, 10)\n");
			printf("              risultato atteso:  HEADER_NOT_FOUND\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non riesce a\n");
			printf("                            copiare il testo e non sa perch,\n");
			printf("                            oppure scopre prima di uscire che il\n");
			printf("                            buffer di scrittura  vuoto e non\n");
			printf("                            ne capisce il motivo.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  estraiHeaders('\\n\\rab', char*, 10)\n");
			printf("              risultato atteso:  HEADER_NOT_FOUND\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione interpreta argomento nullo\n");
			printf("                            il fatto di non trovare l'header.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  estraiHeaders('\\n\\rab', char*, 10)\n");
			printf("              risultato atteso:  HEADER_NOT_FOUND\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  valido, quindi non trovando\n");
			printf("                            gli headers interpreta la stringa  vuota.\n");
		}

		else if(cont == 11)
		{
			printf("Test fallito: funzione testata:  estraiHeaders('\\n\\rab', char*, 10)\n");
			printf("              risultato atteso:  HEADER_NOT_FOUND\n");
			printf("              risultato ottenuto:BAD_HEADER\n");
			printf("	      spiegazione:  la funzione non sa distinguere la\n");
			printf("                            differenza tra la mancanza di headers\n");
			printf("                            e la presenza di un headers scritto male\n");
		}
		else
		{
			printf("Test fallito: funzione testata:  estraiHeaders('\\n\\rab', char*, 10)\n");
			printf("              risultato atteso:  HEADER_NOT_FOUND\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);

	}

	else if (tipo_di_test == 11)
        {
                prova = (char*)malloc(sizeof(char)*3);
		prova[0] = ' ';
		prova[1] = 's';
		prova[2] = '\0';
                cont = estraiHeaders(prova, testo, dim);

		if (cont == tipo_di_test) return (0);

		else if (cont == 0)
		{
			printf("Test fallito: funzione testata:  estraiHeaders(' s', char*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla presenza\n");
			printf("                            di header e di eventuali errori, bens\n");
			printf("                            torna sempre RESULT_OK\n");
		}

		else if (cont == 1)
		{
			printf("Test fallito: funzione testata:  estraiHeaders(' s', char*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non riesce a\n");
			printf("                            copiare il testo e non sa perch,\n");
			printf("                            oppure scopre prima di uscire che il\n");
			printf("                            buffer di scrittura  vuoto e non\n");
			printf("                            ne capisce il motivo.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  estraiHeaders(' s', char*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione interpreta argomento nullo\n");
			printf("                            il fatto di non trovare l'header.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  estraiHeaders(' s', char*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  valido, quindi non trovando\n");
			printf("                            gli headers interpreta la stringa  vuota.\n");
		}

		else if(cont == 11)
		{
			printf("Test fallito: funzione testata:  estraiHeaders(' s', char*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:HEADER_NOT_FOUND\n");
			printf("	      spiegazione:  la funzione non sa distinguere la\n");
			printf("                            differenza tra la mancanza di headers\n");
			printf("                            e la presenza di un headers scritto male\n");
		}
		else
		{
			printf("Test fallito: funzione testata:  estraiHeaders(' s', char*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }

        else return(3);
    }

    else if (argomento == 3)
    {
        testo = (char*)malloc(sizeof(char) * 10);
        if (tipo_di_test == 8)
        {
                prova = "From:casamia@tin.it\nTo:casatua@tin.it\n\nCiao,questa  casa mia\n\nCiao\0";

                dim = 1;
                cont = estraiHeaders(prova, testo, dim);

		if (cont == tipo_di_test) return (0);

		else if(cont == 0)
		{
			printf("Test fallito: funzione testata:  estraHeaders(char*, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla se la\n");
			printf("                            copia del testo della mail va a buon fine\n");
			printf("                            quindi torna sempre RESULT_OK.\n");
		}

		else if(cont == 1)
		{
			printf("Test fallito: funzione testata:  estraHeaders(char*, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non\n");
			printf("                            riesce a copiare il testo e non sa\n");
			printf("                            perch, oppure scopre prima di uscire\n");
			printf("                            che il buffer di scrittura  vuoto\n");
			printf("                            e non ne capisce il motivo.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  estraHeaders(char*, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione interpreta come argomento\n");
			printf("                            nullo il fatto che non riesce a scrivere nulla\n");
			printf("                            nel buffer.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  estraHeaders(char*, char*, 1)\n");
			printf("              risultato atteso:  bUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione interpreta come stringa\n");
			printf("                            vuota il fatto che non riesce a scrivere nulla\n");
			printf("                            nel buffer.\n");
		}

		else if(cont == 9)
		{
			printf("Test fallito: funzione testata:  estraHeaders(char*, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:HEADER_NOT_FOUND\n");
			printf("	      spiegazione:  la funzione prende la stringa ma non\n");
			printf("                            riesce a copiare nulla nel buffer, quindi\n");
			printf("                            lo trova vuoto e pensa che non c' header.\n");
		}

		else if(cont == 11)
		{
			printf("Test fallito: funzione testata:  estraHeaders(char*, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:BAD_HEADER\n");
			printf("	      spiegazione:  la funzione prende la stringa ma non\n");
			printf("                            riesce a copiare nulla nel buffer, quindi\n");
			printf("                            lo trova vuoto e pensa ad un errore negli headers.\n");
		}

		else
		{
			printf("Test fallito: funzione testata:  estraHeaders(char*, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }
        else return(3);
    }

    else if (argomento == 2)
    {
    	return(3);
    }

    if (cont == tipo_di_test) return (0);

}

int test_primoHeader(int tipo_di_test, int argomento)
{
    char *testo; int cont; char *prova;char a = '\0';
    int i, dim;

    if (argomento > 3) return (2);
    if (argomento == 0)
    {
        prova = "From:casamia@tin.it\nTo:casatua@tin.it\0";
        
        dim = 500;
        testo = (char*)malloc(sizeof(char) * 500);
        cont = primoHeader(prova, testo, dim);
	
	if (cont == 0)
	{
		prova = "From:casamia@tin.it\0";
		if (strcmp(testo, prova) == 0) return (0);

		printf("Test fallito: funzione testata:  primoHeaders(char* , char* #5000, 5000)\n");
		printf("              risultato atteso:  RESULT_OK\n");
		printf("              risultato ottenuto:RESULT_OK\n");
		printf("	      spiegazione:  il testo non  per quello che dovrebbe\n");
		printf("                            essere, tornando una stringa diversa, quindi\n");
		printf("                            l'estrazione del primo header non va a buon\n");
		printf("                            fine, ma la funzione torna sempre RESULT_OK.\n");
		return(1);
	}

    }
    
    if (argomento == 1)
    {
        dim = 10;
        testo = (char*)malloc(sizeof(char) * 1);
        
        if (tipo_di_test == 2)
        {
                prova = NULL;
                cont = primoHeader(prova, testo, dim);
		
		if (cont == tipo_di_test) return (0);

		else if (cont == 0)
		{
			printf("Test fallito: funzione testata:  primoHeader(NULL, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla se il\n");
			printf("                            primo argomento  un puntatore nullo.\n");
		}

		else if (cont == 1)
		{
			printf("Test fallito: funzione testata:  primoHeader(NULL, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non riesce a\n");
			printf("                            copiare il testo e non sa perch,\n");
			printf("                            oppure scopre prima di uscire che il\n");
			printf("                            buffer di scrittura  vuoto e non\n");
			printf("                            ne capisce il motivo.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  primoHeader(NULL, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione interpreta come stringa\n");
			printf("                            vuota un argomento nullo.\n");
		}

		else if(cont == 9)
		{
			printf("Test fallito: funzione testata:  primoHeader(NULL, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:HEADER_NOT_FOUND\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  un puntatore nullo, quindi\n");
			printf("                            quando cerca gli headers non li trova\n");
			printf("                            e interpreta che non ci sono.\n");
		}

		else if(cont == 11)
		{
			printf("Test fallito: funzione testata:  primoHeader(NULL, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:BAD_HEADER\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  un puntatore nullo, quindi\n");
			printf("                            quando cerca gli headers non li trova\n");
			printf("                            e interpreta che sono formattati male.\n");
		}
		else
		{
			printf("Test fallito: funzione testata:  primoHeader(NULL, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }

        else if (tipo_di_test == 3)
        {
                prova = (char*)malloc(sizeof(char)*1);
		prova[0] = '\0';
                cont = primoHeader(prova, testo, dim);

		if (cont == tipo_di_test) return (0);

		else if (cont == 0)
		{
			printf("Test fallito: funzione testata:  primoHeader('\\0', char*, 10)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla se il\n");
			printf("                            primo argomento  una stringa vuota.\n");
		}

		else if (cont == 1)
		{
			printf("Test fallito: funzione testata:  primoHeader('\\0', char*, 10)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non riesce a\n");
			printf("                            copiare il testo e non sa perch,\n");
			printf("                            oppure scopre prima di uscire che il\n");
			printf("                            buffer di scrittura  vuoto e non\n");
			printf("                            ne capisce il motivo.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  primoHeader('\\0', char*, 10)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione interpreta argomento nullo\n");
			printf("                            una stringa vuota.\n");
		}

		else if(cont == 9)
		{
			printf("Test fallito: funzione testata:  primoHeader('\\0', char*, 10)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:HEADER_NOT_FOUND\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  una stringa vuota, quindi\n");
			printf("                            quando cerca gli headers non li trova\n");
			printf("                            e interpreta che non ci sono.\n");
		}

		else if(cont == 11)
		{
			printf("Test fallito: funzione testata:  primoHeader('\\0', char*, 10)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:BAD_HEADER\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  una stringa vuota, quindi\n");
			printf("                            quando cerca gli headers non li trova\n");
			printf("                            e interpreta che sono formattati male.\n");
		}
		else
		{
			printf("Test fallito: funzione testata:  primoHeader('\\0', char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }



        else if (tipo_di_test == 11)
        {
                prova = (char*)malloc(sizeof(char)*3);
		prova[0] = ' ';
		prova[1] = 's';
		prova[2] = '\0';
                cont = primoHeader(prova, testo, dim);

		if (cont == tipo_di_test) return (0);

		else if (cont == 0)
		{
			printf("Test fallito: funzione testata:  primoHeader(' s', char*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla presenza\n");
			printf("                            di header e di eventuali errori, bens\n");
			printf("                            torna sempre RESULT_OK\n");
		}

		else if (cont == 1)
		{
			printf("Test fallito: funzione testata:  primoHeader(' s', char*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non riesce a\n");
			printf("                            copiare il testo e non sa perch,\n");
			printf("                            oppure scopre prima di uscire che il\n");
			printf("                            buffer di scrittura  vuoto e non\n");
			printf("                            ne capisce il motivo.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  primoHeader(' s', char*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione interpreta argomento nullo\n");
			printf("                            il fatto di non trovare l'header.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  primoHeader(' s', char*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  valido, quindi non trovando\n");
			printf("                            gli headers interpreta la stringa  vuota.\n");
		}

		else if(cont == 11)
		{
			printf("Test fallito: funzione testata:  primoHeader(' s', char*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:HEADER_NOT_FOUND\n");
			printf("	      spiegazione:  la funzione non sa distinguere la\n");
			printf("                            differenza tra la mancanza di headers\n");
			printf("                            e la presenza di un headers scritto male\n");
		}
		else
		{
			printf("Test fallito: funzione testata:  primoHeader(' s', char*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }

        else return(3);
    }

    else if (argomento == 3)
    {
        testo = (char*)malloc(sizeof(char) * 10);
        if (tipo_di_test == 8)
        {
                prova = "From:casamia@tin.it\nTo:casatua@tin.it\0";

                dim = 1;
                cont = primoHeader(prova, testo, dim);
		
		if (cont == tipo_di_test) return (0);

		else if(cont == 0)
		{
			printf("Test fallito: funzione testata:  primoHeader(char*, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla se la\n");
			printf("                            copia del testo della mail va a buon fine\n");
			printf("                            quindi torna sempre RESULT_OK.\n");
		}

		else if(cont == 1)
		{
			printf("Test fallito: funzione testata:  primoHeader(char*, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non\n");
			printf("                            riesce a copiare il testo e non sa\n");
			printf("                            perch, oppure scopre prima di uscire\n");
			printf("                            che il buffer di scrittura  vuoto\n");
			printf("                            e non ne capisce il motivo.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  primoHeader(char*, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione interpreta come argomento\n");
			printf("                            nullo il fatto che non riesce a scrivere nulla\n");
			printf("                            nel buffer.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  primoHeader(char*, char*, 1)\n");
			printf("              risultato atteso:  bUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione interpreta come stringa\n");
			printf("                            vuota il fatto che non riesce a scrivere nulla\n");
			printf("                            nel buffer.\n");
		}

		else if(cont == 9)
		{
			printf("Test fallito: funzione testata:  primoHeader(char*, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:HEADER_NOT_FOUND\n");
			printf("	      spiegazione:  la funzione prende la stringa ma non\n");
			printf("                            riesce a copiare nulla nel buffer, quindi\n");
			printf("                            lo trova vuoto e pensa che non c' header.\n");
		}

		else if(cont == 11)
		{
			printf("Test fallito: funzione testata:  primoHeader(char*, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:BAD_HEADER\n");
			printf("	      spiegazione:  la funzione prende la stringa ma non\n");
			printf("                            riesce a copiare nulla nel buffer, quindi\n");
			printf("                            lo trova vuoto e pensa ad un errore negli headers.\n");
		}

		else
		{
			printf("Test fallito: funzione testata:  primoHeader(char*, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }
        else return(3);
    }

    else if (argomento == 2)
    {
        return (3);
    }

    if (cont == tipo_di_test) return (0);
}

int test_parseHeader(int tipo_di_test, int argomento)
{
    char *testo; int cont; char *prova; char *tipo;char *prova2;
    int i, dim;
    
    if (argomento > 5) return (2);
    if (argomento == 0)
    {
        prova = "From:casamia@tin.it\0";

        dim = 500;
        testo = (char*)malloc(sizeof(char) * 500);
	tipo = (char*)malloc(sizeof(char) * 500);
        cont = parseHeader(prova, tipo, dim, testo, dim);
	
	if (cont == 0)
	{
		prova = "From:\0";
		prova2 = "casamia@tin.it\0";
		if (strcmp(tipo, prova) == 0)
		{
			if (strcmp(testo, prova2) == 0) return (0);
		}

		printf("Test fallito: funzione testata:  parseHeader(char* , char* , 500, char*, 500)\n");
		printf("              risultato atteso:  RESULT_OK\n");
		printf("              risultato ottenuto:RESULT_OK\n");
		printf("	      spiegazione:  il testo non  per quello che dovrebbe\n");
		printf("                            essere, tornando una stringa diversa, quindi\n");
		printf("                            la divisione dell'header non va a buon\n");
		printf("                            fine, ma la funzione torna sempre RESULT_OK.\n");
		return(1);
	}
    }

    if (argomento == 1)
    {
        dim = 10;
        testo = (char*)malloc(sizeof(char) * 1);
	tipo = (char*)malloc(sizeof(char) * 500);

        if (tipo_di_test == 2)
        {
                prova = NULL;
                cont = parseHeader(prova, tipo, dim, testo, dim);

		if (cont == tipo_di_test) return (0);

		else if (cont == 0)
		{
			printf("Test fallito: funzione testata:  parseHeader(NULL, char*, 10, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla se il\n");
			printf("                            primo argomento  un puntatore nullo.\n");
		}

		else if (cont == 1)
		{
			printf("Test fallito: funzione testata:  parseHeader(NULL, char*, 10, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non riesce a\n");
			printf("                            copiare il testo e non sa perch,\n");
			printf("                            oppure scopre prima di uscire che il\n");
			printf("                            buffer di scrittura  vuoto e non\n");
			printf("                            ne capisce il motivo.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  parseHeader(NULL, char*, 10, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione interpreta come stringa\n");
			printf("                            vuota un argomento nullo.\n");
		}

		else if(cont == 9)
		{
			printf("Test fallito: funzione testata:  parseHeader(NULL, char*, 10, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:HEADER_NOT_FOUND\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  un puntatore nullo, quindi\n");
			printf("                            quando cerca gli headers non li trova\n");
			printf("                            e interpreta che non ci sono.\n");
		}

		else if(cont == 11)
		{
			printf("Test fallito: funzione testata:  parseHeader(NULL, char*, 10, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:BAD_HEADER\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  un puntatore nullo, quindi\n");
			printf("                            quando cerca gli headers non li trova\n");
			printf("                            e interpreta che sono formattati male.\n");
		}
		else
		{
			printf("Test fallito: funzione testata:  parseHeader(NULL, char*, 10, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }

        else return(3);
    }

    else if ((argomento == 3) || (argomento == 5))
    {
        testo = (char*)malloc(sizeof(char) * 10);
        if (tipo_di_test == 8)
        {
                prova = "From:casamia@tin.it\0";
		tipo = (char*)malloc(sizeof(char) * 500);

                dim = 1;
                cont = parseHeader(prova, tipo, dim, testo, dim);
		
		if (cont == tipo_di_test) return (0);

		else if(cont == 0)
		{
			printf("Test fallito: funzione testata:  parseHeader(char*, char*, 1, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla se la\n");
			printf("                            copia del testo della mail va a buon fine\n");
			printf("                            quindi torna sempre RESULT_OK.\n");
		}

		else if(cont == 1)
		{
			printf("Test fallito: funzione testata:  parseHeader(char*, char*, 1, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non\n");
			printf("                            riesce a copiare il testo e non sa\n");
			printf("                            perch, oppure scopre prima di uscire\n");
			printf("                            che il buffer di scrittura  vuoto\n");
			printf("                            e non ne capisce il motivo.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  parseHeader(char*, char*, 1, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione interpreta come argomento\n");
			printf("                            nullo il fatto che non riesce a scrivere nulla\n");
			printf("                            nel buffer.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  parseHeader(char*, char*, 1, char*, 1)\n");
			printf("              risultato atteso:  bUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione interpreta come stringa\n");
			printf("                            vuota il fatto che non riesce a scrivere nulla\n");
			printf("                            nel buffer.\n");
		}

		else if(cont == 9)
		{
			printf("Test fallito: funzione testata:  parseHeader(char*, char*, 1, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:HEADER_NOT_FOUND\n");
			printf("	      spiegazione:  la funzione prende la stringa ma non\n");
			printf("                            riesce a copiare nulla nel buffer, quindi\n");
			printf("                            lo trova vuoto e pensa che non c' header.\n");
		}

		else if(cont == 11)
		{
			printf("Test fallito: funzione testata:  parseHeader(char*, char*, 1, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:BAD_HEADER\n");
			printf("	      spiegazione:  la funzione prende la stringa ma non\n");
			printf("                            riesce a copiare nulla nel buffer, quindi\n");
			printf("                            lo trova vuoto e pensa ad un errore negli headers.\n");
		}

		else
		{
			printf("Test fallito: funzione testata:  parseHeader(char*, char*, 1, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);

        }
        else return(3);
    }
    
    else if ((argomento == 2) || (argomento == 4))
    {
        return (3);
    }

    if (cont == tipo_di_test) return (0);
}

int test_primaParola(int tipo_di_test, int argomento)
{
    char *testo; int cont; char *prova;
    int i, dim;
    
    if (argomento > 3) return (2);
    if (argomento == 0)
    {
        prova = "#@@casa#+12\0";
        
        dim = 500;
        testo = (char*)malloc(sizeof(char) * 500);
        cont = primaParola(prova, testo, dim);
	
	if (cont == 0)
	{
		prova = "casa\0";
		if (strcmp(testo, prova) == 0) return (0);

		printf("Test fallito: funzione testata:  primaParola(char* , char* , 500)\n");
		printf("              risultato atteso:  RESULT_OK\n");
		printf("              risultato ottenuto:RESULT_OK\n");
		printf("	      spiegazione:  il testo non  per quello che dovrebbe\n");
		printf("                            essere, tornando una stringa diversa, quindi\n");
		printf("                            l'estrazione della prima parola non va a buon\n");
		printf("                            fine, ma la funzione torna sempre RESULT_OK.\n");
		return(1);
	}

    }
    
    if (argomento == 1)
    {
        dim = 10;
        testo = (char*)malloc(sizeof(char) * 1);
        
        if (tipo_di_test == 2)
        {
                prova = NULL;
                cont = primaParola(prova, testo, dim);
		
		if (cont == tipo_di_test) return (0);

		else if (cont == 0)
		{
			printf("Test fallito: funzione testata:  primaParola(NULL, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla se il\n");
			printf("                            primo argomento  un puntatore nullo.\n");
		}

		else if (cont == 1)
		{
			printf("Test fallito: funzione testata:  primaParola(NULL, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non riesce a\n");
			printf("                            copiare il testo e non sa perch,\n");
			printf("                            oppure scopre prima di uscire che il\n");
			printf("                            buffer di scrittura  vuoto e non\n");
			printf("                            ne capisce il motivo.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  primaParola(NULL, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione interpreta come stringa\n");
			printf("                            vuota un argomento nullo.\n");
		}


		else
		{
			printf("Test fallito: funzione testata:  primaParola(NULL, char*, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }

        else if (tipo_di_test == 3)
        {
                prova = (char*)malloc(sizeof(char)*1);
		prova[0] = '\0';
                cont = primaParola(prova, testo, dim);
        }
        
        else return(3);
    }

    else if (argomento == 3)
    {
        testo = (char*)malloc(sizeof(char) * 10);
        if (tipo_di_test == 8)
        {
                prova = "#@@casa#+12\0";
            
                dim = 1;
                cont = primaParola(prova, testo, dim);
		
		if (cont == tipo_di_test) return (0);

		else if(cont == 0)
		{
			printf("Test fallito: funzione testata:  primaParola(char*, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla se la\n");
			printf("                            copia del testo va a buon fine\n");
			printf("                            quindi torna sempre RESULT_OK.\n");
		}

		else if(cont == 1)
		{
			printf("Test fallito: funzione testata:  primaParola(char*, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non\n");
			printf("                            riesce a copiare il testo e non sa\n");
			printf("                            perch, oppure scopre prima di uscire\n");
			printf("                            che il buffer di scrittura  vuoto\n");
			printf("                            e non ne capisce il motivo.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  primaParola(char*, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione interpreta come argomento\n");
			printf("                            nullo il fatto che non riesce a scrivere nulla\n");
			printf("                            nel buffer.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  primaParola(char*, char*, 1)\n");
			printf("              risultato atteso:  bUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione interpreta come stringa\n");
			printf("                            vuota il fatto che non riesce a scrivere nulla\n");
			printf("                            nel buffer.\n");
		}

		else
		{
			printf("Test fallito: funzione testata:  primaParola(char*, char*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }
        else return(3);
    }

    if (argomento == 2) return (3);

    if (cont == tipo_di_test) return (0);

}

int test_tokenizzaEmail(int tipo_di_test, int argomento)
{
    int cont; char *prova;int esc = 0;
    int i, dim; Token *testo;Token pippo;

    if (argomento > 3) return (2);
    if (argomento == 0)
    {
        prova = "From:casamia@tin.it\nTo:casatua@tin.it\n\nCiao,questa  casa mia\n\nCiao\0";

        dim = 5000;
        testo = (Token*)malloc(sizeof(Token) * 20);
	for(i = 0; i < 9; i++)
	{
		testo[0].contesto = (char*)malloc(sizeof(char) * 10);
		testo[0].parola = (char*)malloc(sizeof(char) * 10);
	}
	cont = tokenizzaEmail(prova, testo, dim);

    }

    if (argomento == 1)
    {
        dim = 10;

        if (tipo_di_test == 2)
        {
                prova = NULL;
                cont = tokenizzaEmail(prova, testo, dim);
		
		if (cont == tipo_di_test) return (0);

		else if (cont == 0)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(NULL, Token*, 500)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla se il\n");
			printf("                            primo argomento  un puntatore nullo.\n");
		}

		else if (cont == 1)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(NULL, Token*, 500)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non riesce a\n");
			printf("                            copiare il testo e non sa perch,\n");
			printf("                            oppure scopre prima di uscire che il\n");
			printf("                            buffer di scrittura  vuoto e non\n");
			printf("                            ne capisce il motivo.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(NULL, Token*, 500)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione interpreta come stringa\n");
			printf("                            vuota un argomento nullo.\n");
		}

		else if(cont == 9)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(NULL, Token*, 500)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:HEADER_NOT_FOUND\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  un puntatore nullo, quindi\n");
			printf("                            quando cerca gli headers non li trova\n");
			printf("                            e interpreta che non ci sono.\n");
		}

		else if(cont == 11)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(NULL, Token*, 500)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:BAD_HEADER\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  un puntatore nullo, quindi\n");
			printf("                            quando cerca gli headers non li trova\n");
			printf("                            e interpreta che sono formattati male.\n");
		}
		else
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(NULL, Token*, 500)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }

        else if (tipo_di_test == 3)
        {
                prova = (char*)malloc(sizeof(char)*1);
		prova[0] = '\0';
                cont = tokenizzaEmail(prova, testo, dim);

		if (cont == tipo_di_test) return (0);

		else if (cont == 0)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(char*, Token*, 500)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla se il\n");
			printf("                            primo argomento  una stringa vuota.\n");
		}

		else if (cont == 1)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(char*, Token*, 500)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non riesce a\n");
			printf("                            copiare il testo e non sa perch,\n");
			printf("                            oppure scopre prima di uscire che il\n");
			printf("                            buffer di scrittura  vuoto e non\n");
			printf("                            ne capisce il motivo.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(char*, Token*, 500)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione interpreta argomento nullo\n");
			printf("                            una stringa vuota.\n");
		}

		else if(cont == 9)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(char*, Token*, 500)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:HEADER_NOT_FOUND\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  una stringa vuota, quindi\n");
			printf("                            quando cerca gli headers non li trova\n");
			printf("                            e interpreta che non ci sono.\n");
		}

		else if(cont == 11)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(char*, Token*, 500)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:BAD_HEADER\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  una stringa vuota, quindi\n");
			printf("                            quando cerca gli headers non li trova\n");
			printf("                            e interpreta che sono formattati male.\n");
		}
		else
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(char*, Token*, 500)\n");
			printf("              risultato atteso:  EMPTY_STRING\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }
        
        else if (tipo_di_test == 9)
        {
                prova = (char*)malloc(sizeof(char)*5);
		prova[0] = '\n';
		prova[1] = '\r';
		prova[2] = '\a';
		prova[3] = '\b';
		prova[4] = '\0';
                cont = tokenizzaEmail(prova, testo, dim);
		
		if (cont == tipo_di_test) return (0);

		else if (cont == 0)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail('\\n\\rab', Token*, 500)\n");
			printf("              risultato atteso:  HEADER_NOT_FOUND\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla presenza\n");
			printf("                            di header e di eventuali errori, bens\n");
			printf("                            torna sempre RESULT_OK\n");
		}

		else if (cont == 1)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail('\\n\\rab', Token*, 500)\n");
			printf("              risultato atteso:  HEADER_NOT_FOUND\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non riesce a\n");
			printf("                            copiare il testo e non sa perch,\n");
			printf("                            oppure scopre prima di uscire che il\n");
			printf("                            buffer di scrittura  vuoto e non\n");
			printf("                            ne capisce il motivo.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail('\\n\\rab', Token*, 500)\n");
			printf("              risultato atteso:  HEADER_NOT_FOUND\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione interpreta argomento nullo\n");
			printf("                            il fatto di non trovare l'header.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail('\\n\\rab', Token*, 500)\n");
			printf("              risultato atteso:  HEADER_NOT_FOUND\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  valido, quindi non trovando\n");
			printf("                            gli headers interpreta la stringa  vuota.\n");
		}

		else if(cont == 11)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail('\\n\\rab', Token*, 500)\n");
			printf("              risultato atteso:  HEADER_NOT_FOUND\n");
			printf("              risultato ottenuto:BAD_HEADER\n");
			printf("	      spiegazione:  la funzione non sa distinguere la\n");
			printf("                            differenza tra la mancanza di headers\n");
			printf("                            e la presenza di un headers scritto male\n");
		}
		else
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail('\\n\\rab', Token*, 500)\n");
			printf("              risultato atteso:  HEADER_NOT_FOUND\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);


        }
        
        else if (tipo_di_test == 10)
        {
                //prova = (char*)malloc(sizeof(char)*1);
		prova = "From:casamia@tin.it";
                cont = tokenizzaEmail(prova, testo, dim);
		
		if (cont == tipo_di_test) return (0);

		else if (cont == 0)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail('From:casamia@tin.it', Token*, 500)\n");
			printf("              risultato atteso:  BODY_NOT_FOUND\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla presenza\n");
			printf("                            del corpo o di eventuali errori, bens\n");
			printf("                            torna sempre RESULT_OK\n");
		}

		else if (cont == 1)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail('From:casamia@tin.it', Token*, 500)\n");
			printf("              risultato atteso:  BODY_NOT_FOUND\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non riesce a\n");
			printf("                            copiare il corpo e non sa perch,\n");
			printf("                            oppure non trova ci che si aspetta\n");
			printf("                            e non ne capisce il motivo.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail('From:casamia@tin.it', Token*, 500)\n");
			printf("              risultato atteso:  BODY_NOT_FOUND\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione interpreta argomento nullo\n");
			printf("                            il fatto di non trovare il corpo.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail('From:casamia@tin.it', Token*, 500)\n");
			printf("              risultato atteso:  BODY_NOT_FOUND\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione non controlla se esiste il\n");
			printf("                            corpo, quindi non trovandolo successivamente\n");
			printf("                            interpreta la stringa  vuota.\n");
		}

		else if(cont == 9)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail('From:casamia@tin.it', Token*, 500)\n");
			printf("              risultato atteso:  BODY_NOT_FOUND\n");
			printf("              risultato ottenuto:HEADER_NOT_FOUND\n");
			printf("	      spiegazione:  la funzione invece di capire l'assenza\n");
			printf("                            del corpo interpreta come se ci fosse un\n");
			printf("                            problema nella mail, decidendo che  la\n");
			printf("                            assenza degli header\n");
		}
		else if(cont == 9)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail('From:casamia@tin.it', Token*, 500)\n");
			printf("              risultato atteso:  BODY_NOT_FOUND\n");
			printf("              risultato ottenuto:BED_HEADER\n");
			printf("	      spiegazione:  la funzione invece di capire l'assenza\n");
			printf("                            del corpo interpreta come se ci fosse un\n");
			printf("                            errore nella scrittura degli headers\n");
		}
		else
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail('From:casamia@tin.it', Token*, 500)\n");
			printf("              risultato atteso:  BODY_NOT_FOUND\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }

	else if (tipo_di_test == 11)
        {
                prova = (char*)malloc(sizeof(char)*3);
		prova[0] = ' ';
		prova[1] = 's';
		prova[2] = '\0';
                cont = tokenizzaEmail(prova, testo, dim);
		
		if (cont == tipo_di_test) return (0);

		else if (cont == 0)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(' s', Token*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla presenza\n");
			printf("                            di header e di eventuali errori, bens\n");
			printf("                            torna sempre RESULT_OK\n");
		}

		else if (cont == 1)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(' s', Token*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non riesce a\n");
			printf("                            copiare il testo e non sa perch,\n");
			printf("                            oppure scopre prima di uscire che il\n");
			printf("                            buffer di scrittura  vuoto e non\n");
			printf("                            ne capisce il motivo.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(' s', Token*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione interpreta argomento nullo\n");
			printf("                            il fatto di non trovare l'header.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(' s', Token*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione non controlla se il primo\n");
			printf("                            argomento  valido, quindi non trovando\n");
			printf("                            gli headers interpreta la stringa  vuota.\n");
		}

		else if(cont == 11)
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(' s', Token*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:HEADER_NOT_FOUND\n");
			printf("	      spiegazione:  la funzione non sa distinguere la\n");
			printf("                            differenza tra la mancanza di headers\n");
			printf("                            e la presenza di un headers scritto male\n");
		}
		else
		{
			printf("Test fallito: funzione testata:  tokenizzaEmail(' s', Token*, 10)\n");
			printf("              risultato atteso:  BED_HEADER\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }

        else return(3);
    }
    
    else if (argomento == 3)
    {
        if (tipo_di_test == 8)
        {
                prova = "From:casamia@tin.it\nTo:casatua@tin.it\n\nCiao,questa  casa mia\n\nCiao\0";
            
                dim = 1;
                cont = tokenizzaEmail(prova, testo, dim);
		
		if(cont == 0)
		{
			printf("Test fallito: funzione testata:  tokenArray(char*, Token*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla se la\n");
			printf("                            copia del testo della mail va a buon fine\n");
			printf("                            quindi torna sempre RESULT_OK.\n");
		}

		else if(cont == 1)
		{
			printf("Test fallito: funzione testata:  tokenArray(char*, Token*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non\n");
			printf("                            riesce a copiare il testo e non sa\n");
			printf("                            perch, oppure scopre prima di uscire\n");
			printf("                            che il buffer di scrittura  vuoto\n");
			printf("                            e non ne capisce il motivo.\n");
		}

		else if(cont == 2)
		{
			printf("Test fallito: funzione testata:  tokenArray(char*, Token*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:NULL_POINTER\n");
			printf("	      spiegazione:  la funzione interpreta come argomento\n");
			printf("                            nullo il fatto che non riesce a scrivere nulla\n");
			printf("                            nel buffer.\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  tokenArray(char*, Token*, 1)\n");
			printf("              risultato atteso:  bUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione interpreta come stringa\n");
			printf("                            vuota il fatto che non riesce a scrivere nulla\n");
			printf("                            nel buffer.\n");
		}

		else if(cont == 9)
		{
			printf("Test fallito: funzione testata:  tokenArray(char*, Token*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:HEADER_NOT_FOUND\n");
			printf("	      spiegazione:  la funzione prende la stringa ma non\n");
			printf("                            riesce a copiare nulla nel buffer, quindi\n");
			printf("                            lo trova vuoto e pensa che non c' header.\n");
		}

		else if(cont == 11)
		{
			printf("Test fallito: funzione testata:  tokenArray(char*, Token*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:BAD_HEADER\n");
			printf("	      spiegazione:  la funzione prende la stringa ma non\n");
			printf("                            riesce a copiare nulla nel buffer, quindi\n");
			printf("                            lo trova vuoto e pensa ad un errore negli headers.\n");
		}

		else
		{
			printf("Test fallito: funzione testata:  tokenArray(char*, Token*, 1)\n");
			printf("              risultato atteso:  BUFFER_TOO_SMALL\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }
        else return(3);
    }
    
    else if (argomento == 2)
    {
        return (3);
    }

    if (cont == tipo_di_test) return (0);

}

int test_printTokens(int tipo_di_test, int argomento)
{
    int cont;
    int i, dim;
    Token tok[5]; Token pippo;

    if (argomento > 2) return (2);
    pippo.contesto = (char *)malloc(sizeof(char) * 8);
    pippo.parola = (char *)malloc(sizeof(char) * 8);
    pippo.parola = "casa\0";
    pippo.contesto = "From:\0";
    tok[0] = pippo;
    pippo.contesto = (char *)malloc(sizeof(char) * 8);
    pippo.parola = (char *)malloc(sizeof(char) * 8);
    pippo.parola = "lavoro\0";
    pippo.contesto = "To:\0";
    tok[1] = pippo;
    pippo.contesto = (char *)malloc(sizeof(char) * 8);
    pippo.parola = (char *)malloc(sizeof(char) * 8);
    pippo.parola = "vieni\0";
    pippo.contesto = NULL;
    tok[2] = pippo;
    
    if (argomento == 0)
    {
        
        dim = 3;
        cont = printTokens(tok, dim);
    }
    
    if (argomento == 1)
    {
        dim = 10;
        
        if (tipo_di_test == 2)
        {

		cont = printTokens(NULL, dim);
		if (cont == tipo_di_test) return (0);

		else if (cont == 0)
		{
			printf("Test fallito: funzione testata:  printTokens(NULL, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:RESULT_OK\n");
			printf("	      spiegazione:  la funzione non controlla se il\n");
			printf("                            primo argomento  un puntatore nullo.\n");
		}

		else if (cont == 1)
		{
			printf("Test fallito: funzione testata:  printTokens(NULL, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:UNKNOWN_ERROR\n");
			printf("	      spiegazione:  la funzione vede che non riesce a\n");
			printf("                            leggere il testo e non sa perch,\n");
		}

		else if(cont == 3)
		{
			printf("Test fallito: funzione testata:  printTokens(NULL, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:EMPTY_STRING\n");
			printf("	      spiegazione:  la funzione interpreta come stringa\n");
			printf("                            vuota un argomento nullo.\n");
		}


		else
		{
			printf("Test fallito: funzione testata:  printTokens(NULL, 10)\n");
			printf("              risultato atteso:  NULL_POINTER\n");
			printf("              risultato ottenuto:%d\n", argomento);
			printf("	      spiegazione:  impossibile capirne la causa.\n");
		}
		return (1);
        }
        
        else return(3);
    }

    else if (argomento == 2)
    {
        return (3);
    }

    if (cont == tipo_di_test) return (0);
}

