// --------------------PROGETTO FILTRO ANTISPAM--------------------------------//


// modulo1.c
// Gabriele Tarantino 698294

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "modulo1.h"

int isEmpty(char *v){
    if(v[0] == '\0')return 1;
    else return 0;
}
int leggiFile(char *nomeFile, int dim , char *testo){
    FILE *f;
    int i=1;
    char c;
    if(!nomeFile ||!testo)return NULL_POINTER;
    if(isEmpty(nomeFile))return EMPTY_STRING;
     if(access(nomeFile, 0))return FILE_MISSING;
     if(!(f = fopen(nomeFile,"r"))) return FILE_UNREADABLE;
    if((testo[0] = getc(f)) == EOF)return FILE_EMPTY;
    while(((testo[i] = getc(f)) != EOF)&&(i<dim-1))i++;
    testo[i] = '\0';
    fclose(f);
    return RESULT_OK;

}
int estraiHeaders(char *email, char *headers, int dim){
    int i=0;
    if(!dim)return BUFFER_TOO_SMALL;
    if(!email || !headers)return NULL_POINTER;
    if(isEmpty(email))return EMPTY_STRING;
    if(email[i] == '\n')return HEADER_NOT_FOUND;
    while(1){
        if(email[i] == '\n' && email[i+1] == '\n'){
            headers[i] = '\0';
            return RESULT_OK;
        }
        if(i<dim-1)headers[i] = email[i++];
        else{
            headers[i]='\0';
            return BUFFER_TOO_SMALL;
        }
    }
}

int primoHeader(char *headers, char *primo_header, int dim){
    int i=0;
	if(!dim)return BUFFER_TOO_SMALL;
    if(!headers|| !primo_header)return NULL_POINTER;
    if(isEmpty(headers))return EMPTY_STRING;
    if(headers[0] ==':')return BAD_HEADER;
    while(i<dim-1){
        if((headers[i]== '\n' && headers[i+1] != '\t' && headers[i+1] != ' ' )|| headers[i] == '\0' ){
            primo_header[i] ='\0';
            return RESULT_OK;
        }
        else primo_header[i] = headers[i++];
    }
    primo_header[i]='\0';
    return BUFFER_TOO_SMALL;
}


int parseHeader(char * header, char * tipo, int dimt, char * valore, int dimv){
    int i=0, j=0;
    if(!dimt || !dimv)return BUFFER_TOO_SMALL;
    if(!header || !valore || !tipo)return NULL_POINTER;
    if(isEmpty(header))return EMPTY_STRING;
    while(header[i]!= ' '){
      if(header[i] == '\0')return BAD_HEADER;
       if(header[i] == '\n')return BAD_HEADER;
        if(i==dimt-1)return BUFFER_TOO_SMALL;
        tipo[i] = header[i];
        i++;
    }
    tipo[i] = '\0';
    i++;
    while(header[i] != '\0'){
        if(j==dimv-1)return BUFFER_TOO_SMALL;
        valore[j]=header[i];
        i++;
        j++;
    }
    if(!j)return BAD_HEADER;
    valore[j] = '\0';
    return RESULT_OK;
}
//estrae la prima parola dal vettore testo e la sostituisce con dei caratteri non alfanumerici.
//se non trova parole restituisce la stringa vuota.
int primaParola(char * testo, char * parola, int dim){
    int i=0,j=0;
    if(!dim)return BUFFER_TOO_SMALL;
    if(!testo || !parola)return NULL_POINTER;
    //test su STRING_EMPTY di questa funz NOT_INPLEMENTED
    while( ((!(testo[i]>='a' && testo[i]<='z')&& !(testo[i]>='0' && testo[i]<='9')&&!(testo[i]>='A' && testo[i]<='Z')) || (((testo[i]>='a' && testo[i]<='z')||(testo[i]>='0' && testo[i]<='9')||(testo[i]>='A' && testo[i]<='Z'))&&(!(testo[i+1]>='a' && testo[i+1]<='z') && !(testo[i+1]>='A' && testo[i+1]<='Z') && !(testo[i+1]>='0' && testo[i+1]<='9')))) && i<dim-1 && testo[i] != '\0')i++;
        if((i == dim-1)||(testo[i] == '\0')){
            parola[0] = '\0';
            return RESULT_OK;
        }
	  do{
	    parola[j] = testo[i];
	    testo[i] = '%';
	    i++;
	    j++;
	  }while(((testo[i]>='a' && testo[i]<='z')||(testo[i]>='0' && testo[i]<='9')||(testo[i]>='A' && testo[i]<='Z'))&& i<dim-1 && testo[i] != '\0');

    if(i == dim-1)return BUFFER_TOO_SMALL;
    parola[j]='\0';
    return RESULT_OK;

}
//aggiorna il buffer ogni volta che viene estratto un header
int aggiornaBuffer(char ** v, int dimP, int dim){
    int i;
    char * temp;
    temp = malloc(sizeof(char) * dim);
    while((*v)[dimP+ i]!= '\0'){
        temp[i] = (*v)[dimP+1 + i];
        i++;
    }

    temp[i]='\0';
    if(!strlen(temp))return 0;
    free(*v);
    *v = temp;
    return 1;
}

char * ins(char *v, int dim){
char *c;
c = malloc(sizeof(char) * dim);
return c = strncpy(c, v, dim);

}

int tokenizzaEmail(char * email, Token array[], int dimT){
    int dim = 400, i=0, j=0;
    char * headers;
    char * primo_header;
    char * parola;
    char *tipo, *valore;
    if(!email || !array)return NULL_POINTER;
    if(isEmpty(email))return EMPTY_STRING;
    if(!(primo_header = malloc(dim * sizeof(char))))return MEM_ALLOC_ERROR;
    if(!(headers = malloc(dim * sizeof(char))))return MEM_ALLOC_ERROR;
    if(!(parola = malloc(dim * sizeof(char))))return MEM_ALLOC_ERROR;
    if(!(tipo = malloc(dim * sizeof(char))))return MEM_ALLOC_ERROR;
    if(!(valore = malloc(dim * sizeof(char))))return MEM_ALLOC_ERROR;
    if((i = estraiHeaders(email, headers, dim)))return i;
      for(i=0; i<strlen(headers); i++)email[i]= '%';
       do{      
	  if(i = primoHeader(headers, primo_header, dim))return i;
	  if(i=parseHeader(primo_header, tipo, dim, valore, dim))return i;

	  	 if(i = primaParola(valore, parola,dim))return i;
	  	 while(!isEmpty(parola)){
		   	  array[j].parola = ins(parola,dim);
		   	 array[j].contesto = ins(tipo,dim);  
		   	 j++; 
			 if(i=primaParola(valore, parola,dim))return i;  
		       
		 }
		    }while(aggiornaBuffer(&headers, strlen(primo_header),dim));
         if(i = primaParola(email, parola,dim))return i;
    if(isEmpty(parola))return BODY_NOT_FOUND;
    while(!isEmpty(parola)){
        array[j].parola = ins(parola,dim);
        array[j].contesto = NULL;
        j++; 
        if(i=primaParola(email, parola,dim))return i;            
	}
    return RESULT_OK;
}

int printTokens(Token array[], int dimT){
    int i=0;
    if(!array)return NULL_POINTER;
    if(!dimT)return  BUFFER_TOO_SMALL;
    while(array[i].parola){
        if(array[i].contesto)printf("%s*%s\n",array[i].contesto,array[i].parola);
        else printf("%s\n", array[i].parola);
        i++;
    }
    return RESULT_OK;
}
/*
main(){
int i=0;
char * testo;
Token * array;
char nome[11]={'e','m','a','i','l','1','.','t','x','t','\0'};
int dim = 600;
testo = malloc(sizeof(char) * dim);
array = malloc(sizeof(Token) * dim); 
leggiFile(nome, dim, testo);
tokenizzaEmail(testo, array, dim);
printTokens(array, dim);
}
*/

