#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <strings.h>
#include "modulo1.h"
#include <ctype.h>



int leggiFile(char * nomefile, int dimensione, char * testo){
 char carattere;
int i=0, j=0, dimensioneFile=0;
FILE *f1, *f2;
if(nomefile==NULL||testo==NULL)
return(NULL_POINTER);

if(nomefile[0]=='\0')
return (EMPTY_STRING);

  if ((f1 = fopen(nomefile, "r")) == NULL)
      return(FILE_MISSING);
 f2 = fopen(nomefile, "r");

while((carattere = getc(f2)) != EOF){
j++;}
 dimensioneFile = j * (sizeof(char));
 if (dimensioneFile==0)
return(FILE_EMPTY);

if (dimensioneFile > dimensione)
    return(BUFFER_TOO_SMALL);
 while(i < dimensioneFile-1){

i++;  
 testo[i] = (getc(f1));}
   testo[i+1] = '\0';
   
  return(RESULT_OK);
}

int estraiHeaders(char * email, char * headers, int dimh){   
int contatore=0,i=0;

if (email==NULL)
return(NULL_POINTER);

if (email[0]=='\0')
return (EMPTY_STRING);

while ((email[i+1]!='\0')&&((email[i]!='\n')||(email[i+1]!='\n'))) 
  {contatore++;
   i++;
}
if(dimh<contatore)
  return(BUFFER_TOO_SMALL);

if(email[0]=='\n'&&email[1]=='\n')
return (HEADER_NOT_FOUND);

i=0;
while((email[i+1]!='\0')&&((email[i]!='\n')||(email[i+1]!='\n'))){
headers[i]=email[i];
i++;
}

headers[i]='\n';
headers[i+1]='\0';


return(RESULT_OK);
}

int primoHeader(char * headers, char * primo_header, int dim){
int i=0,contatore=0;


if ((headers==NULL)||(primo_header==NULL))
return(NULL_POINTER);


if (headers[0]=='\0')
return (EMPTY_STRING);



while ((headers[i]!='\n')||((headers[i]=='\n')&&(headers[i+1]==' '))||((headers[i]=='\n')&&(headers[i+1]=='\t')))
  {contatore++;
   i++;
}

if(dim<contatore)
  return(8);
i=0;
while((headers[i]!='\n')||((headers[i]=='\n')&&(headers[i+1]==' '))||((headers[i]=='\n')&&(headers[i+1]=='\t'))){
 
primo_header[i]=headers[i];
i++;}
primo_header[i]='\0'; 
return(0);
}

int parseHeader(char*header,char*tipo,int dimt,char*valore,int dimv)
{int j=0,i=0,value;
int lunghezza=0;    						  
int contatoreT=0; 						  
int contatoreV=0;						 
int g=0;						 

if (header==NULL||tipo==NULL||valore==NULL)  		 
return(NULL_POINTER);                                   

if (header[0]=='\0')                                     
return (EMPTY_STRING);                                  

lunghezza=strlen(header);                                    
for (i=0;(i<(lunghezza))&&(header[i]!=' ');i++){            
    contatoreT++;}    
    contatoreT++;  

if(dimt<contatoreT)                
return (BUFFER_TOO_SMALL);  


if ((header[0]<'a'&&header[0]>'z')&&(header[0]<'A'&&header[0]>'Z')&&(header[0]<'0'&&header[0]>'9'))
return (BAD_HEADER);


for (i=0;(i<(dimt))&&(header[i]!=' ');i++)
   tipo[i]=header[i];
 tipo[i]='\0';
 value=i;
 

g=i; 
for(++g;(g<(value+lunghezza))&&(header[g]!='\0')&&(header[g]!='\t');g++) 
contatoreV++; 

contatoreV++; 
if(dimv<contatoreV)           
return (BUFFER_TOO_SMALL);       



for(++i;(i<(value+dimv))&&(header[i]!='\0')&&(header[i]!='\t');i++)
{  valore[j]=header[i];
 j++;
}
valore[j]= '\0';

return(0);
    }

int primaParola(char*testo,char*parola,int dim)
{int i,j=0;

i=0;
while((testo[i]!='\0')&&((!isalpha(testo[i]))||(!isalpha(testo[i+1])))){i++;}
  

if(testo[i]=='\0')

return(UNKNOWN_ERROR);

while(isalpha(testo[i]))
{parola[j]=testo[i];
i++;
j++;
}
parola[i]='\0';
return (0);
}


int tokenizzaEmail(char *email, Token tokenArray[], int dimT){

int dimEH=200,dim=50, dimt=20, dimv=30,dimp=15;
int dimType,dimWord,dimValore,dimHeaders;
int posizione,m=0,i, j, k=0;
char strings[dimEH], string_one[dim], type[dimt], value[dimv],word[dimp];


if (email==NULL||tokenArray==NULL)
return(NULL_POINTER);  

if (email[0]=='\0')
return (EMPTY_STRING);

if (dimT==0)
return (BUFFER_TOO_SMALL); 


estraiHeaders(email, strings, dimEH);
dimHeaders = strlen(strings);

int a=1,b=1;
while(k<dimT&&strings[m]!='\0')
{
a=primoHeader(strings+m, string_one, dim);
b=parseHeader(string_one, type, dimt, value, dimv);
posizione=0;
dimValore=strlen(value);

while (k<dimT&& value[posizione]!='\0')
{
for (;(((!isalpha(value[posizione]))||(!isalpha(value[posizione+1])))&&(value[posizione+1]!='\0'));posizione++);    
if(value[posizione+1]=='\0')
break;
primaParola(value+posizione,word,dimp);
dimType = strlen(type); 

if((tokenArray[k].contesto =malloc(dimType*sizeof(char)))==NULL)
return(MEM_ALLOC_ERROR);
for (i=0, j=0; i < dimType; i++, j++){
tokenArray[k].contesto[j] = type[i];}


dimWord = strlen(word);
if((tokenArray[k].parola =malloc(dimWord*sizeof(char)))==NULL)
return(MEM_ALLOC_ERROR);
for (i=0; i < dimWord;i++){
tokenArray[k].parola[i] = word[i];}
posizione=posizione+dimWord;

k++;
}

m=m+(strlen(string_one))+1;
}

if (k==dimT)
{if(!primaParola(value+posizione,word,dimp))
return (BUFFER_TOO_SMALL); }


int posbody=dimHeaders, dimEmail;
char *body = email;
for(i=posizione;(!isalpha(email[i]))&&(email[i]!='\0');i++)
if(email[i]=='\0')
return (BODY_NOT_FOUND);
dimEmail = strlen(email) - dimHeaders;
while ((k<dimT) && (k<dimEmail) && (email[posbody]!='\0')){
for (;((!isalpha(email[posbody]))||((!isalpha(email[posbody+1])))&&((email[posbody+1]!='\0')));posbody++);

if(email[posbody+1]=='\0')
break;
primaParola(email+posbody,word,dimp);

tokenArray[k].contesto = NULL;

dimWord = strlen(word);
if((tokenArray[k].parola =malloc(dimWord*sizeof(char)))==NULL)
return(MEM_ALLOC_ERROR);
for (i=0; i < dimWord;i++){
tokenArray[k].parola[i] = word[i];}
tokenArray[k].parola[i] = '\0';
posbody = posbody + dimWord;
k++;
}
if(k<dimt)
{tokenArray[k].parola=NULL;
tokenArray[k].contesto=NULL;
}
if (k==dimT)
{if(!primaParola(email+posbody,word,dimp))
return (BUFFER_TOO_SMALL); }

return (0);
}

int printTokens(Token tokenArray[], int dimT)
{int i=0;
for (i=0;i<dimT&&(tokenArray[i].parola!=NULL);i++)
{if(tokenArray[i].contesto==NULL)
     {printf("%s\n",tokenArray[i].parola);}
else
     {printf("%s*%s\n",tokenArray[i].contesto,tokenArray[i].parola);}
}
}







