
#include "testModulo1.h"
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <strings.h>
	
#include <sys/stat.h>
#define MAX 1000
	

int test_leggiFile(int tipo_di_test, int argomento){
	
	
	char*nomefile;
	int dimensione=MAX;
	char*testo;	
	int val_1;
	
	
			switch(tipo_di_test){
		
			case FILE_MISSING :
				
				switch(argomento){
				
				case 0:
				
					nomefile="shudaedpcnev";
					dimensione=MAX;	
					testo=(char*)malloc(sizeof(char)*dimensione);
					if(testo==NULL)
						return(MEM_ALLOC_ERROR);
					val_1=leggiFile(nomefile,dimensione,testo);
						if(val_1==4)
							return(TEST_PASSED);
						else {
		printf("La funzione leggiFile nn gestisce il caso in cui venga passato un file inesistente come primo argomento.Il codice di ritorno doveva essere '4', invece  %d\n",val_1);
							return(TEST_FAILED);}
				
				case 1: return(NOT_VALID);		
				
				case 2: return(NOT_VALID);		
				
				default : return(ARG_MISSING);
				
				}//whitch argomento			
								
			case BUFFER_TOO_SMALL :
			
				switch(argomento){
				
					case 1:
					
						nomefile=(char*)malloc(sizeof(char)*dimensione);
							if(nomefile==NULL)
								return(MEM_ALLOC_ERROR);
						nomefile="testodiprovaperlafunzioneleggifile";
						dimensione=1;
						testo=(char*)malloc(sizeof(char)*MAX);
							if(testo==NULL)
								return(MEM_ALLOC_ERROR);
				
						val_1=leggiFile(nomefile,dimensione,testo);
						if(val_1==8)
							return(TEST_PASSED);
						else {
	printf("La funzione leggiFile nn gestisce il caso in cui venga passata una dimensione troppo piccola per contenere il contenuto del file.Il codice di ritorno doveva essere '8', invece  %d\n",val_1);
						return(TEST_FAILED);
						}
					case 0: return(NOT_VALID);
					
					case 2:
							return(NOT_VALID);
					
					default : return(ARG_MISSING);				
				}
			
			case NULL_POINTER :
			
				switch(argomento){
				
					case 0:
					
						nomefile=(char*)malloc(sizeof(char)*dimensione);
							if(nomefile==NULL)
								return(MEM_ALLOC_ERROR);
						nomefile=NULL;
						dimensione=MAX;
						testo=(char*)malloc(sizeof(char)*MAX);
							if(testo==NULL)
								return(MEM_ALLOC_ERROR);
				
						val_1=leggiFile(nomefile,dimensione,testo);
						if(val_1==2)
							return(TEST_PASSED);
						else {
						printf("La funzione leggiFile nn gestisce il caso in cui venga passato come primo argomento un argomento NULL.Il codice di ritorno doveva essere '2', invece  %d\n",val_1);
						return(TEST_FAILED);
						}
					case 1:
							return(NOT_VALID);
					
					case 2:
							testo=(char*)malloc(sizeof(char)*MAX);
							if(testo==NULL)
								return(MEM_ALLOC_ERROR);
						nomefile=(char*)malloc(sizeof(char)*dimensione);
							if(nomefile==NULL)
								return(MEM_ALLOC_ERROR);
						dimensione=MAX;
						testo=NULL;
						
						val_1=leggiFile(nomefile,dimensione,testo);
						if(val_1==2)
							return(TEST_PASSED);
						else {
						printf("La funzione leggiFile nn gestisce il caso in cui venga passato come secondo argomento un argomento NULL.Il codice di ritorno doveva essere '2', invece  %d\n",val_1);
						return(TEST_FAILED);
						}
			
					
					default : return(ARG_MISSING);				
				}	
			
			case HEADER_NOT_FOUND :
					return(NOT_VALID);
				
			case BODY_NOT_FOUND :
					return(NOT_VALID);
			case BAD_HEADER :
					return(NOT_VALID);	
				
				
			default : return(NOT_IMPLEMENTED);			
						

		}//end switch tipo di test



}//end test_leggiFile


int test_estraiHeaders(int tipo_di_test, int argomento){

	int dimh=MAX;
	char*email;
	char*headers;
	int val_2;
	email=(char*)malloc(sizeof(char)*MAX);
		if(email==NULL)
			return(MEM_ALLOC_ERROR);
	
	
	headers=(char*)malloc(sizeof(char)*dimh);
		if(headers==NULL)
			return(MEM_ALLOC_ERROR);

			switch(tipo_di_test){

				case NULL_POINTER :
						
						switch(argomento){
							
						case 0 :
							email=NULL;
									
							val_2=estraiHeaders(email,headers,dimh);		
								if(val_2==2)
									return(TEST_PASSED);
								else{
								printf("la funzione estraiHeaders nn gestisce il caso in cui venga passato il primo argomento = NULL.Il codice di ritorno doveva essere '2', invece  %d\n",val_2);
								return(TEST_FAILED);
								}

						case 1 :		
							headers=NULL;
							email="cainconoubvor";
							val_2=estraiHeaders(email,headers,dimh);		
								if(val_2==2)
									return(TEST_PASSED);
								else{
								printf("la funzione estraiHeaders nn gestisce il caso in cui venga passato il secondo argomento = NULL.Il codice di ritorno doveva essere '2', invece  %d\n",val_2);
								return(TEST_FAILED);
								}
	
						case 2 :
							return(NOT_VALID);	
						
						default : return(ARG_MISSING);		
						
						
						}
			
				case EMPTY_STRING :			
						switch(argomento){
						
							case 0 :
							
								email[0]='\0';
								
							val_2=estraiHeaders(email,headers,dimh);		
								if(val_2==3)
									return(TEST_PASSED);
							else{
								printf("la funzione estraiHeaders nn gestisce il caso in cui venga passata una stringa vuota come primo argomento.Il codice di ritorno doveva essere '3', invece  %d\n",val_2);
								return(TEST_FAILED);
								}
	
							case 1 :
								
								return(NOT_VALID);

							case 2 :
							
							return(NOT_VALID);
						
							default : return(ARG_MISSING);
						
						}//end argomento
			
					case BUFFER_TOO_SMALL :
						
						switch(argomento){
							
						case 2 :
							dimh=0;
							email="ahdiodhsauhao";
									
							val_2=estraiHeaders(email,headers,dimh);		
								if(val_2==8)
									return(TEST_PASSED);
								else{
								printf("la funzione estraiHeaders nn gestisce il caso in cui venga passata una dimensione del buffer troppo piccola per contenere i dati degli headers.Il codice di ritorno doveva essere '8', invece  %d\n",val_2);
								return(TEST_FAILED);
								}
								
						case 0 :		
								return(NOT_VALID);	
	
						case 1 :
							return(NOT_VALID);	
						
						default : return(ARG_MISSING);		
						
						
						}
			
				case FILE_MISSING :
					return(NOT_VALID);
				case FILE_UNREADABLE :
					return(NOT_VALID);
				case FILE_UNWRITABLE :
					return(NOT_VALID);
				case FILE_EMPTY :
					return(NOT_VALID);
				case BODY_NOT_FOUND :
					return(NOT_VALID);
				case BAD_HEADER :
					return(NOT_VALID);		
						
								
				default : return(NOT_IMPLEMENTED);
			}
			
			





}//end test_estraiHeaders


int test_primoHeader(int tipo_di_test, int argomento){

	char*headers;
	char*primo_header;
	int dim=MAX;
	int val_3;
	headers=(char*)malloc(sizeof(char)*MAX);
		if(headers==NULL)
			return(MEM_ALLOC_ERROR);	
	primo_header=(char*)malloc(sizeof(char)*dim);
		if(primo_header==NULL)
			return(MEM_ALLOC_ERROR);

		switch(tipo_di_test){
				
		
				case HEADER_NOT_FOUND :

					switch(argomento){
				
				case 0 :
					headers="  headersbagliato\n\n";
					
					val_3=primoHeader(headers,primo_header,dim);
						if(val_3==9)
							return(TEST_PASSED);
						else{
						printf("la funzione primoHeader nn gestisce correttamente gli headers. Abbiamo passato un header sbagliato e il valore di errore di ritorno nn era esatto!.Il codice di ritorno doveva essere '9', invece  %d\n",val_3);
						return(TEST_FAILED);
						
						
						}	
					
				case 1 :
				
					return(NOT_VALID);
					
				case 2 :
				
				     return(NOT_VALID);			
							
				default :
				
					return(ARG_MISSING);
						
					
					
		}//switch argomento
				
				case BUFFER_TOO_SMALL:
				
						switch(argomento){
						
							case 0 :
							
								return(NOT_VALID);
								
							case 1 :
								return(NOT_VALID);
						
						
							case 2 :
							
								headers="aushdiuahdiahduisahdia\n\n";
								dim=1;
								val_3=primoHeader(headers,primo_header,dim);
									if(val_3==8)
										return(TEST_PASSED);
									else{	
									printf("la funzione leggi file nn gestisce correttamente il caso in cui venga passata una dimensione del buffer troppo piccola.Il codice di ritorno doveva essere '8', invece  %d\n",val_3);
									return(TEST_FAILED);
								}
							default : return(ARG_MISSING);
						}//end argomento
				
				case EMPTY_STRING:
				
						switch(argomento){
						
							case 0 :
							
								headers[0]='\0';
								
								val_3=primoHeader(headers,primo_header,dim);
									if(val_3==3)
										return(TEST_PASSED);
									else{	
									printf("la funzione leggi file nn gestisce correttamente il caso in cui venga passata una stringa vuota come primo argomento.Il codice di ritorno doveva essere '3', invece  %d\n",val_3);
									return(TEST_FAILED);
								}
							case 1 :
									
								return(NOT_VALID);
						
						
							case 2 :
							
								return(NOT_VALID);
								
							default : return(ARG_MISSING);
						}//end argomento		
						
						
				case FILE_MISSING :
					return(NOT_VALID);
				case FILE_UNREADABLE :
					return(NOT_VALID);
				case FILE_UNWRITABLE :
					return(NOT_VALID);
				case FILE_EMPTY :
					return(NOT_VALID);
				case BODY_NOT_FOUND :
					return(NOT_VALID);
				
				case BAD_HEADER :
					return(NOT_VALID);			
						
				default : return(NOT_IMPLEMENTED);
				
				
		
		
		
		}
		
}//end test primo header


int test_parseHeader(int tipo_di_test, int argomento){
	char*header;
	char*tipo;
	int dimt=MAX;
	int dimv=MAX;
	char*valore;
	int val_4;

	header=(char*)malloc(sizeof(char)*MAX);
		if(header==NULL)
			return(MEM_ALLOC_ERROR);
	tipo=(char*)malloc(sizeof(char)*dimt);
		if(header==NULL)
			return(MEM_ALLOC_ERROR);
	valore=(char*)malloc(sizeof(char)*dimv);
		if(header==NULL)
			return(MEM_ALLOC_ERROR);
	

			switch(tipo_di_test){


				case BAD_HEADER :
				
						switch(argomento){
						
							
						case 0 :	
							
							header=" unbadheader\n\n";
							val_4=parseHeader(header,tipo,dimt,valore,dimv);
								if(val_4==11)
									return(TEST_PASSED);
								else{
								printf("Abbiamo passato un header sbagliato (primo argomento)alla funzione. Ma nn  stato tornato un codice di errore esatto.Il codice di ritorno doveva essere '11', invece  %d\n",val_4);
								return(TEST_FAILED);
								}
			
						case 1 :
							return(NOT_VALID);
						case 2 :
							return(NOT_VALID);		
						case 3 :
							return(NOT_VALID);		
						case 4 :
							return(NOT_VALID);		
						default : 
							return(ARG_MISSING);	
								
						}//end argomento
			
				case BUFFER_TOO_SMALL :
				
						switch(argomento){
						
						
								case 0 :
									return(NOT_VALID);
								case 1 :
									return(NOT_VALID);
								case 2 :
									dimt=1;
									header="ahisdijsfoijf ienodneaofno\n";
									val_4=parseHeader(header,tipo,dimt,valore,dimv);
										if(val_4==8)
											return(TEST_PASSED);
										else{	
										printf("la funzione nn gestisce correttamente il caso in cui venga passato una dimensio troppo piccola al campo testo! (dimt).Il codice di ritorno doveva essere '8', invece  %d\n",val_4);
										return(TEST_FAILED);
																										
										}
								case 3 :
									return(NOT_VALID);
								case 4 :
									
									dimv=1;
									header="ahisdijsfoijf ienodneaofno\n";
									val_4=parseHeader(header,tipo,dimt,valore,dimv);
										if(val_4==8)
											return(TEST_PASSED);
										else{	
										printf("la funzione nn gestisce correttamente il caso in cui venga passato una dimensio troppo piccola al campo valore! (dimv).Il codice di ritorno doveva essere '8', invece  %d\n",val_4);
										return(TEST_FAILED);
																										
										}					
								
								default : return(ARG_MISSING);	
						
						}//end argomento		

					case EMPTY_STRING :
				
						switch(argomento){
						
							
						case 0 :	
							
							header[0]='\0';
							
							val_4=parseHeader(header,tipo,dimt,valore,dimv);
								if(val_4==3)
									return(TEST_PASSED);
								else{
								printf("La funzione nn gestisce correttamente il caso in cui passiamo una stringa vuota come primo argomento(header).Il codice di ritorno doveva essere '3', invece  %d\n",val_4);
								return(TEST_FAILED);
								}
			
						case 1 :
							return(NOT_VALID);
						case 2 :
							return(NOT_VALID);		
						case 3 :
							return(NOT_VALID);	
						case 4 :
							return(NOT_VALID);		
						default : 
							return(ARG_MISSING);	
								
						}//end argomento	
					
						
					
					case FILE_MISSING :
						return(NOT_VALID);
					case FILE_UNREADABLE :
						return(NOT_VALID);
					case FILE_UNWRITABLE :
						return(NOT_VALID);
					case FILE_EMPTY :
						return(NOT_VALID);	
					case BODY_NOT_FOUND :
						return(NOT_VALID);
					
							
					default : return(NOT_IMPLEMENTED);

			}//end tipo_ti_test

}//end test_parseHeader


int test_primaParola(int tipo_di_test, int argomento){

	char*testo;
	char*parola;
	int dim=MAX;
	

	testo=(char*)malloc(sizeof(char)*MAX);
		if(testo==NULL)
			return(MEM_ALLOC_ERROR);
	parola=(char*)malloc(sizeof(char)*MAX);
		if(parola==NULL)
			return(MEM_ALLOC_ERROR);
	int val_5=0;
	
	
	
		switch(tipo_di_test){
		
		
				case EMPTY_STRING :
				
						switch(argomento){
		
		
							case 0 :
								
								testo[0]='\0';
								val_5=primaParola(testo,parola,dim);
									if(val_5==3)
										return(TEST_PASSED);	
									else{
		printf("la funzione nn gestisce correttamente il caso in cui venga passata come primo argomento una stringa vuota.Il codice di ritorno doveva essere '3', invece  %d\n",val_5);
									return(TEST_FAILED);
									
									}
									
							case 1 :
								return(NOT_VALID);
							case 2 :
								return(NOT_VALID);
		
		
							default : return(ARG_MISSING);
		
			
						}
		
				case NULL_POINTER :
				
						switch(argomento){
						
							case 0 :
								testo=NULL;
								val_5=primaParola(testo,parola,dim);
									if(val_5==2)
										return(TEST_PASSED);	
									else{
		printf("la funzione nn gestisce correttamente il caso in cui venga passata come primo argomento un argomento NULL.Il codice di ritorno doveva essere '2', invece  %d\n",val_5);
									return(TEST_FAILED);
									
									}
							case 1 : 
								
								parola=NULL;
								testo="ouhfdufdhwo";
								val_5=primaParola(testo,parola,dim);
									if(val_5==2)
										return(TEST_PASSED);	
									else{
		printf("la funzione nn gestisce correttamente il caso in cui venga passata come secondo argomento un argomento NULL.Il codice di ritorno doveva essere '2', invece  %d\n",val_5);
									return(TEST_FAILED);
									
									}
						
							case 2 :
								return(NOT_VALID);
							
							default : return(ARG_MISSING);
						
							
						}		
						
					case BUFFER_TOO_SMALL :
				
						switch(argomento){
						
							case 0 :
								return(NOT_VALID);
							case 1 : 
								
								return(NOT_VALID);
							case 2 :
								dim=0;
								testo="aifhochdocosdi";
								val_5=primaParola(testo,parola,dim);
									if(val_5==8)
										return(TEST_PASSED);	
									else{
printf("la funzione nn gestisce correttamente il caso in cui venga passata come terzo argomento una dimensione troppo piccola per contenere i dati della stringa testo.Il codice di ritorno doveva essere '8', invece  %d\n",val_5);
									return(TEST_FAILED);
									
									}
							
							default : return(ARG_MISSING);
						
							
					}		
						
						
						case FILE_MISSING :
							return(NOT_VALID);
						case FILE_UNREADABLE :
							return(NOT_VALID);
						case FILE_UNWRITABLE :
							return(NOT_VALID);
						case FILE_EMPTY :
							return(NOT_VALID);
						case BODY_NOT_FOUND :
							return(NOT_VALID);
						case BAD_HEADER :
							return(NOT_VALID);
						case HEADER_NOT_FOUND :
							return(NOT_VALID);
								
						
						
						
						default : return(NOT_IMPLEMENTED);
						
		}//end tipo di test
		
		
}//end test primaParola


int test_tokenizzaEmail(int tipo_di_test, int argomento){
	char*email;
	Token tokenArray[MAX];
	int dimT=MAX;
	int val_6;
	
	
	email=(char*)malloc(sizeof(char)*dimT);
		if(email==NULL)
			return(MEM_ALLOC_ERROR);
	
		switch(tipo_di_test,argomento){
		
		
				case EMPTY_STRING :
				
						switch(argomento){
		
		
							case 0 :
								
								email[0]='\0';
								val_6=tokenizzaEmail(email,tokenArray,dimT);
									if(val_6==3)
										return(TEST_PASSED);	
									else{
									printf("la funzione nn gestisce correttamente il caso in cui venga passata come primo argomento una stringa vuota.Il codice di ritorno doveva essere '3', invece  %d\n",val_6);
									return(TEST_FAILED);
									
									}
									
							case 1 :
							
								return(NOT_VALID);	
							case 2 :
								return(NOT_VALID);
		
		
							default : return(ARG_MISSING);
		
			
						}
		
				case NULL_POINTER :
				
						switch(argomento){
						
							case 0 :
								email=NULL;
								val_6=tokenizzaEmail(email,tokenArray,dimT);
									if(val_6==2)
										return(TEST_PASSED);	
									else{
									printf("la funzione nn gestisce correttamente il caso in cui venga passata come primo argomento un argomento NULL.Il codice di ritorno doveva essere '2', invece  %d\n",val_6);
									return(TEST_FAILED);
									
									}
							case 1 : 
								email="dnfcosdihfsodifd";
								tokenArray->contesto=NULL;
								tokenArray->parola=NULL;
								val_6=tokenizzaEmail(email,tokenArray,dimT);
									if(val_6==2)
										return(TEST_PASSED);	
									else{
									printf("la funzione nn gestisce correttamente il caso in cui venga passata come secondo argomento un argomento NULL.Il codice di ritorno doveva essere '2', invece  %d\n",val_6);
									return(TEST_FAILED);
									
									}
						
							case 2 :
								return(NOT_VALID);
							
							default : return(ARG_MISSING);
						
							
						}		
				
				case BUFFER_TOO_SMALL :
				
						switch(argomento){
						
							case 0 :
								return(NOT_VALID);
							case 1 : 
								return(NOT_VALID);
							case 2 :
								
								dimT=0;
								email="adohnoacfndaocindao";
								val_6=tokenizzaEmail(email,tokenArray,dimT);
									if(val_6==8)
										return(TEST_PASSED);	
									else{
									printf("la funzione nn gestisce correttamente il caso in cui venga passata come terzo argomento una dimensione troppo piccola per contenere i dati della stringa email..Il codice di ritorno doveva essere '8', invece  %d\n",val_6);
									return(TEST_FAILED);
									
									}
							
							default : return(ARG_MISSING);
						
							
						}		
						
						case FILE_MISSING :
							return(NOT_VALID);
						case FILE_UNREADABLE :
							return(NOT_VALID);
						case FILE_UNWRITABLE :
							return(NOT_VALID);
						case FILE_EMPTY :
							return(NOT_VALID);		
						
							
							
							
						default : return(NOT_IMPLEMENTED);
						
		}//end tipo di test


}//end test_tokenizza


int test_printTokens(int tipo_di_test, int argomento){
	int val_7;
	Token * tokenArray=NULL;
	int dimT=0;

	
		switch(tipo_di_test,argomento){
		
		
				
		
				case NULL_POINTER :
				
						switch(argomento){
						
							case 1 :
								return(NOT_VALID);	
									
							case 0 : 
								
								
							val_7=printTokens(tokenArray,dimT);
									if(val_7==2)
										return(TEST_PASSED);	
									else{
									printf("la funzione nn gestisce correttamente il caso in cui venga passata come primo argomento un argomento NULL.Il codice di ritorno doveva essere '2', invece  %d\n",val_7);
									return(TEST_FAILED);
									
									}
						
							
							default : return(ARG_MISSING);
						
							
						}		
						

				case EMPTY_STRING :
				
						switch(argomento){
		
		
							case 0 :
								
								tokenArray=(Token*)malloc(sizeof(Token)*MAX);
								
								tokenArray->parola[0]='\0';
								tokenArray->contesto[0]='\0';	
							
								val_7=printTokens(tokenArray,dimT);
									if(val_7==3)
										return(TEST_PASSED);	
									else{
									printf("la funzione nn gestisce correttamente il caso in cui venga passata come primo argomento una stringa vuota.Il codice di ritorno doveva essere '3', invece  %d\n",val_7);
									return(TEST_FAILED);
									
									}	
							
							case 1 :
								return(NOT_VALID);		
							default : return(ARG_MISSING);
		
			
						}
				
						
						
						case FILE_MISSING :
							return(NOT_VALID);
						case FILE_UNREADABLE :
							return(NOT_VALID);
						case FILE_UNWRITABLE :
							return(NOT_VALID);
						case FILE_EMPTY :
							return(NOT_VALID);
						case BAD_HEADER :
							return(NOT_VALID);
						case HEADER_NOT_FOUND :
							return(NOT_VALID);
						case BODY_NOT_FOUND :
							return(NOT_VALID);		
							
							default : return(NOT_IMPLEMENTED);
						
		}	

}//end printtokens

