int test_leggiFile(int tipo_di_test, int n_argomento)
{
  int result = 0;
  int dim = 1000;
  char *ciao = {"email.txt"};
  char testo[1000];

  if(tipo_di_test == NULL_POINTER && n_argomento == 0)
    {
  result = leggiFile(NULL,dim,testo);
  if(result == EMPTY_STRING)
    return TEST_PASSED;
  else if (result == RESULT_OK)
    return TEST_FAILED;
    }



else if (tipo_di_test == NULL_POINTER && n_argomento == 2)
    {
      result = leggiFile(ciao,dim,NULL);
      if(result == NULL_POINTER)
	return TEST_PASSED;
      else if (result == RESULT_OK)
	return TEST_FAILED;
    }


else if(tipo_di_test == BUFFER_TOO_SMALL  && n_argomento == 1)
  {
    result = leggiFile(ciao,0,testo);
    if(result == BUFFER_TOO_SMALL)
      return TEST_PASSED;
    else if(result == RESULT_OK)
      return TEST_FAILED;
  }

  else return NOT_IMPLEMENTED;
}
int test_estraiHeaders(int tipo_di_test, int n_argomento)
{
  int result = 0;
  int dim = 1000;
  char *ciao = {"email.txt"};
  char testo[1000];

  if(tipo_di_test == NULL_POINTER && n_argomento == 0)
    {
  result = leggiFile(NULL,dim,testo);
  if(result == EMPTY_STRING)
    return TEST_PASSED;
  else if (result == RESULT_OK)
    return TEST_FAILED;
    }



else if (tipo_di_test == NULL_POINTER && n_argomento == 2)
    {
      result = leggiFile(ciao,dim,NULL);
      if(result == NULL_POINTER)
	return TEST_PASSED;
      else if (result == RESULT_OK)
	return TEST_FAILED;
    }


else if(tipo_di_test == BUFFER_TOO_SMALL  && n_argomento == 1)
  {
    result = leggiFile(ciao,0,testo);
    if(result == BUFFER_TOO_SMALL)
      return TEST_PASSED;
    else if(result == RESULT_OK)
      return TEST_FAILED;
  }
  else return NOT_IMPLEMENTED;
}

int test_primoHeader(int tipo_di_test, int n_argomento)
{
  int result = 0;
  int dim = 1000;
  char *ciao = {"email.txt"};
  char testo[1000];

  if(tipo_di_test == NULL_POINTER && n_argomento == 0)
    {
  result = leggiFile(NULL,dim,testo);
  if(result == EMPTY_STRING)
    return TEST_PASSED;
  else if (result == RESULT_OK)
    return TEST_FAILED;
    }



else if (tipo_di_test == NULL_POINTER && n_argomento == 2)
    {
      result = leggiFile(ciao,dim,NULL);
      if(result == NULL_POINTER)
	return TEST_PASSED;
      else if (result == RESULT_OK)
	return TEST_FAILED;
    }


else if(tipo_di_test == BUFFER_TOO_SMALL  && n_argomento == 1)
  {
    result = leggiFile(ciao,0,testo);
    if(result == BUFFER_TOO_SMALL)
      return TEST_PASSED;
    else if(result == RESULT_OK)
      return TEST_FAILED;
  }
  else return NOT_IMPLEMENTED;
}

int test_parseHeader(int tipo_di_test, int n_argomento)	
{
  int result = 0;
  int dim = 1000;
  char *ciao = {"email.txt"};
  char testo[1000];

  if(tipo_di_test == NULL_POINTER && n_argomento == 0)
    {
  result = leggiFile(NULL,dim,testo);
  if(result == EMPTY_STRING)
    return TEST_PASSED;
  else if (result == RESULT_OK)
    return TEST_FAILED;
    }



else if (tipo_di_test == NULL_POINTER && n_argomento == 2)
    {
      result = leggiFile(ciao,dim,NULL);
      if(result == NULL_POINTER)
	return TEST_PASSED;
      else if (result == RESULT_OK)
	return TEST_FAILED;
    }


else if(tipo_di_test == BUFFER_TOO_SMALL  && n_argomento == 1)
  {
    result = leggiFile(ciao,0,testo);
    if(result == BUFFER_TOO_SMALL)
      return TEST_PASSED;
    else if(result == RESULT_OK)
      return TEST_FAILED;
  }
  else return NOT_IMPLEMENTED;
}

int test_primaParola(int tipo_di_test, int n_argomento)	
{
  int result = 0;
  int dim = 1000;
  char *ciao = {"email.txt"};
  char testo[1000];

  if(tipo_di_test == NULL_POINTER && n_argomento == 0)
    {
  result = leggiFile(NULL,dim,testo);
  if(result == EMPTY_STRING)
    return TEST_PASSED;
  else if (result == RESULT_OK)
    return TEST_FAILED;
    }



else if (tipo_di_test == NULL_POINTER && n_argomento == 2)
    {
      result = leggiFile(ciao,dim,NULL);
      if(result == NULL_POINTER)
	return TEST_PASSED;
      else if (result == RESULT_OK)
	return TEST_FAILED;
    }


else if(tipo_di_test == BUFFER_TOO_SMALL  && n_argomento == 1)
  {
    result = leggiFile(ciao,0,testo);
    if(result == BUFFER_TOO_SMALL)
      return TEST_PASSED;
    else if(result == RESULT_OK)
      return TEST_FAILED;
  }
  else return NOT_IMPLEMENTED;
}

int test_tokenizzaEmail(int tipo_di_test, int n_argomento)
{
  int result = 0;
  int dim = 1000;
  char *ciao = {"email.txt"};
  char testo[1000];

  if(tipo_di_test == NULL_POINTER && n_argomento == 0)
    {
  result = leggiFile(NULL,dim,testo);
  if(result == EMPTY_STRING)
    return TEST_PASSED;
  else if (result == RESULT_OK)
    return TEST_FAILED;
    }



else if (tipo_di_test == NULL_POINTER && n_argomento == 2)
    {
      result = leggiFile(ciao,dim,NULL);
      if(result == NULL_POINTER)
	return TEST_PASSED;
      else if (result == RESULT_OK)
	return TEST_FAILED;
    }


else if(tipo_di_test == BUFFER_TOO_SMALL  && n_argomento == 1)
  {
    result = leggiFile(ciao,0,testo);
    if(result == BUFFER_TOO_SMALL)
      return TEST_PASSED;
    else if(result == RESULT_OK)
      return TEST_FAILED;
  }
  else return NOT_IMPLEMENTED;
}

int test_printTokens(int tipo_di_test, int n_argomento)
{
  int result = 0;
  int dim = 1000;
  char *ciao = {"email.txt"};
  char testo[1000];

  if(tipo_di_test == NULL_POINTER && n_argomento == 0)
    {
  result = leggiFile(NULL,dim,testo);
  if(result == EMPTY_STRING)
    return TEST_PASSED;
  else if (result == RESULT_OK)
    return TEST_FAILED;
    }



else if (tipo_di_test == NULL_POINTER && n_argomento == 2)
    {
      result = leggiFile(ciao,dim,NULL);
      if(result == NULL_POINTER)
	return TEST_PASSED;
      else if (result == RESULT_OK)
	return TEST_FAILED;
    }


else if(tipo_di_test == BUFFER_TOO_SMALL  && n_argomento == 1)
  {
    result = leggiFile(ciao,0,testo);
    if(result == BUFFER_TOO_SMALL)
      return TEST_PASSED;
    else if(result == RESULT_OK)
      return TEST_FAILED;
  }
  else return NOT_IMPLEMENTED;

}  
