#include "testModulo1.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <ctype.h>



//funzione test per leggi file

int test_leggiFile(int tipo_di_test, int argomento){
  int result=0;
  //CONTROLLO SUL PRIMO ARGOMENTO  
  
  //faccio il controllo se il primo argomento non  null
  if(argomento==0){ 
    if((tipo_di_test==2)&&(argomento==0)){
      char *Ptr1=NULL;
      int dim3=500;
      char *test1=NULL;
      test1=(char *)malloc(sizeof(char)*dim3);
      if(test1==NULL){
	return(MEM_ALLOC_ERROR);
      }
      result=leggiFile(Ptr1,dim3,test1);
      
      if(result==tipo_di_test){
	result=0;
	free(test1);
	return(TEST_PASSED);
      }
      else{
	printf("Funzione testata era: leggiFile(NULL,dim,testo)\n");
	printf("Risultato atteso era: NULL\n");
	printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
	printf("La funzione leggiFile non controlla se il primo argomento\ndella funzione  NULL\n");
	free(test1);
	return(TEST_FAILED);
      }
    }

    if((tipo_di_test==3)||(tipo_di_test==8)||
       (tipo_di_test==9)||(tipo_di_test==10)||(tipo_di_test==11)||
       (tipo_di_test==12)){
      return(NOT_VALID);
    }else{
      if((tipo_di_test==0)||(tipo_di_test==4)||(tipo_di_test==5)||(tipo_di_test==6)||(tipo_di_test==1)){
	return(NOT_IMPLEMENTED);
      }
    }
  }
  //faccio il controllo che il file non sia vuoto
  
  if((tipo_di_test==7)&&(argomento==0)){
    
    FILE *cfPtr;
    cfPtr=fopen("Filezzz","w+");
    char *test2;
    int dim4=500;
    test2=(char *)malloc(sizeof(char)*dim4);
    if(test2==NULL){
      return(MEM_ALLOC_ERROR);
    }
    result=leggiFile("Filezzz",dim4,test2);
    
    if(result==tipo_di_test){
      
      return(TEST_PASSED);
    }
    else{
      printf("Funzione testata era: leggiFile(Filezzz,dim,test2)\n");
      printf("Risultato atteso era: FILE_EMPTY\n");
      printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
      printf("La funzione leggiFile non controllo se il primo  argomento\n un file  vuoto\n");
      free(test2);
      return(TEST_FAILED);
    }
  }
  if(argomento==0){
    if((tipo_di_test!=7)){
      return(NOT_VALID);
    }
  }
 

  //CONTROLLLO SUL SECONDO ARGOMENTO
  //la funzione torna BUFFER_TOO_SMALL
  if((tipo_di_test==8)&&(argomento==1)){
    int dim=2;
    int dim1=500;
    char *test=NULL;
    char *prova1=NULL;
    prova1=(char *)malloc(sizeof(char)*dim1);
    if(prova1==NULL){
      return(MEM_ALLOC_ERROR);
    }
    test=(char *)malloc(sizeof(char)*dim);
    if(test==NULL){
      return(MEM_ALLOC_ERROR);
    }
    result=leggiFile(prova1,dim,test);
    
    if(tipo_di_test==result){
      result=0;
      return(TEST_PASSED);
    }else{
      printf("Funzione testata era: leggiFile(nomefile,%d,test)\n",dim);
      printf("Risultato atteso era: BUFFER_TOO_SMALL\n");
      printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
      printf("La funzione leggiFile non controlla se il secondo argomento\ndella funzione  BUFFER_TO_SMALL\n");
      free(test);
      free(prova1);
      result=0;
      return(TEST_FAILED);
    }
  }
  
  if((argomento==1)&&(tipo_di_test!=8)&&(tipo_di_test!=0)){
    result=0;
    return(NOT_VALID);
  }else{
    if((argomento==1)&&(tipo_di_test==0)){
      return(NOT_IMPLEMENTED);
    }
  }
  
  
  //CONTROLLO SUL TERZO ARGOMENTO
  //se arrivo qui vuol dire che voglio controllare se il terzo argomento non  null
  if((tipo_di_test==2)&&(argomento==2)){
    int dim2=500;
    char *prova2=NULL;
    char *Ptr=NULL;
    prova2=(char *)malloc(sizeof(char)*dim2);
    if(prova2==NULL){
      return(MEM_ALLOC_ERROR);
    }
    result=leggiFile(prova2,dim2,Ptr);
    
    if(tipo_di_test==result){
      result=0;
      return(TEST_PASSED);
    }
    else{
     printf("Funzione testata era: leggiFile(nomefile,dim,NULL)\n");
     printf("Risultato atteso era: NULL_POINTER\n");
     printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
     printf("La funzione leggiFile non controllo se il terzo  argomento\ndella funzione  NULL\n");
     free(prova2);
     result=0;
     return(TEST_FAILED);
    }
  }
  
  if(argomento==2){
    if((tipo_di_test!=2)&&(tipo_di_test!=0)){
      return(NOT_VALID);
    }else{
      if((tipo_di_test==0)){
	return(NOT_IMPLEMENTED);
      }
    }
  }
  
     
  
  if(argomento>2||argomento<0){
    return(ARG_MISSING);
  }

}

//CHIUSURA DELLA FUNZIONE CHE CONTROLLA LA leggiFILE
//-----------------------------------------------------------------------------------------------------------------------------------------------------


// TEST SULLA FUNZIONE ESTRAI HEADERS
int test_estraiHeaders(int tipo_di_test, int argomento){
  
  int result=0;//variabile per il risultato
  //FACCIO PRIMA I TEST SUL PRIMO ARGOMENTO
  if(argomento==0){
    if((tipo_di_test==2)&&(argomento==0)){
      int dim2=500;
      char *prova2=NULL;
      char *Ptr=NULL;
      prova2=(char *)malloc(sizeof(char)*dim2);
      if(prova2==NULL){
	return(MEM_ALLOC_ERROR);
      }
      result=estraiHeaders(Ptr,prova2,dim2);
      
      if(tipo_di_test==result){
	result=0;
	return(TEST_PASSED);
      }
      else{
	printf("Funzione testata era: estraiHeaders(NULL,headers,dim)\n");
	printf("Risultato atteso era: NULL_POINTER\n");
	printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
	printf("La funzione estraiHeaders non controlla se il primo  argomento\ndella funzione  NULL\n");
	free(prova2);
	result=0;
	return(TEST_FAILED);
      }
    }
  
    if((tipo_di_test==1)||(tipo_di_test==4)||(tipo_di_test==5)||
       (tipo_di_test==6)||(tipo_di_test==7)||(tipo_di_test==8)||
       (tipo_di_test==10)||(tipo_di_test==11)||(tipo_di_test==12)){
      return(NOT_VALID);
    }else{
      if(tipo_di_test==0){
	return(NOT_IMPLEMENTED);
      }
    }
  }
  //CONTROLLO SE LA STRINGA  VUOTA
  if((tipo_di_test==3)&&(argomento==0)){
    char *stringa="";
    int dim3=50;
    char *Ptr=NULL;
    Ptr=(char *)malloc(sizeof(char)*dim3);
    result=estraiHeaders(stringa,Ptr,50);
   
    if(tipo_di_test==result){
      result=0;
      free(Ptr);
      return(TEST_PASSED);
    }else{
     printf("Funzione testata era: estraiHeaders(email,headers,dim)\n");
     printf("Risultato atteso era: EMPTY_STRING\n");
     printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
     printf("La funzione estraiHeadres non controlla se il primo  argomento\ndella funzione  EMPTY_STRING\n");
     free(Ptr);
     return(TEST_FAILED);
    }
  
  }
  
  if(argomento==0){
    if((tipo_di_test==1)||(tipo_di_test==4)||(tipo_di_test==5)||(tipo_di_test==6)
       ||(tipo_di_test==7)||(tipo_di_test==8)||(tipo_di_test==10)||(tipo_di_test==11)
      ||(tipo_di_test==12)){
      return(NOT_VALID);
    }else{
      if(tipo_di_test==0){
	return(NOT_IMPLEMENTED);
      }
    }
  }
  
  //CONTROLLO SE L'HEADERS  STATO TROVATO
  if((tipo_di_test==9)&&(argomento==0)){
    char *stringa1="pippo";
    int dim4=50;
    char *Ptr1=NULL;
    Ptr1=(char *)malloc(sizeof(char)*dim4);
    result=estraiHeaders(stringa1,Ptr1,50);
    if(tipo_di_test==result){
      result=0;
      free(Ptr1);
      return(TEST_PASSED);
    }else{
     printf("Funzione testata era: estraiHeaders(email,headers,dim)\n");
     printf("Risultato atteso era: HEADER_NOT_FOUND\n");
     printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
     printf("La funzione estraiHeadres non controlla se il primo  argomento\ndella funzione  HEADER_NOT_FOUND\n");
     free(Ptr1);
     return(TEST_FAILED);
    }
  }
  
 

 //CONTROLLO SE IL SECONDO ARGOMENTO E NULL
 if(argomento==1){
   if((tipo_di_test==2)&&(argomento==1)){
    int dim5=500;
    char *prova5="pippo";
    char *Ptr5=NULL;
    result=estraiHeaders(prova5,Ptr5,dim5);
   
    if(tipo_di_test==result){
      result=0;
      
      return(TEST_PASSED);
    }
    else{
     printf("Funzione testata era: estraiHeaders(email,NULL,dim)\n");
     printf("Risultato atteso era: NULL_POINTER\n");
     printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
     printf("La funzione estraiHeaders non controlla se il primo  argomento\ndella funzione  NULL\n");
     
     result=0;
     return(TEST_FAILED);
    }
  }
 }
 
 if(argomento==1){  
   if((tipo_di_test!=2)&&(tipo_di_test!=0)){
     return(NOT_VALID);
   }else{
     if(tipo_di_test==0){
       return(NOT_IMPLEMENTED);
     }
   }
 }
 

  //CONTROLLO SE IL BUFFER  TROPPO PICCOLO
  if((tipo_di_test==8)&&(argomento==2)){
    int dim6=2;
    int dim7=500;
    char *test6="pippo";
    char *prova6="pluto";
    if(test6==NULL){
      return(MEM_ALLOC_ERROR);
    }
    result=estraiHeaders(prova6,test6,dim6);
   
    if(tipo_di_test==result){
      result=0;
      return(TEST_PASSED);
    }else{
      printf("Funzione testata era: estraiHeaders(nomefile,test,%d)\n",dim6);
      printf("Risultato atteso era: BUFFER_TOO_SMALL\n");
      printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
      printf("La funzione estraiHeaders non controlla se il terzo argomento\ndella funzione  BUFFER_TO_SMALL\n");
      result=0;
      return(TEST_FAILED);
    }
  }
  
  
  if(argomento==2){
    if((tipo_di_test!=8)&&(tipo_di_test!=0)){
      return(NOT_VALID);
    }else{
      if(tipo_di_test==0){
	return(NOT_IMPLEMENTED);
      }
    }
  }

   if(argomento>2||argomento<0){
    return(ARG_MISSING);
  }

}

//--------------------------------------------------------------------------------------------------------------------------------------------------

//ESEGUO I TEST SU PRIMO HEADERS
int test_primoHeader(int tipo_di_test, int argomento){
 int result=0;//variabile per il risultato
  //FACCIO PRIMA I TEST SUL PRIMO ARGOMENTO
  if(argomento==0){
   
    if((tipo_di_test==2)&&(argomento==0)){
      int dim2=500;
      char *prova2=NULL;
      char *Ptr=NULL;
      prova2=(char *)malloc(sizeof(char)*dim2);
      if(prova2==NULL){
	return(MEM_ALLOC_ERROR);
      }
      result=primoHeader(Ptr,prova2,dim2);
      
     
      if(tipo_di_test==result){
	result=0;
	return(TEST_PASSED);
      }
      else{
	printf("Funzione testata era: primoHeader(NULL,headers,dim)\n");
	printf("Risultato atteso era: NULL_POINTER\n");
	printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
	printf("La funzione primoHeader non controllo se il primo  argomento\ndella funzione  NULL\n");
	free(prova2);
	result=0;
	return(TEST_FAILED);
      }
    }
  
    if((tipo_di_test==1)||(tipo_di_test==4)||(tipo_di_test==5)||
       (tipo_di_test==6)||(tipo_di_test==7)||(tipo_di_test==8)||
       (tipo_di_test==10)||(tipo_di_test==11)||(tipo_di_test==12)){
      return(NOT_VALID);
    }else{
      if(tipo_di_test==0){
	return(NOT_IMPLEMENTED);
      }
    }
  }

  //CONTROLLO SE LA STRINGA  VUOTA
  if((tipo_di_test==3)&&(argomento==0)){
    char *stringa="";
    int dim3=50;
    char *Ptr=NULL;
    Ptr=(char *)malloc(sizeof(char)*dim3);
    result=primoHeader(stringa,Ptr,50);
    
    if(tipo_di_test==result){
      result=0;
      free(Ptr);
      return(TEST_PASSED);
    }else{
      printf("Funzione testata era: primoHeader(email,headers,dim)\n");
      printf("Risultato atteso era: EMPTY_STRING\n");
      printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
      printf("La funzione primoHeader non controlla se il primo  argomento\ndella funzione  EMPTY_STRING\n");
      free(Ptr);
      return(TEST_FAILED);
    }
  
  }

  //CONTROLLO SE IL SECONDO ARGOMENTO E NULL
  if(argomento==1){
    if((tipo_di_test==2)&&(argomento==1)){
      int dim5=500;
      char *prova5="pippo";
      char *Ptr5=NULL;
      result=primoHeader(prova5,Ptr5,dim5);
      if(tipo_di_test==result){
	result=0;
	return(TEST_PASSED);
      }
      else{
	printf("Funzione testata era: primoHeader(email,NULL,dim)\n");
	printf("Risultato atteso era: NULL_POINTER\n");
	printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
	printf("La funzione primoHeader non controlla se il secondo  argomento\ndella funzione  NULL\n");
     
	result=0;
	return(TEST_FAILED);
      }
    }
  
    if((tipo_di_test!=2)&&(tipo_di_test!=0)){
      return(NOT_VALID);
    }else{
      return(NOT_IMPLEMENTED);
    }
  }
  //CONTROLLO SE L'HEADER  STATO TROVATO

 if((tipo_di_test==9)&&(argomento==0)){
    char *stringa1="pippo";
    int dim4=50;
    char *Ptr1=NULL;
    Ptr1=(char *)malloc(sizeof(char)*dim4);
    result=primoHeader(stringa1,Ptr1,50);
    if(tipo_di_test==result){
      result=0;
      free(Ptr1);
      return(TEST_PASSED);
    }else{
     printf("Funzione testata era: primoHeaders(email,headers,dim)\n");
     printf("Risultato atteso era: HEADER_NOT_FOUND\n");
     printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
     printf("La funzione primoHeader non controlla se il primo  argomento\ndella funzione  HEADER_NOT_FOUND\n");
     free(Ptr1);
     return(TEST_FAILED);
    }
  }
  
//CONTROLLO SE IL BUFFER  TROPPO PICCOLO
  if((tipo_di_test==8)&&(argomento==2)){
    int dim6=2;
    int dim7=500;
    char *test6="pippo";
    char *prova6="pluto";
    if(test6==NULL){
      return(MEM_ALLOC_ERROR);
    }
    result=primoHeader(prova6,test6,dim6);
    
    if(tipo_di_test==result){
      result=0;
      return(TEST_PASSED);
    }else{
      printf("Funzione testata era: primoHeader(email,headers,%d)\n",dim6);
      printf("Risultato atteso era: BUFFER_TOO_SMALL\n");
      printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
      printf("La funzione primoHeader non controlla se il terzo argomento\ndella funzione  BUFFER_TO_SMALL\n");
      result=0;
      return(TEST_FAILED);
    }
  }
  
  if(argomento==2){
    if((tipo_di_test!=8)&&(tipo_di_test!=0)){
      return(NOT_VALID);
    }else{
      if(tipo_di_test==0){
	return(NOT_IMPLEMENTED);
      }
    }
  }

   if(argomento>2||argomento<0){
    return(ARG_MISSING);
  }




}//chiusura funzione test


//-------------------------------------------------------------------------------------------------------------------------------------------------------------


// ESEGUO I TEST SULLA PARSEHEADER
int test_parseHeader(int tipo_di_test, int argomento){
 int result=0;//variabile per il risultato
  //FACCIO PRIMA I TEST SUL PRIMO ARGOMENTO
  if(argomento==0){
   
    if((tipo_di_test==2)&&(argomento==0)){
      int dim2=50;
      int dimt=50;
      int dimv=50;
      char *header=NULL;
      char *prova2=NULL;
      char *tipo=NULL;
      char *valore=NULL;
      tipo=(char *)malloc(sizeof(char *)*dimt);
      valore=(char *)malloc(sizeof(char *)*dimv);
      prova2=(char *)malloc(sizeof(char)*dim2);
      if(prova2==NULL){
	return(MEM_ALLOC_ERROR);
      }
      if(tipo==NULL){
	return(MEM_ALLOC_ERROR);
      }
      if(valore==NULL){
	return(MEM_ALLOC_ERROR);
      }
      result=parseHeader(header,tipo,dimt,valore,dimv);
      
      if(tipo_di_test==result){
	result=0;
	free(tipo);
	free(valore);
	return(TEST_PASSED);
      }
      else{
	printf("Funzione testata era: parseHeader(NULL,tipo,dimt,valore,dimv)\n");
	printf("Risultato atteso era: NULL_POINTER\n");
	printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
	printf("La funzione parseHeader non controlla se il primo  argomento\ndella funzione  NULL\n");
	free(tipo);
	free(valore);
	result=0;
	return(TEST_FAILED);
      }
    }
  
    if((tipo_di_test==1)||(tipo_di_test==4)||(tipo_di_test==5)||
       (tipo_di_test==6)||(tipo_di_test==7)||(tipo_di_test==8)||
       (tipo_di_test==9)||(tipo_di_test==10)||(tipo_di_test==12)){
      return(NOT_VALID);
    }else{
      if((tipo_di_test==0)||(tipo_di_test==11)){
	return(NOT_IMPLEMENTED);
      }
    }
  }

 //CONTROLLO SE LA STRINGA  VUOTA
  if((tipo_di_test==3)&&(argomento==0)){
    char *stringa="";
    int dimt3=50;
    int dimv3=50;
    char *tipo1=NULL;
    char *valore1=NULL;
    tipo1=(char *)malloc(sizeof(char)*dimt3);
    valore1=(char *)malloc(sizeof(char)*dimv3);
    if(tipo1==NULL){
      return(MEM_ALLOC_ERROR);
    }
    if(valore1==NULL){
      return(MEM_ALLOC_ERROR);
    }
    result=parseHeader(stringa,tipo1,dimt3,valore1,dimv3);
    result=1;
    if(tipo_di_test==result){
      
      free(tipo1);
      free(valore1);
      return(TEST_PASSED);
    }else{
      printf("Funzione testata era: primoHeader(headers,tipo,dimt,valore,dimv)\n");
      printf("Risultato atteso era: EMPTY_STRING\n");
      printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
      printf("La funzione primoHeader non controlla se il primo  argomento\ndella funzione  EMPTY_STRING\n");
      free(tipo1);
      free(valore1);
      return(TEST_FAILED);
    }
  
  }
  
 


  

 //CONTROLLO SE IL SECONDO ARGOMENTO E NULL
  if(argomento==1){
    if((tipo_di_test==2)&&(argomento==1)){
      int dim5=500;
      int dimt5=500;
      int dimv5=500;
      char *prova5="pippo";
      char *tipo5=NULL;
      char *valore5=NULL;
      valore5=(char *)malloc(sizeof(char *)*dimv5);
      if(valore5==NULL){
	return(MEM_ALLOC_ERROR);
      }
      result=parseHeader(prova5,tipo5,dimt5,valore5,dimv5);
      
      if(tipo_di_test==result){
	free(valore5);
	result=0;
	return(TEST_PASSED);
      }
      else{
	printf("Funzione testata era: parseHeader(header,tipo,dimt,valore,dimv)\n");
	printf("Risultato atteso era: NULL_POINTER\n");
	printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
	printf("La funzione parseHeader non controlla se il secondo  argomento\ndella funzione  NULL\n");
     
	result=0;
	free (valore5);
	return(TEST_FAILED);
      }
    }
  
    if((tipo_di_test!=2)&&(tipo_di_test!=0)){
      return(NOT_VALID);
    }else{
      if(tipo_di_test==0){
	return(NOT_IMPLEMENTED);
      }
    }  
  }

  //CONTROLLO SE IL BUFFER  TROPPO PICCOLO
  if(argomento==2){
    if((tipo_di_test==8)&&(argomento==2)){
      int dimt6=2;
      int dimv6=500;
      char *test6="pippo";
      char *tipo6="pluto";
      char *valore6="minnie";
      result=parseHeader(test6,tipo6,dimt6,valore6,dimv6);
      
      if(tipo_di_test==result){
	result=0;
	return(TEST_PASSED);
      }else{
	printf("Funzione testata era: parseHeader(header,tipo,%d,valore,dimv)\n",dimt6);
	printf("Risultato atteso era: BUFFER_TOO_SMALL\n");
	printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
	printf("La funzione parseHeader non controlla se il terzo argomento\ndella funzione  BUFFER_TO_SMALL\n");
	result=0;
	return(TEST_FAILED);
      }
    }
  
  
    if((tipo_di_test!=8)&&(tipo_di_test!=0)){
      return(NOT_VALID);
    }else
      if(tipo_di_test==0){
	return(NOT_IMPLEMENTED);
      }
  }

  //CONTROLLO SE IL VALORE  NULL 
  if(argomento==3){
    if((tipo_di_test==2)&&(argomento==3)){
      int dim7=500;
      int dimt7=500;
      int dimv7=500;
      char *prova7="pippo";
      char *tipo7=NULL;
      char *valore7=NULL;
      tipo7=(char *)malloc(sizeof(char *)*dimt7);
      if(tipo7==NULL){
	return(MEM_ALLOC_ERROR);
      }
      result=parseHeader(prova7,tipo7,dimt7,valore7,dimv7);
      if(tipo_di_test==result){
	free(tipo7);
	result=0;
	return(TEST_PASSED);
      }
      else{
	printf("Funzione testata era: parseHeader(header,tipo,dimt,valore,dimv)\n");
	printf("Risultato atteso era: NULL_POINTER\n");
	printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
	printf("La funzione parseHeader non controlla se il quarto  argomento\ndella funzione  NULL\n");
     
	result=0;
	free (tipo7);
	return(TEST_FAILED);
      }
    }
  
    if((tipo_di_test!=2)&&(tipo_di_test!=0)){
      return(NOT_VALID);
    }else{
      if(tipo_di_test==0){
	return(NOT_IMPLEMENTED);
      } 
    }
  }

  //CONTROLLO SE IL BUFFER  TROPPO PICCOLO
  if(argomento==4){
    if((tipo_di_test==8)&&(argomento==4)){
      int dimt8=500;
      int dimv8=2;
      char *test8="pippo";
      char *tipo8="pluto";
      char *valore8="minnie";
      result=parseHeader(test8,tipo8,dimt8,valore8,dimv8);
      if(tipo_di_test==result){
	result=0;
	return(TEST_PASSED);
      }else{
	printf("Funzione testata era: parseHeader(header,tipo,%d,valore,dimv)\n",dimv8);
	printf("Risultato atteso era: BUFFER_TOO_SMALL\n");
	printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
	printf("La funzione parseHeader non controlla se il quinto argomento\ndella funzione  BUFFER_TO_SMALL\n");
	result=0;
	return(TEST_FAILED);
      }
    }
    if((tipo_di_test!=8)&&(tipo_di_test!=0)){
      return(NOT_VALID);
    }else
      if(tipo_di_test==0){
	return(NOT_IMPLEMENTED);
      }
  }  

  if(argomento>4||argomento<0){
    return(ARG_MISSING);
  }



}//CHIUSURA CONTROLLI PARSEHEADER

//--------------------------------------------------------------------------------------------------------------------------------------------------------------

// eseguo un test sulla funzione primaParola
int test_primaParola(int tipo_di_test, int argomento){
 int result=0;//variabile per il risultato
  //FACCIO PRIMA I TEST SUL PRIMO ARGOMENTO
  if(argomento==0){
    if((tipo_di_test==2)&&(argomento==0)){
      int dim2=500;
      char *prova2=NULL;
      char *Ptr=NULL;
      prova2=(char *)malloc(sizeof(char)*dim2);
      
      if(prova2==NULL){
	return(MEM_ALLOC_ERROR);
      }
      result=primaParola(Ptr,prova2,dim2);
      
     
      if(tipo_di_test==result){
	result=0;
	return(TEST_PASSED);
      }
      else{
	printf("Funzione testata era: primaProla(NULL,parola,dim)\n");
	printf("Risultato atteso era: NULL_POINTER\n");
	printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
	printf("La funzione primaParola non controllo se il primo  argomento\ndella funzione  NULL\n");
	free(prova2);
	result=0;
	return(TEST_FAILED);
      }
    }
  
    if((tipo_di_test==4)||(tipo_di_test==5)||
       (tipo_di_test==6)||(tipo_di_test==7)||(tipo_di_test==8)||
       (tipo_di_test==10)||(tipo_di_test==11)||(tipo_di_test==12)){
      
      return(NOT_VALID);
    }else{
      if((tipo_di_test==0)||(tipo_di_test==1)){
	return(NOT_IMPLEMENTED);
      }
    }
  }

  //CONTROLLO SE LA STRINGA  VUOTA
  if((tipo_di_test==3)&&(argomento==0)){
    char *stringa="";
    int dim3=50;
    char *Ptr=NULL;
    Ptr=(char *)malloc(sizeof(char)*dim3);
    result=primaParola(stringa,Ptr,50);
    
    if(tipo_di_test==result){
      result=0;
      free(Ptr);
      return(TEST_PASSED);
    }else{
      printf("Funzione testata era: primaParola(testo,parola,dim)\n");
      printf("Risultato atteso era: EMPTY_STRING\n");
      printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
      printf("La funzione primaParola non controlla se il primo  argomento\ndella funzione  EMPTY_STRING\n");
      free(Ptr);
      return(TEST_FAILED);
    }
  
  }
  
  //CONTROLLO SE IL SECONDO ARGOMENTO E NULL
  if(argomento==1){
    if((tipo_di_test==2)&&(argomento==1)){
      int dim5=500;
      char *prova5="pippo";
      char *Ptr5=NULL;
      result=primaParola(prova5,Ptr5,dim5);
      
      if(tipo_di_test==result){
	result=0;
	return(TEST_PASSED);
      }
      else{
	printf("Funzione testata era: primaParola(email,NULL,dim)\n");
	printf("Risultato atteso era: NULL_POINTER\n");
	printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
	printf("La funzione primaParola non controlla se il secondo  argomento\ndella funzione  NULL\n");
     
	result=0;
	return(TEST_FAILED);
      }
    }
  
    if((tipo_di_test!=2)&&(tipo_di_test!=0)){
      return(NOT_VALID);
    }else{
      if(tipo_di_test==0){
	return(NOT_IMPLEMENTED);
      }
    }
  }
//CONTROLLO SE IL BUFFER  TROPPO PICCOLO
  if((tipo_di_test==8)&&(argomento==2)){
    int dim6=2;
    int dim7=500;
    char *test6="pippo";
    char *prova6="pluto";
    if(test6==NULL){
      return(MEM_ALLOC_ERROR);
    }
    result=primaParola(prova6,test6,dim6);
   
    if(tipo_di_test==result){
      result=0;
      return(TEST_PASSED);
    }else{
      printf("Funzione testata era: primaParola(nomefile,test,%d)\n",dim6);
      printf("Risultato atteso era: BUFFER_TOO_SMALL\n");
      printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
      printf("La funzione primaParola non controllo se il terzo argomento\ndella funzione  BUFFER_TO_SMALL\n");
      result=0;
      return(TEST_FAILED);
    }
  }
  
  if(argomento==2){
    if((tipo_di_test!=8)&&(tipo_di_test!=0)){
      result=0;
      return(NOT_VALID);
    }else{
      if(tipo_di_test==0){
	return(NOT_IMPLEMENTED);
      }
    }
  }
  if(argomento>2||argomento<0){
    return(ARG_MISSING);
  }

}

//--------------------------------------------------------------------------

// TEST SULLA TOKENIZZA EMAIL
int test_tokenizzaEmail(int tipo_di_test, int argomento){
  int result=0;
  if(argomento==0){
    if((tipo_di_test==2)&&(argomento==0)){
      
      Token tokenArray[1000];
      char *Ptr=NULL;
    
      result=tokenizzaEmail(Ptr,tokenArray,1000);
      
        if(tipo_di_test==result){
	result=0;
	return(TEST_PASSED);
      }
      else{
	printf("Funzione testata era: tokenizzaEmail(NULL,tokenArray,dim)\n");
	printf("Risultato atteso era: NULL_POINTER\n");
	printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
	printf("La funzione tokenizzaEmail non controllo se il primo  argomento\ndella funzione  NULL\n");
	
	result=0;
	return(TEST_FAILED);
      }
    }
  
    if((tipo_di_test==1)||(tipo_di_test==4)||(tipo_di_test==5)||
       (tipo_di_test==6)||(tipo_di_test==7)||(tipo_di_test==8)||(tipo_di_test==9)||
       (tipo_di_test==11)){
      return(NOT_VALID);
    }else{
      if((tipo_di_test==0)||(tipo_di_test==10)||(tipo_di_test==12)){
	return(NOT_IMPLEMENTED);
      }
    }
  }

  //CONTROLLO SE LA STRINGA  VUOTA
  if((tipo_di_test==3)&&(argomento==0)){
    char *stringa="";
    Token tokenArray1[1000];
    result=tokenizzaEmail(stringa,tokenArray1,1000);
    if(tipo_di_test==result){
      result=0;
 
      return(TEST_PASSED);
    }else{
      printf("Funzione testata era: primaParola(email,tokeArray,dim)\n");
      printf("Risultato atteso era: EMPTY_STRING\n");
      printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
      printf("La funzione tokenArray non controlla se il primo  argomento\ndella funzione  EMPTY_STRING\n");
     
      return(TEST_FAILED);
    }
  
  }
  
 if(argomento==1){
    if((tipo_di_test==2)&&(argomento==1)){
      
      Token *tokenArray2=NULL;
      char *Ptr2="PIPPO";
    
      result=tokenizzaEmail(Ptr2,tokenArray2,1000);
     
        if(tipo_di_test==result){
	result=0;
	return(TEST_PASSED);
      }
      else{
	printf("Funzione testata era: tokenizzaEmail(email,NULL,dim)\n");
	printf("Risultato atteso era: NULL_POINTER\n");
	printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
	printf("La funzione tokenizzaEmail non controllo se il primo  argomento\ndella funzione  NULL\n");
	
	result=0;
	return(TEST_FAILED);
      }
    }
  
    if((tipo_di_test==1)||(tipo_di_test==4)||(tipo_di_test==5)||
       (tipo_di_test==6)||(tipo_di_test==7)||(tipo_di_test==8)||(tipo_di_test==9)||
       (tipo_di_test==11)){
      return(NOT_VALID);
    }else{
      if((tipo_di_test==0)||(tipo_di_test==10)||(tipo_di_test==12)){
	return(NOT_IMPLEMENTED);
      }
    }
  }	
   
 if(argomento==2){
   if((tipo_di_test==8)||(tipo_di_test==0)){
     return(NOT_IMPLEMENTED);
   }else{
     return(NOT_VALID);
   }
 }
  
 
 
 if(argomento>2||argomento<0){
    return(ARG_MISSING);
  }
    
  


}

// eseguo un test sulla funzione printAllEmailTokens
int test_printTokens(int tipo_di_test, int argomento){
int result=0;

if(argomento==0){
    if((tipo_di_test==2)&&(argomento==0)){
      
      Token *tokenArray2=NULL;
     
    
      result=printTokens(tokenArray2,1000);
      result=3;
        if(tipo_di_test==result){
	
	return(TEST_PASSED);
      }
      else{
	printf("Funzione testata era: printTokens(tokeArray,dim)\n");
	printf("Risultato atteso era: NULL_POINTER\n");
	printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
	printf("La funzione printTokens non controllo se il primo  argomento\ndella funzione  NULL\n");
	
	result=0;
	return(TEST_FAILED);
      }
    }
  
    if((tipo_di_test==1)||(tipo_di_test==4)||(tipo_di_test==5)||
       (tipo_di_test==6)||(tipo_di_test==7)||(tipo_di_test==8)||(tipo_di_test==9)||(tipo_di_test==10)||
       (tipo_di_test==11)||(tipo_di_test==12)){
      return(NOT_VALID);
    }else{
      if((tipo_di_test==0)){
	return(NOT_IMPLEMENTED);
      }
    }
  }	
   
//PRINTOKENS VUOTO
 if(argomento==0){
   
   if((tipo_di_test==3)&&(argomento==0)){
   Token *tokenArray10=NULL;
   int dim10=1000;
   tokenArray10=(Token *)malloc(sizeof(Token)*dim10);
   tokenArray10->contesto='\0';
   tokenArray10->parola='\0';
   result=printTokens(tokenArray10,dim10);
   
   if(result==tipo_di_test){
     return(TEST_PASSED);
   }else{
	printf("Funzione testata era: printTokens(tokenArray,dim)\n");
	printf("Risultato atteso era: EMPTY_STRING\n");
	printf("Risultato ottenuto corrisponde al codice di errore: %d\n",result);
	printf("La funzione printTokens non controllo se il primo  argomento\ndella funzione  EMPTY_STRING\n");
	result=0;
	return(TEST_FAILED);
      }
   }
 }
 
 if(argomento==1){
   if((tipo_di_test!=8)&&(tipo_di_test!=0)){
     return(NOT_VALID);
   }else{
     return(NOT_IMPLEMENTED);
   }
 }

 if((argomento<0)||(argomento>1)){
   return(ARG_MISSING);
 }

}//chiusra funzione che controlla la printTokens

