#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<modulo1.h>
#include<sys/stat.h>
#define MAX 500



int printTokens(Token tokenArray[],int dimt){
  int cont=0;  
  if(dimt<=0)return 8;

while(tokenArray[cont].parola!=NULL){
  if(tokenArray[cont].contesto!=NULL){
    printf("%s*%s\n",tokenArray[cont].contesto,tokenArray[cont].parola);
     }else{
    printf("%s\n",tokenArray[cont].parola);
     }
  cont++;
}
 
}//printToken


int tokenizzaEmail(char*email,Token tokenArray[],int dimT){
 int rt=-1,r=0,x=0;
 int def=50,array=0;
 char testo[MAX];
 char parola[MAX]={"\0"};
 char primohe[MAX]={"\0"};
 char headers[MAX]={"\0"};
 char valore[MAX]={"\0"};
 char tipo[MAX]={"\0"};
 int l=0,sent=0,fr=0,h=0,k;
 
 if(email==NULL)return 2;
 if(*email=='\0')return 3;
 if(dimT<=0)return 8;
 

 rt=estraiHeaders(email,headers,MAX);
 
 
 while(headers[r]!='\0'){
   for(k=0;k<=MAX;k++)parola[k]='\0';
   rt=primoHeader(&headers[r],primohe,MAX);
   parseHeader(primohe,tipo,MAX,valore,MAX);
   h=strlen(valore);
   while(valore[h-1]!=' '){   
     fr=primaParola(valore,parola,MAX);
     tokenArray[array].parola=malloc(def);
     tokenArray[array].contesto=malloc(def);
     strcpy(tokenArray[array].contesto,tipo);
     strcpy(tokenArray[array].parola,parola);
     array++;
   }
   
   r=r+strlen(primohe);
 }
 
 x=strlen(headers);
 r=strlen(email);
 
 while(email[r-1]!=' '){    
   primaParola(&email[x],parola,MAX);  
   tokenArray[array].parola=malloc(def);
   strcpy(tokenArray[array].parola,parola);
   tokenArray[array].contesto=NULL;  
   array++;
 }
 
 
 
 tokenArray[array].parola=NULL;
}



int leggiFile(char* nomefile,int dimensione,char* testo){
  FILE* filePtr;
  int dim=0;
  struct stat control; 
  //controlli di integrità
  if(nomefile == NULL) return 2;
  if(testo== NULL)return 2;
  if(*nomefile=='\0')return 3;
  if((stat(nomefile,&control))!=0)return 4;  
  if(dimensione<=0) return 8;




  if(testo == NULL)return 12;
  //apertura file
  if((filePtr=fopen(nomefile,"r"))==NULL) return 5;
 
  //lettura valori
 
  while((*testo=getc(filePtr))!=EOF){
    ++testo;
    ++dim;
    if(dim>(dimensione-1))return 8;
  }
 //controllo se il file è vuoto
  --testo;
  if(*testo==EOF)return 7;
  //se la stringa non è vuota la chiudo
  *testo='\0';
 

  //chiusura file e funzione
  
  return 0;
  fclose(filePtr);

}//leggiFile


int estraiHeaders(char* email,char* headers,int dimh){
  char* cont=NULL;  
  int contatore=0;
 

  //controlli integrità
 
  if(email==NULL)return 2;
  if(headers==NULL)return 2;
  if(*email=='\0')return 3;
  if(dimh<=0) return 8;
  if((isalnum(*email))==0)return 11;
  cont=email+1;
  //lettura
  
  while((*email!='\n')||(*cont!='\n')){
    if(contatore>(dimh-1))return 8;
    *headers=*email;
    ++contatore;
    ++headers;
    ++email;
    cont=email+1;
  }//while controllo
  *headers='\n';
  ++headers;
  *headers='\0';
  

  return 0;
}//estariHeaders


int primoHeader(char* headers,char* primo_header,int dim){
  char* app=NULL;
  int sent=0,x;
  for(x=0;x<dim;x++)primo_header[x]='\0';
  //controlli integrita  
  if(headers==NULL)return 2;
  if(primo_header==NULL)return 2;
  if(dim<=0)return 8;
  if((isalnum(*headers))==0)return 11;

  app=headers+1;

  while(sent!=-1){
    
    if(*headers=='\n'){

      if((*app!=' ')||(*app!='\t')){      
	sent=-1;
      }
    }
    *primo_header=*headers;
    ++primo_header;
    ++headers;
    app=headers+1;
  }//while
  *primo_header='\0';
  
  
  return 0;
}//primoHeader


int parseHeader(char*header,char*tipo,int dimt,char*valore,int dimv){
  int cont=0,x;
  

  //controlli
  if(header==NULL)return 2;
  if(tipo==NULL)return 2;
  if(valore==NULL)return 2;
  if(dimt<=0)return 8; 
  if(dimv<=0)return 8;
  for(x=0;x<dimt;x++)tipo[x]='\0';
  for(x=0;x<dimv;x++)valore[x]='\0';
 

  //estrazione tipo
  if((*header!=' ')&&(*header!='\t')){  
    while(*header!=' '){
      if(cont>(dimt-1))return 8; 
      *tipo=*header;
      ++cont;
      ++tipo;
      ++header;
      
    }
  }
  *tipo='\0';
  
  cont=0;
  
  while(*header!='\0'){

 
      if(cont>(dimt-1))return 8;
      *valore=*header;  
      ++cont;
      ++header;
      ++valore;
    
    
  }//estrazione valori 
  *valore='\0';
  
  
  
  
  
}//parse header

int primaParola(char*testo,char*parola,int dim){
  int x;
  int cont=0;
  int sent=0;
 
  //controlli
  if(testo==NULL)return 2;
  if(parola==NULL)return 2;
  if(dim<=0)return 8;
 
  //ciclo prendi parole
  while(sent!=-1){
    if((isalnum(*testo))!=0){
      *parola=*testo;
      *testo=' ';
      ++cont;
      ++testo;
      ++parola;
    }else{
      if(cont>=1){
	sent=-1;
      }
      *testo=' ';
      ++testo;
    }
    if(*testo=='\0'){
      // testo[0]='\0';
      //parola[0]='\0';
      sent=-1;
    } 
   
  }//whilecontrollo  
  
  *parola='\0';
  
  
  
  
  
  return 0; 
}//prima parola




