
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

#define TEST_PASSED	0 // il test  andato bene, la funzione si comporta come mi aspettavo
#define TEST_FAILED	1 // il test  fallito, la funzione non si comporta come mi aspettavo
#define ARG_MISSING	2 // la funzione da testare non ha questo argomento
#define NOT_VALID	3 // questo tipo di test non ha senso per questo argomento
#define NOT_IMPLEMENTED	4 // questo test per questo argomento non  stato implementato
#define LAST_TEST	5 // (non usato) numero di codici che sono stati definiti
/*
int test_leggiFile(int , int );
int test_estraiHeaders(int , int );
int test_primoHeader(int , int );
int test_parseHeader(int , int );
int test_primaParola(int , int );
int test_tokenizzaEmail(int , int);
int test_printTokens(int , int );
*/



//Comunque non capisco a cosa servono queste funzioni di TEST!!!!!!!!!

int test_leggiFile(int tipo_di_test, int argomento)
{ int dim=500;//Dimensione MAX di caratteri dell'email
  //E' evidente ke se si cerca di leggere un'email + grande di 500 la funzione SBALLA
  int val=-1;
  char test[dim];
  char *nome="email1.txt";//Viene aperta l'email di nome: "email1.txt"
  if((tipo_di_test==5)||(tipo_di_test==7))
   { printf("Non sapendo se potevo creare 1file non ho inplementato questo tipo di test!\nTest su leggiFile-->tipo_di_test=%d\n",tipo_di_test);
      return(NOT_IMPLEMENTED);
   }
  if(tipo_di_test==12)
   return(NOT_IMPLEMENTED);
  if(tipo_di_test>8)
   return(NOT_VALID);
  if(argomento>2)
   return(ARG_MISSING);
  if(tipo_di_test==0)
   { val=leggiFile(nome,dim,test);
     if(val==0)
      return(TEST_PASSED);
     else return(NOT_VALID);
   }
  if(tipo_di_test==1) return(NOT_VALID);
  if(tipo_di_test==2)
   { if(argomento==0)
      { nome=NULL;
        val=leggiFile(nome,dim,test);
        if(val==2)
         return(TEST_PASSED);
      }
   }
  if(tipo_di_test==2)
    if(argomento==1)
       return(NOT_VALID);
  if(tipo_di_test==2)
   { if(argomento==2)
      { char *test1=NULL;
        val=leggiFile(nome,dim,test1);
        if(val==2)
         return(TEST_PASSED);
      }
   }
  if(tipo_di_test==3)
   { if(argomento==0)
      { char nome1[2];
        nome1[0]='\0';
        val=leggiFile(nome1,dim,test);
        if(val==3)
         return(TEST_PASSED);
      }
   }
  if(tipo_di_test==3)
    if((argomento==1)||(argomento==2))
      return(NOT_VALID);
  if(tipo_di_test==4)
   { char *nome2="non_esisto.nnes";
     val=leggiFile(nome2,dim,test);
     if(val==4)
       return(TEST_PASSED);
   }
  if(tipo_di_test==6) return(NOT_VALID);
  if(tipo_di_test==8)
   { dim=1;
     val=leggiFile(nome,dim,test);
     if(val==8)
       return(TEST_PASSED);
   }
}

int test_estraiHeaders(int tipo_di_test, int argomento)
{ int dim=500;//Dimensione MAX di caratteri dell'email
  //E' evidente ke se si cerca di leggere un'email + grande di 500 la funzione SBALLA
  int dim1=200;//Dimensione MAX di caratteri degli headers
  int val=-1;
  char test[dim],head[dim1];
  char *nome="email1.txt";//Viene aperta l'email di nome: "email1.txt"
  leggiFile(nome,dim,test);
  if(argomento>2)
   return(ARG_MISSING);
  if(tipo_di_test==12)
   return(NOT_IMPLEMENTED);
  if(tipo_di_test==0)
   { val=estraiHeaders(test,head,dim1);
     if(val==0)
      return(TEST_PASSED);
     else return(NOT_VALID);
   }
  if(tipo_di_test==1) return(NOT_VALID);
  if(tipo_di_test==2)
   { if(argomento==0)
      { char *test1=NULL;
        val=estraiHeaders(test1,head,dim1);
        if(val==2)
         return(TEST_PASSED);
      }
   }
  if(tipo_di_test==2)
    if(argomento==2)
       return(NOT_VALID);
  if(tipo_di_test==2)
   { if(argomento==1)
      { char *head1=NULL;
        val=estraiHeaders(test,head1,dim1);
        if(val==2)
         return(TEST_PASSED);
      }
   }
  if(tipo_di_test==3)
   { if(argomento==0)
      { char nome1[2];
        nome1[0]='\0';
        val=estraiHeaders(nome1,head,dim1);
        if(val==3)
         return(TEST_PASSED);
      }
   }
  if(tipo_di_test==3)
    if((argomento==1)||(argomento==2))
      return(NOT_VALID);
  if((tipo_di_test==4)||(tipo_di_test==5)||(tipo_di_test==6)||(tipo_di_test==7))
    return(NOT_VALID);
  if(tipo_di_test==8)
   { dim1=1;
     val=estraiHeaders(test,head,dim1);
     if(val==8)
       return(TEST_PASSED);
   }
   if((tipo_di_test==9)||(tipo_di_test==10)||(tipo_di_test==11))
    { printf("Non sapendo se potevo creare 1file non ho inplementato questo tipo di test!\nTest su estraiHeaders-->tipo_di_test=%d\n",tipo_di_test);
      return(NOT_IMPLEMENTED);
    }
}

int test_primoHeader(int tipo_di_test, int argomento)
{ int dim=500;//Dimensione MAX di caratteri dell'email
  //E' evidente ke se si cerca di leggere un'email + grande di 500 la funzione SBALLA
  int dim1=200;//Dimensione MAX di caratteri degli headers
  int dim2=50; //Dimensione MAX di caratteri del primo header
  int val=-1;
  char test[dim],head[dim1],primo_h[dim2];
  char *nome="email1.txt";//Viene aperta l'email di nome: "email1.txt"
  leggiFile(nome,dim,test);
  estraiHeaders(test,head,dim1);
  if(argomento>2)
   return(ARG_MISSING);
  if(tipo_di_test==0)
   { val=primoHeader(head,primo_h,dim2);
     if(val==0)
      return(TEST_PASSED);
     else return(NOT_VALID);
   }
  if(tipo_di_test==1) return(NOT_VALID);
  if(tipo_di_test==2)
   { if(argomento==0)
      { char *test1=NULL;
        val=primoHeader(test1,primo_h,dim2);
        if(val==2)
         return(TEST_PASSED);
      }
   }
  if(tipo_di_test==2)
    if(argomento==2)
       return(NOT_VALID);
  if(tipo_di_test==2)
   { if(argomento==1)
      { char *test1=NULL;
        val=primoHeader(head,test1,dim2);
        if(val==2)
         return(TEST_PASSED);
      }
   }
  if(tipo_di_test==3)
   { if(argomento==0)
      { char nome1[2];
        nome1[0]='\0';
        val=primoHeader(nome1,primo_h,dim2);
        if(val==3)
         return(TEST_PASSED);
      }
   }
  if(tipo_di_test==3)
    if((argomento==1)||(argomento==2))
      return(NOT_VALID);
  if((tipo_di_test==4)||(tipo_di_test==5)||(tipo_di_test==6)||(tipo_di_test==7))
    return(NOT_VALID);
  if(tipo_di_test==8)
   { dim1=1;
     val=primoHeader(head,primo_h,dim1);
     if(val==8)
       return(TEST_PASSED);
   }
  if(tipo_di_test==12)
   return(NOT_IMPLEMENTED);
  if(tipo_di_test>8)
   return(NOT_VALID);
}

int test_parseHeader(int tipo_di_test, int argomento)
{ int dim=500;//Dimensione MAX di caratteri dell'email
  //E' evidente ke se si cerca di leggere un'email + grande di 500 la funzione SBALLA
  int dim1=200;//Dimensione MAX di caratteri degli headers
  int dim2=65; //Dimensione MAX di caratteri del primo header
  int dimt=10; //Dimensione MAX di caratteri del tipo di header
  int dimv=50; //Dimensione MAX di caratteri dei valori degli headers
  int val=-1;
  char test[dim],head[dim1],primo_h[dim2],tip[dimt],valor[dimv];
  char *nome="email1.txt";//Viene aperta l'email di nome: "email1.txt"
  leggiFile(nome,dim,test);
  estraiHeaders(test,head,dim1);
  primoHeader(head,primo_h,dim2);
  if(argomento>4)
   return(ARG_MISSING);
  if(tipo_di_test==0)
   { val=parseHeader(primo_h,tip,dimt,valor,dimv);
     if(val==0)
      return(TEST_PASSED);
     else return(NOT_VALID);
   }
  if(tipo_di_test==1) return(NOT_VALID);
  if(tipo_di_test==2)
   { if(argomento==0)
      { char *test1=NULL;
        val=parseHeader(test1,tip,dimt,valor,dimv);
        if(val==2)
         return(TEST_PASSED);
      }
   }
  if(tipo_di_test==2)
    if((argomento==2)||(argomento==4))
       return(NOT_VALID);
  if(tipo_di_test==2)
   { if(argomento==1)
      { char *test1=NULL;
        val=parseHeader(primo_h,test1,dimt,valor,dimv);
        if(val==2)
         return(TEST_PASSED);
      }
   }
  if(tipo_di_test==2)
   { if(argomento==3)
      { char *test1=NULL;
        val=parseHeader(primo_h,tip,dimt,test1,dimv);
        if(val==2)
         return(TEST_PASSED);
      }
   }
  if(tipo_di_test==3)
   { if(argomento==0)
      { char nome1[2];
        nome1[0]='\0';
        val=parseHeader(nome1,tip,dimt,valor,dimv);
        if(val==3)
         return(TEST_PASSED);
      }
   }
  if(tipo_di_test==3)
    if(argomento>0)
      return(NOT_VALID);
  if((tipo_di_test==4)||(tipo_di_test==5)||(tipo_di_test==6)||(tipo_di_test==7))
    return(NOT_VALID);
  if(tipo_di_test==8)
   { if(argomento==2)
      { dim1=1;
        val=parseHeader(primo_h,tip,dim1,valor,dimv);
        if(val==8)
          return(TEST_PASSED);
      }
     if(argomento==4)
      { dim1=1;
        val=parseHeader(primo_h,tip,dimt,valor,dim1);
        if(val==8)
          return(TEST_PASSED);
      }
     else return(NOT_VALID);
   }
  if(tipo_di_test==12)
   return(NOT_IMPLEMENTED);
  if(tipo_di_test>8)
   return(NOT_VALID);
}

int test_primaParola(int tipo_di_test, int argomento)
{ int dim=500;//Dimensione MAX di caratteri dell'email
  //E' evidente ke se si cerca di leggere un'email + grande di 500 la funzione SBALLA
  int dim1=200;//Dimensione MAX di caratteri degli headers
  int dim2=65; //Dimensione MAX di caratteri del primo header
  int dimt=10; //Dimensione MAX di caratteri del tipo di header
  int dimv=50; //Dimensione MAX di caratteri dei valori degli headers
  int dim3=20; //Dimensione MAX di caratteri di una parola
  int val=-1;
  char test[dim],head[dim1],primo_h[dim2],tip[dimt],valor[dimv],par[dim3];
  char *nome="email1.txt";//Viene aperta l'email di nome: "email1.txt"
  leggiFile(nome,dim,test);
  estraiHeaders(test,head,dim1);
  primoHeader(head,primo_h,dim2);
  parseHeader(primo_h,tip,dimt,valor,dimv);
  if(argomento>2)
   return(ARG_MISSING);
  if(tipo_di_test==0)
   { val=primaParola(valor,par,dim3);
     if(val==0)
      return(TEST_PASSED);
     else return(NOT_VALID);
   }
  if(tipo_di_test==2)
   { if(argomento==0)
      { char *test1=NULL;
        val=primaParola(test1,par,dim3);
        if(val==2)
         return(TEST_PASSED);
      }
   }
  if(tipo_di_test==2)
    if(argomento==2)
       return(NOT_VALID);
  if(tipo_di_test==2)
   { if(argomento==1)
      { char *test1=NULL;
        val=primaParola(valor,test,dim3);
        if(val==2)
         return(TEST_PASSED);
      }
   }
  if(tipo_di_test==3)
   { if(argomento==0)
      { char nome1[2];
        nome1[0]='\0';
        val=primaParola(nome1,par,dim3);
        if(val==3)
         return(TEST_PASSED);
      }
   }
  if(tipo_di_test==3)
    if((argomento==1)||(argomento==2))
      return(NOT_VALID);
  if((tipo_di_test==4)||(tipo_di_test==5)||(tipo_di_test==6)||(tipo_di_test==7))
    return(NOT_VALID);
  if(tipo_di_test==8)
   { dim1=1;
     val=primaParola(valor,par,dim1);
     if(val==8)
       return(TEST_PASSED);
   }
  if(tipo_di_test==12)
   return(NOT_IMPLEMENTED);
  if(tipo_di_test>8)
   return(NOT_VALID);
  if(tipo_di_test==1)
    { printf("Non sapendo se potevo creare 1file non ho inplementato questo tipo di test!\nIl programma segnala se non ci sono PAROLE nel testo ma solo caratteri NON alfanumerici e restituisce il valore UNKNOWN_ERROR\nTest su primaParola-->tipo_di_test=%d\n",tipo_di_test);
      return(NOT_IMPLEMENTED);
    }
}

int test_tokenizzaEmail(int tipo_di_test, int argomento)
{ if(argomento>2)
   return(ARG_MISSING);
  else return(NOT_IMPLEMENTED);

}

int test_printTokens(int tipo_di_test, int argomento)
{ if(argomento>2)
   return(ARG_MISSING);
  if(tipo_di_test==2)
   return(NOT_IMPLEMENTED);
  else
   return(NOT_VALID);
}


