#include "testModulo1.h"
#include "modulo1.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
void shift(char *array,int spiazzamento);//elimina il contenuto di un array gi letto

int leggiFile(char* nomefile,int dimensione,char* testo)
{FILE* fp;
 int i=0,copia_terminata=0;
 
	if(nomefile==NULL)	//contollare !!!!!!
	  return NULL_POINTER;	
	if(nomefile[0]=='\0')	// la stringa nomefile  vuota
	  return EMPTY_STRING;	
	if((fp=fopen(nomefile,"r"))==NULL)// il file non esiste
	  return FILE_MISSING;	//implementare il giusto codice !!!!!!!
	if(getc(fp)==EOF)		// il file  vuoto implementare
	  return FILE_EMPTY;
	else rewind(fp);
	  while(copia_terminata==0)
	   { testo[i]=getc(fp);
	     if(testo[i]==EOF||i>=dimensione-1)
	      {copia_terminata=1;}
	     i++;
	   }
	testo[i-1]='\0';
	 //printf("%s\n",testo);	//eliminare
	fclose(fp);
	return RESULT_OK;
}

int estraiHeaders(char* email,char* headers,int dimh)
{int headers_riconosciuti=0;
 int i=0;
 	if(email==NULL)
	  return NULL_POINTER;	
	if(email[0]=='\0')	// un argomento  vuoto
	  return EMPTY_STRING;	
	while(headers_riconosciuti==0)
	  { while(email[i]!='\n')	//copia headers fino al \n
	     { if(email[i]=='\0')
	        return HEADER_NOT_FOUND;	//non sono stati trovati headers 
	       if(dimh<=i)
	       {return BUFFER_TOO_SMALL;} //dimh insufficiente
	       headers[i]=email[i];i++;
	     }
	   headers[i]=email[i];i++;
	   if(email[i]=='\n')
	     headers_riconosciuti=1;	//headers riconosciuto correttamente
	  }
	i++;	headers[i]='\0';
//	printf("%s\n",headers);	//eliminare
	shift(email,i);
//	printf("%s",email);
	return RESULT_OK;	
}

int primoHeader(char* headers,char *primo_header,int dim)
{int i=0;
 int primo_riconosciuto=0;

	if(headers[0]=='\0')		// un argomento  vuoto
	   return EMPTY_STRING;	
	if(headers[i]==':'||headers[i]==' ') //controlla se la 1riga  corretta 
	   return BAD_HEADER;	
	while(primo_riconosciuto==0)
	 { while(headers[i]!='\n')	//copia tutta la riga
	    { if(headers[i]=='\0')		//header non esiste
	       {return HEADER_NOT_FOUND;}
	      if(i>=dim-1)			//spazio insufficiente
	       {return BUFFER_TOO_SMALL;}
	      primo_header[i]=headers[i];i++;
	    }
	   primo_header[i]=headers[i];i++;//copia \n
	   if((headers[i]!=' ')&&(headers[i]!='\t'))// se non trova \t o ' '
	     {primo_riconosciuto=1;}		  // primo_header  terminato
	 }
	primo_header[i]='\0';
	//printf("primo_header=%s",primo_header);	//eliminare
	shift(headers,i);
	//printf("%s",headers);
	return RESULT_OK;
}

int parseHeader(char* header,char* tipo,int dimt,char *valore, int dimv)
{int i=0,j=0;

	if(header[0]=='\0')		// un argomento  vuoto
	  return EMPTY_STRING;	
	while(header[i]!=' ')		//copia il tipo
	  { if(dimt-1<=i)
	     {return BUFFER_TOO_SMALL;}	//buffer insufficiente
	    tipo[i]=header[i];i++;
	  }
	    tipo[i]='\0';i++;
	    while(header[i]!='\0')		//copia il valore
	     { if(dimv-1<=j)
	        {return BUFFER_TOO_SMALL;}	//buffer insufficiente
	       valore[j]=header[i];i++;j++;
	     }
	    valore[j]='\0';		//termina la stringa valore
	//printf("%s\n%s\n",tipo,valore);
	return RESULT_OK;
}

int primaParola(char* testo,char* parola,int dim)
{int i=0,j=0;
	if(testo[0]=='\0')		// un argomento  vuoto
	  return EMPTY_STRING;	
	while(!isalnum(testo[i])&&testo[i]!='\0')	//salta i separatori iniziali
	  { i++;}
	while(isalnum(testo[i]))	//copia la parola
	  { if(dim-1<=j)
	     {return BUFFER_TOO_SMALL;}	//buffer insufficiente
	    parola[j]=testo[i];i++;j++;
	  }
	while(!isalnum(testo[i])&&testo[i]!='\0')	//salta i separatori finali
	  { i++;}

	parola[j]='\0';			//termina parola
	//printf("parola=%s\n",parola);
	shift(testo,i);		//cancella la prima parola da testo
	return RESULT_OK;
}

int tokenizzaEmail(char* email,Token tokenArray[],int dimT)
{char headers[dimT];
 char primo_header[dimT];
 char tipo[dimT];
 char valore[dimT];
 char parola[dimT]; 
 int i=0,var=-1,dim,dimv;

 	if(tokenArray == NULL) return NULL_POINTER;
 	var=estraiHeaders(email,headers,dimT);
dim=strlen(headers);	
	if(var!=0)return var;
	while(headers[0]!='\0')//separa i tre header
	  { var=primoHeader(headers,primo_header,dim);
dimv=strlen(primo_header);		  
	    if(var!=0)return var;
	    var=parseHeader(primo_header,tipo,dimv,valore,dimv);
	    if(var!=0)return var;
	//carica Token con tipo e valore degli headers
	  while(valore[0]!='\0')
	   { tokenArray[i].contesto=malloc(sizeof(dimv));
	     if(tokenArray[i].contesto==NULL){return MEM_ALLOC_ERROR;}	 //non  possibile allocare memoria  
	     tokenArray[i].parola=malloc(sizeof(dimv));
	     if(tokenArray[i].parola==NULL){return MEM_ALLOC_ERROR;;}	//non  possibile allocare memoria  
  	     
	     var=primaParola(valore,tokenArray[i].parola,dimv);
 	     if(var!=0)return var;//se una funzione genera un errore lo ritorna
	     strcpy(tokenArray[i].contesto,tipo);//tokenizza i tre header
 	     i++;
	   }
	 }
	//carica Token con le parole di body
	if(email[0]=='\0'){return BODY_NOT_FOUND;}
	while(email[0]!='\0')//carica Token con le parole del corpo email
	  {tokenArray[i].contesto=malloc(sizeof(dimv));
	   if(tokenArray[i].contesto==NULL){return MEM_ALLOC_ERROR;;}	//non  possibile allocare memoria  
	  
	   tokenArray[i].parola=malloc(sizeof(dimv));
	   if(tokenArray[i].parola==NULL){return MEM_ALLOC_ERROR;;}//non  possibile allocare memoria  

	   var=primaParola(email,tokenArray[i].parola,dimv);
	   if(var!=0)return var;//se una funzione genera un errore lo ritorna
	   tokenArray[i].contesto=NULL;
	   i++;
	  }

	tokenArray[i].parola=NULL;
	tokenArray[i].contesto=NULL;
	var=printTokens(tokenArray,i);
	if(var!=0)return var;
	return RESULT_OK;
}

int printTokens(Token tokenArray[],int dimT)
{int i=0;
	
	for(i=0;i<dimT;i++)
	{ if(tokenArray[i].contesto!=NULL){printf("%s*",tokenArray[i].contesto);}	
	  printf("%s\n",tokenArray[i].parola);	
	}
	return RESULT_OK;
}

void shift(char *array,int spiazzamento)
{int i=0;	
	while(array[spiazzamento]!='\0')
	 {array[i]=array[spiazzamento];
 	  i++;spiazzamento++;
	 }
	array[i]='\0';
}

