#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include "modulo1.h"
#include <ctype.h>




int estraiHeaders(char * email, char * headers, int dimh){  
int kont=0;

if (email==NULL)
return(NULL_POINTER);

if (email[0]=='\0')
return (EMPTY_STRING);
int k=0;
for (;(email[k+1]!='\0')&&((email[k]!='\n')||(email[k+1]!='\n'));k++)
  kont++;
   
if(dimh<kont)
  return(BUFFER_TOO_SMALL);

if(email[0]=='\n'&&email[1]=='\n')
return (HEADER_NOT_FOUND);


for(k=0;(email[k+1]!='\0')&&((email[k]!='\n')||(email[k+1]!='\n'));k++)
{headers[k]=email[k];
}

headers[k]='\n';
headers[k+1]='\0';


return(RESULT_OK);
}


int leggiFile(char * nomefile, int dimensione, char * testo){
int  dimF=0;
char temp;
int j=0;
FILE  *ifp;
if(nomefile==NULL||testo==NULL)
return(NULL_POINTER);

if(nomefile[0]=='\0')
return (EMPTY_STRING);
  if ((ifp = fopen(nomefile, "r")) == NULL)
      return(FILE_MISSING);
 


 for (j = 0; ((temp = getc(ifp)) != EOF); j++);
dimF = j * (sizeof(char));
 if (dimF==0)
return(FILE_EMPTY);

if (dimF > dimensione)
    return(BUFFER_TOO_SMALL);
ifp = fopen(nomefile, "r");
 for (j = 0; j < dimF-1; j++){
   testo[j] = (getc(ifp));}
   testo[j] = '\0';

  return(RESULT_OK);
}



int primoHeader(char * headers, char * primo_header, int dim){
int j=0,val=0;


if ((headers==NULL)||(primo_header==NULL))
return(NULL_POINTER);


if (headers[0]=='\0')
return (EMPTY_STRING);




  
while ((headers[j]!='\n')&&((headers[j+1]!='\t')||(headers[j+1]!=' ')))
  {val++;
   j++;
}

if(dim<val)
  return(8);
 for(j=0;j<val;j++) 
 
primo_header[j]=headers[j];
primo_header[j]='\0'; 
return(RESULT_OK);
}

int parseHeader(char*header,char*tipo,int dimt,char*valore,int dimv)
{int i=0,val;
int lung=0;    						
int ContT=0; 						
int ContVal=0;						
int k=0;						

if (header==NULL||tipo==NULL||valore==NULL)  		
return(NULL_POINTER);                                   

if (header[0]=='\0')                                    
return (EMPTY_STRING);                                 

lung=strlen(header);                                 
for (i=0;(i<(lung))&&(header[i]!=' ');i++){            
    ContT++;}    
    ContT++;  

if(dimt<ContT)               
return (BUFFER_TOO_SMALL);  


if ((header[0]<'a'&&header[0]>'z')&&(header[0]<'A'&&header[0]>'Z')&&(header[0]<'0'&&header[0]>'9'))
return (BAD_HEADER);


for (i=0;(i<(dimt))&&(header[i]!=' ');i++)
   tipo[i]=header[i];
 tipo[i]='\0';
 val=i;
 

k=i;
for(++k;(k<(val+lung))&&(header[k]!='\0')&&(header[k]!='\t');k++) 
ContVal++;

ContVal=ContVal+1; 
if(dimv<ContVal)           
return (BUFFER_TOO_SMALL);        


int j;
for(j=0,++i;(i<(val+dimv))&&(header[i]!='\0')&&(header[i]!='\t');i++,j++)
{  valore[j]=header[i];
 
}
valore[j]= '\0';

return(0);
    }

int primaParola(char*testo,char*parola,int dim)
{int i;
for (i=0;(testo[i]!='\0')&&((!isalpha(testo[i]))||(!isalpha(testo[i+1])));i++);    

if(testo[i]=='\0')
return(UNKNOWN_ERROR);
int j=0;
while((testo[i]>='a'&&testo[i]<='z')||(testo[i]>='A'&&testo[i]<='Z')||(testo[i]>='0'&&testo[i]<='9'))
{parola[j]=testo[i];
i++;
j++;
}
parola[i]='\0';
return(RESULT_OK);
}







int tokenizzaEmail(char *email, Token tokenArray[], int dimT)
{
int dimEH=200,dim=50, dimt=20, dimv=30,dimp=15;
int dimTip,dimParol,dimValor,dimHeaderz;
int pos,m=0,i, j, k=0;
char headers[dimEH], primo_header[dim], tipo[dimt], valore[dimv],parolina[dimp];
if (email==NULL||tokenArray==NULL)
return(NULL_POINTER);  
if (email[0]=='\0')
return (EMPTY_STRING);
if (dimT==0)
return (BUFFER_TOO_SMALL); 
estraiHeaders(email, headers, dimEH);
dimHeaderz = strlen(headers);
while(k<dimT&&headers[m]!='\0')
{
primoHeader(headers+m, primo_header, dim);
parseHeader(primo_header, tipo, dimt, valore, dimv);
pos=0;
dimValor=strlen(valore);
while (k<dimT&& valore[pos]!='\0')
{
for (;(((!isalpha(valore[pos]))||(!isalpha(valore[pos+1])))&&(valore[pos+1]!='\0'));pos++);    
if(valore[pos+1]=='\0')
break;
primaParola(valore+pos,parolina,dimp);
dimTip = strlen(tipo); 
if((tokenArray[k].contesto =malloc(dimTip*sizeof(char)))==NULL)
return(MEM_ALLOC_ERROR);
for (i=0, j=0; i < dimTip; i++, j++){
tokenArray[k].contesto[j] = tipo[i];}
dimParol = strlen(parolina);
if((tokenArray[k].parola =malloc(dimParol*sizeof(char)))==NULL)
return(MEM_ALLOC_ERROR);
for (i=0; i < dimParol;i++){
tokenArray[k].parola[i] = parolina[i];}
pos=pos+dimParol;
k++;
}
m=m+(strlen(primo_header))+1;
}
if (k==dimT)
{if(!primaParola(valore+pos,parolina,dimp))
return (BUFFER_TOO_SMALL); }
int posbody=dimHeaderz, dimEmail;
char *body = email;
for(i=pos;(!isalpha(email[i]))&&(email[i]!='\0');i++)
if(email[i]=='\0')
return (BODY_NOT_FOUND);
dimEmail = strlen(email) - dimHeaderz;
while ((k<dimT) && (k<dimEmail) && (email[posbody]!='\0')){
for (;((!isalpha(email[posbody]))||((!isalpha(email[posbody+1])))&&((email[posbody+1]!='\0')));posbody++);
if(email[posbody+1]=='\0')
break;
primaParola(email+posbody,parolina,dimp);
tokenArray[k].contesto = NULL;
dimParol = strlen(parolina);
if((tokenArray[k].parola =malloc(dimParol*sizeof(char)))==NULL)
return(MEM_ALLOC_ERROR);
for (i=0; i < dimParol;i++){
tokenArray[k].parola[i] = parolina[i];}
tokenArray[k].parola[i] = '\0';
posbody = posbody + dimParol;
k++;
}
if(k<dimt)
{tokenArray[k].parola=NULL;
tokenArray[k].contesto=NULL;
}
if (k==dimT)
{if(!primaParola(email+posbody,parolina,dimp))
return (BUFFER_TOO_SMALL); }
return(RESULT_OK);
}


int printTokens(Token tokenArray[], int dimT)
{int j=0;
for (j=0;j<dimT&&(tokenArray[j].parola!=NULL);j++)
{if(tokenArray[j].contesto==NULL)
     {printf("%s\n",tokenArray[j].parola);}
else
     {printf("%s*%s\n",tokenArray[j].contesto,tokenArray[j].parola);}
}
}





