#include<stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>

#include<string.h>

/*
#define TEST_PASSED    0       // il test  andato bene, la funzione si comporta come mi aspettavo
#define TEST_FAILED    1       // il test  fallito, la funzione non si comporta come mi aspettavo
#define ARG_MISSING    2       // la funzione da testare non ha questo argomento
#define NOT_VALID              3       // questo tipo di test non ha senso per questo argomento
#define NOT_IMPLEMENTED        4       // questo test per questo argomento non  stato implementato
#define LAST_TEST              5       // (non usato) numero 

#define RESULT_OK               0       // la funzione ha avuto successo
#define UNKNOWN_ERROR           1       // errore sconosciuto
#define NULL_POINTER            2       // uno degli argomenti della funzione era NULL
#define EMPTY_STRING            3       // uno degli argomenti era una stringa vuota
#define FILE_MISSING            4       // il file non esiste
#define FILE_UNREADABLE         5       // il file non  leggibile
#define FILE_UNWRITABLE         6       // il file non  scrivibile
#define FILE_EMPTY              7       // il file  vuoto
#define BUFFER_TOO_SMALL        8       // il blocco di memoria (o vettore) passato non  sufficiente a contenere i dati
#define HEADER_NOT_FOUND        9       // lo header del messaggio non esiste
#define BODY_NOT_FOUND          10      // il corpo del messaggio non esiste
#define BAD_HEADER              11      // una riga degli headers non segue la sintassi giusta
#define MEM_ALLOC_ERROR         12      // non si  potuto allocare un blocco di memoria
#define LAST_CODE               13      // (da non usare) numero di codici di errore definiti

//#include"modulo1.h"
//#include"test_modulo1.h"

typedef struct a_token {
	        char * parola;          // la parola estratta dalla email (headers o body)
		        char * contesto;        // il contesto: nome dello header oppure NULL (body)
			                } Token;

int test_leggiFile(int tipo_di_test, int argomento);

 // eseguo un test sulla funzione estraiHeaders
 int test_estraiHeaders(int tipo_di_test, int argomento);

 // eseguo un test sulla funzione primoHeader
 int test_primoHeader(int tipo_di_test, int argomento);

 // eseguo un test sulla funzione parseHeader
 int test_parseHeader(int tipo_di_test, int argomento);

 // eseguo un test sulla funzione primaParola
 int test_primaParola(int tipo_di_test, int argomento);

 // eseguo un test sulla funzione tokenizzaEmail
 int test_tokenizzaEmail(int tipo_di_test, int argomento);

 // eseguo un test sulla funzione printAllEmailTokens
 int test_printTokens(int tipo_di_test, int argomento);

*/


void p_f(int n); //stampa fallitalo

void p_f(int n)
	{if(n==0)
		{printf("Test Fallito:leggiFile(char * nomefile, int dimensione, char * testo)\nRisultato Atteso:");
		 return;
		}
	if(n==1)
		{printf("Test Fallito:estraiHeaders(char *email, char *headers, int dimh)\nRisultato Atteso:");
		return;	
		}
	if(n==2)
		{printf("Test Fallito:primoHeader(char *headers, char *primo_header, int dim)\nRisultato Atteso:");
                return;
		}
	if(n==3)
		{printf("Test Fallito:parseHeader(char * header, char * tipo, int dimt, char * valore, int dimv)\nRisultato Atteso:");
		 return;
		}
	if(n==4)
		{printf("Test Fallito:primaParola(char * testo, char * parola, int dim)\nRisultato Atteso:");
			                 return;
		}
	if(n==5)
	 	{printf("Test Fallito:tokenizzaEmail(char *email,Token tokenArray[],int dimT)\nRisultato Atteso:");
			                 return;
		}
	}


void p_a(int n);

void p_a(int n) // print argoments
	{if(n==0)
		{printf("RETURN_OK");
		}
	 if(n==1)
	 	{printf("UNKNOWN_ERROR");
		}
	 if(n==2)
	 	{printf("NULL_POINTER");
		}
	 if(n==3)
	 	{printf("EMPTY_STRING");
		}
	 if(n==4)
		{printf("FILE_MISSING");
		}
	 if(n==5)
	 	{printf("FILE_UNREADABLE");
		}
	 if(n==6)
	        {printf("FILE_UNWRITABLE");
		}
	 if(n==7)
                {printf("FILE_EMPTY");
 	        }
	 if(n==8)
		{printf("BUFFER_TOO_SMALL");
		}
	 if(n==9)
                {printf("HEADER_NOT_FOUND");
	        }
	 if(n==10)
		{printf("BODY_NOT_FOUND");
		}
	 if(n==11)
		 {printf("BAD_HEADER");
	         }
	 if(n==12)
		 {printf("MEM_ALLOC_ERROR");
		 }
	}

void p_r(int n);

void p_r(int n)
	{printf("\nRisultato Ottenuto:");
	 p_a(n);
	 return;
	}


void s();

void s(int n)
	{printf("\nSpiegazione: la funzione testa ");
	 p_a(n);
	 printf(" sull'argomento ");
	 return;
	}

//TEST SU LEGGI FILE


int test_leggiFile(int tipo_di_test, int argomento)
{int risultato;
 char *nomefile="email.txt";
 char *nomefalso="pasdasasdastxt"; 
 char *nuovofiler="test_file_r.txt";
 char *nuovofilew1="test_file_w1.txt";
 char *nuovofilew2="test_file_w2.txt";
   
 int dim=1000;
 char *testo;
 FILE *fd;
 testo=(char *)malloc(dim*sizeof(char));
//test se c' un errore nella allocazione della memoria
 if(testo==NULL)
 	{
	 return  MEM_ALLOC_ERROR;
	}


 //test se l'input del tipo di test non  valido
 if((tipo_di_test<0)||(tipo_di_test>13))
 	{
	 return ARG_MISSING;
	}
/* 
 if(tipo_di_test==0) //RESULT_OK
	{if((argomento!=0)&&(argomento!=1)&&(argomento!=2))
		{p_f(0);
		 p_a(tipo_di_test);
		 printf("Risultato Ottenuto:ARG_MISSING\nSpeigazione:Errore nel passaggio dei parametri\n");
		 return ARG_MISSING;
		}
				
	 else
		{risultato=leggiFile(nomefile,dim,testo);
		 if(risultato!=0)
			{p_f(0);
			 p_a(tipo_di_test);
			 printf("\nRisultato Ottenuto:");
			 p_a(risultato);
			 s(tipo_di_test);
			 printf("%d\n",argomento);
			 return TEST_FAILED;
			}
		 return TEST_PASSED;
		}
	}
*/
 if(tipo_di_test==0)
 	{return NOT_IMPLEMENTED;
	} 

 if(tipo_di_test==1)
 	{return NOT_VALID;
	}
 
 if(tipo_di_test==2) //NULL POINTER
 	{
	 if(argomento==0) //nome del file nullo
	 	{risultato=leggiFile(NULL,dim,testo);
		 if(risultato!=2)
			{
			 p_f(0);
			 p_a(tipo_di_test);
			 p_r(risultato);
			 s(tipo_di_test);
			 printf("0\n");
			 return TEST_FAILED;
			}
		 return TEST_PASSED;
		}
	 if(argomento==1)//dimensione nulla(non valido)
	 	{return NOT_VALID;
		}
	 if(argomento==2)//testo null pointer
	 	{risultato=leggiFile(nomefile,dim,NULL);
		if(risultato!=2)
			{
			 p_f(0);
			 p_a(tipo_di_test);
			 p_r(risultato);
			 s(tipo_di_test);
			 printf("%d\n",argomento);
			 return TEST_FAILED;
			}
		return TEST_PASSED;
		}

	 return ARG_MISSING;
	}


 if(tipo_di_test==3) //EMPTY STRING
 	{return NOT_IMPLEMENTED;
	}

 
 if(tipo_di_test==4) //FILE MISSING
 	{if((argomento!=0)&&(argomento!=1)&&(argomento!=2))
		{
		 return ARG_MISSING;
		}
				
	 if(argomento==0) //leggi file
	 	{risultato=leggiFile(nomefalso,dim,testo);
		 if(risultato!=4)
		 	{
			 p_f(0);
			 p_a(tipo_di_test);
			 p_r(risultato);
			 s(tipo_di_test);
			 printf("%d\n",argomento);
			 return TEST_FAILED;
			}
		  return TEST_PASSED;
		}
	 if((argomento==1)||(argomento==2))
		{return NOT_VALID;
		}
	}

 
/* DA FARE
 
 if(tipo_di_test==5) //file unreadable
 	{fd=fopen(nuovofiler,"w+");
	 if(argomento!=0)
		{return NOT_VALID;
		}
	 else
	 	{	
		risultato=leggiFile(nuovofiler,dim,testo);
		if(risultato!=5)
			{return TEST_FAILED;
			}
		return TEST_PASSED;
		 }
	}

 if(tipo_di_test==6) //file unwritable
 	{return NOT_IMPLEMENTED;
	} 
  
 
*/

 if(tipo_di_test==7) //FILE EMPTY
 	{if((argomento!=0)&&(argomento!=1)&&(argomento!=2))
	       {
		 return ARG_MISSING;
			}
	       		       
	 if((argomento==1)||(argomento==2))
		{return NOT_VALID;
			}
				
	 if(argomento==0)
		{fd=fopen(nuovofilew2,"w+");	
		 if(fd==NULL)
		 	{p_f(0);
			 p_a(tipo_di_test);
			 p_r(risultato);
			 s(tipo_di_test);
			 printf("%d\n",argomento);
			 return UNKNOWN_ERROR;
			}
		 risultato=leggiFile(nuovofilew2,dim,testo);
		 if(risultato!=7)
			{p_f(0);
			 p_a(tipo_di_test);
			 s(tipo_di_test);
			 printf("%d\n",argomento);
			 return TEST_FAILED;
			}
		 return TEST_PASSED;
		}
	
	}
 
 
 if(tipo_di_test==8) //	BUFFER TOO SMALL
	{if((argomento!=0)&&(argomento!=1)&&(argomento!=2))
		{
		 return ARG_MISSING;
			}
	 if((argomento==0)||(argomento==2))
		{return NOT_VALID;
		}
	 
			       
	 if(argomento==1) //leggi file
		{risultato=leggiFile(nomefile,0,testo);
		 if(risultato!=8)
			{p_f(0);
			 p_a(tipo_di_test);
			 p_r(risultato);
			 s(tipo_di_test);
			 printf("%d\n",argomento);
			 return TEST_FAILED;
			}
		 return TEST_PASSED;
		}

	 
	}	

 if((tipo_di_test>=9)&&(tipo_di_test<=11)) // non implementati perch non hanno senso
	{return NOT_IMPLEMENTED;
														                     }

     
}



 

/*

TEST DI ESTRAI HEADERS
   
*/




int test_estraiHeaders(int tipo_di_test, int argomento)
{char testo[]="ciao\n\n";
 int dim=10;
 char emptystring[1]="\0";
 char *headers;
 char test_header[]="ciao";
 int dimh=1024;
 char badheader[1]=":";
 headers=(char *)malloc(dimh*sizeof(char));
 if(headers==(char *)-1)
 	{return MEM_ALLOC_ERROR;
	}
 int t;
 char h_notfound[]="\noaij";

 int risultato;
//TIPI DI TEST
 
 if(tipo_di_test==0) //result_ok
	{if((argomento!=0)&&(argomento!=1)&&(argomento!=2))
		{return ARG_MISSING;
		}
	 else
	 	{risultato=estraiHeaders(testo,headers,dimh);
		 t=strcmp(headers,test_header);
		 if(t!=0)
		 	{
			 p_f(1);
                         p_a(tipo_di_test);
			 p_r(risultato);
			 if(risultato==0)
			 	{printf("\nSpiegazione: L'header ottenuto  diverso da quello aspettato\n");
					return TEST_FAILED;
				}
			 s(tipo_di_test);
			 printf("%d\n",argomento);
			 return TEST_FAILED;
			}
		 else
		 	return TEST_PASSED;
		}
	 
	}
 
 if(tipo_di_test==1) //UNKNOWN ERROR
 	{return NOT_IMPLEMENTED;
	}

 if(tipo_di_test==2) //NULL POINTER
 	{
	 if(argomento==0) //testo
		{risultato=estraiHeaders(NULL,headers,dimh);
		 if(risultato!=2)
		 	{ p_f(1);
			  p_a(tipo_di_test);
			  p_r(risultato);
			  s(tipo_di_test);
			  printf("%d\n",argomento);
			 return TEST_FAILED;
			}
		 return TEST_PASSED;
		}
	 if((argomento==1)||(argomento==2))
	 	{return NOT_VALID;
		}
	 if((argomento<0)&&(argomento>2))
	 	{return ARG_MISSING;
		}
	}


 
  if(tipo_di_test==3) //empty string
  	{
	 if((argomento==1)||(argomento==2))
	 	{return NOT_VALID;
		}
	 if(argomento==0)
	 	{risultato=estraiHeaders(emptystring,headers,dimh);
		 if(risultato!=3)
		 	{p_f(1);
			 p_a(tipo_di_test);
			 p_r(risultato);
			 s(tipo_di_test);
			 printf("%d\n",argomento);
			 return TEST_FAILED;
			}
		 return TEST_PASSED;
		}
	 return ARG_MISSING;
	}


  
   if((tipo_di_test>=4)&&(tipo_di_test<=7)) //test sul file...non valido
   	{return NOT_VALID;
	}


   
   if(tipo_di_test==8) //BUFFER_TOO_SMALL
   	{if((argomento==0)||(argomento==1))
		{return NOT_VALID;
		}
	 if(argomento==2)
	 	{risultato=estraiHeaders(testo,headers,0);
		 if(risultato!=8)
		 	{p_f(1);
			 p_a(tipo_di_test);
			 p_r(risultato);
			 s(tipo_di_test);
			 printf("%d\n",argomento);
			 return TEST_FAILED;
			}
		 return TEST_PASSED;
		}
	return ARG_MISSING;
	}
 
   
   if(tipo_di_test==9)
 	{if(argomento==0)
		{risultato=estraiHeaders(h_notfound,headers,dim);
			if(risultato!=9)
				{p_f(1);
				 p_a(tipo_di_test);
				 p_r(risultato);
				 s(tipo_di_test);
				 printf("%d\n",argomento);
				 return TEST_FAILED;
				}
			return TEST_PASSED;
		}
	 if((argomento==1)||(argomento==2))
	 	{return NOT_VALID;
		}
	 
	  return ARG_MISSING;
	}
   
  if(tipo_di_test==11)//bad header
  	{if(argomento==0)
		{risultato=estraiHeaders(badheader,headers,dim);
			if(risultato!=11)
				{p_f(1);
				 p_a(tipo_di_test);
				 p_r(risultato);
				 s(tipo_di_test);
				 printf("%d\n",argomento);
				 return TEST_FAILED;
				}
			return TEST_PASSED;
		}
	if((argomento==1)||(argomento==2))
		{return NOT_VALID;
		}
	return ARG_MISSING;
	} 
  
 if((tipo_di_test==9)||(tipo_di_test==10))//test che non vanno bene
 	{return NOT_VALID;
	} 
 if((tipo_di_test==12)||(tipo_di_test==13))
 	{return NOT_VALID;
	}

 return ARG_MISSING; 
}

/*

	TEST SUL PRIMO HEADER

 */

int test_primoHeader(int tipo_di_test, int argomento)
	{//primoHeader(char *headers, char *primo_header, int dim)
	 char head[7]="a a\ni\0";
	 int risultato;
	 int r;
	 char t[]="a a";
	 char *p_h;
	 int dim=7;
	 p_h=(char *)malloc(sizeof(char)*dim);
	 char emptystring[1]="\0";
	 char badheader[1]=":";
	 
	 if(tipo_di_test==0) //test su return ok
		{if((argomento==0)||(argomento==1)||(argomento==2))
			{risultato=primoHeader(head,p_h,dim);
			 r=strcmp(p_h,t);
 			 if(r!=0)
				{ p_f(2);
				  p_a(tipo_di_test);
				  p_r(risultato);
				  if(risultato==0)
				  	{printf("Spiegazione: L'header ottenuto  diverso da quello aspettato\n");
						return TEST_FAILED;
					}
				  s(tipo_di_test);
				  printf("%d\n",argomento);
				  return TEST_FAILED;
				}			 
		 	return TEST_PASSED;
			}
		 return ARG_MISSING;
		}

	 if(tipo_di_test==1)	//test su unknown
	 	{return NOT_IMPLEMENTED;
		}

	 if(tipo_di_test==2) //null pointer
	 	{if(argomento==0)
			{risultato=primoHeader(NULL,p_h,dim);
				if(risultato!=2)
					{p_f(2);
					 p_a(tipo_di_test);
		                         p_r(risultato);
		                         s(tipo_di_test);
		                         printf("%d\n",argomento);					
					 return TEST_FAILED;
					}
				return TEST_PASSED;
			}
		if(argomento==1)
			{
			 risultato=primoHeader(head,NULL,dim);
			 if(risultato!=2)
			 	{p_f(2);
	   			p_a(tipo_di_test);
	                         p_r(risultato);
	                         s(tipo_di_test);
	                         printf("%d\n",argomento);
				return TEST_FAILED;
				}
			 return TEST_PASSED;
			}
		if(argomento==2)
			{return NOT_VALID;
			}
		return ARG_MISSING; 
		}

	 if(tipo_di_test==3)//empty string
	 	{if(argomento==0)
			{risultato=primoHeader(emptystring,p_h,dim);
				if(risultato!=3)
					{p_f(2);
					 p_a(tipo_di_test);
					 p_r(risultato);
					 s(tipo_di_test);
					 printf("%d\n",argomento);
					 return TEST_FAILED;
					}
				return TEST_PASSED;
			}
		if((argomento==1)||(argomento==2))
			{return NOT_VALID;
			}
		return ARG_MISSING;
		}



	if((tipo_di_test>=4)&&(tipo_di_test<=7)) //test sul file...non valido
	               {return NOT_VALID;
		               }

	if(tipo_di_test==8)
		{if((argomento==0)||(argomento==1))
			{return NOT_VALID;
			}
		if(argomento==2)
			{risultato=primoHeader(head,p_h,0);
			 	if(risultato!=8)
					{p_f(2);
					 p_a(tipo_di_test);
					 p_r(risultato);
					 s(tipo_di_test);
					 printf("%d\n",argomento); 
					 return TEST_FAILED;
					}
				return TEST_PASSED;
			}
		 return ARG_MISSING;
		}
	
	if(tipo_di_test==11)
		{if(argomento==0)
			{risultato=primoHeader(badheader,p_h,dim);
				if(risultato!=11)
					{p_f(2);
					 p_a(tipo_di_test);
					 p_r(risultato);
					 s(tipo_di_test);
					 printf("%d\n",argomento);	    
					 return TEST_FAILED;
					}
				return TEST_PASSED;
			}
		 if((argomento==1)||(argomento==2))
		 	{return NOT_VALID;
			}
		 return ARG_MISSING;
		}
		
	if((tipo_di_test==9)||(tipo_di_test==10))
			{return NOT_VALID;
			}
	
	if((tipo_di_test==12)||(tipo_di_test==13))
		{return NOT_VALID;
		}	
	
	return ARG_MISSING;
	}



/*

TEST PARSE HEADER
   
*/


int test_parseHeader(int tipo_di_test, int argomento)
	{int risultato;
	 char header[10]="ciao ciao\0";
	 char tipo[5];
	 char valore[5];
	 char test[5]="ciao";
	 int dimt=5,dimv=5;
	 int risposta1,risposta2;
	char emptystring[1]="\0";	
	char badheader[1]=":";	
	
	 if(tipo_di_test==0) //return ok
	 	{if((argomento==0)||(argomento==1)||(argomento==2))
			{risultato=parseHeader(header,tipo,dimt,valore,dimv);
			 risposta1=strcmp(tipo,test);	 
			 risposta2=strcmp(valore,test);
			 if(risposta1==0)
			 	{if(risposta2==0)
					{return TEST_PASSED;
					}
				 else
				 	{p_f(3);
					 p_a(tipo_di_test);
					 p_r(risultato);
					 printf("Spiegazione: Il tipo o il valore ottenuti sono diversi da quelli aspettati\n");
					 return TEST_FAILED;
 				 	}
				}
			 else
			 	{p_f(3);
				 p_a(tipo_di_test);
				 p_r(risultato);
				 s(tipo_di_test);
				 printf("%d\n",argomento);			    
				 return TEST_FAILED;
				}
                        }
		return ARG_MISSING;
		}

	 if(tipo_di_test==1)
	 	{return NOT_VALID;
		}

	 if(tipo_di_test==2)//null pointer
	 	{if(argomento==0)
			{risultato=parseHeader(NULL,tipo,dimt,valore,dimv);
				if(risultato!=2)
					{p_f(3);
	                                 p_a(tipo_di_test);
		                         p_r(risultato);
		                         s(tipo_di_test);
		                         printf("%d\n",argomento);
		                         return TEST_FAILED;
					}
				return TEST_PASSED;
			}
		if(argomento==1)
			{risultato=parseHeader(header,NULL,dimt,valore,dimv);
			       if(risultato!=2)
				       {p_f(3);
                                        p_a(tipo_di_test);
	                                p_r(risultato);
	                                s(tipo_di_test);
	                                printf("%d\n",argomento);
					return TEST_FAILED;
			               }
				 return TEST_PASSED;
			}
		if(argomento==3)
			{risultato=parseHeader(header,tipo,dimt,NULL,dimv);
				if(risultato!=2)
					{p_f(3);
	                                 p_a(tipo_di_test);
	                                 p_r(risultato);
	                                 s(tipo_di_test);
	                                 printf("%d\n",argomento);
					 return TEST_FAILED;
					}
				return TEST_PASSED;
			}
		if((argomento==2)||(argomento==4))
			{return NOT_VALID;
			}
		
		return ARG_MISSING;
		}

	 if(tipo_di_test==3)//empty string
	 	{if(argomento==0)
			{risultato=parseHeader(emptystring,tipo,dimt,valore,dimv);
				if(risultato!=3)
					{p_f(3);
	                                 p_a(tipo_di_test);
	                                 p_r(risultato);
	                                 s(tipo_di_test);
	                                 printf("%d\n",argomento);
					 return TEST_FAILED;
					}
				return TEST_PASSED;
			}
		if((argomento==1)||(argomento==2)||(argomento==3)||(argomento==4))
			{return NOT_VALID;
			}
		return ARG_MISSING;
		}

	 if((tipo_di_test>=4)&&(tipo_di_test<=7)) //test sul file...non valido
	 	{return NOT_VALID;
		 }

	  if(tipo_di_test==8)
		{if((argomento==0)||(argomento==1)||(argomento==3))
			 {return NOT_VALID;
			 }
		 if(argomento==2)				
	     		 {risultato=parseHeader(header,tipo,0,valore,dimv);
                	            if(risultato!=8)
					{p_f(3);
	                                 p_a(tipo_di_test);
	                                 p_r(risultato);
	                                 s(tipo_di_test);
	                                 printf("%d\n",argomento);
					 return TEST_FAILED;
					}
				 return TEST_PASSED;
		          }
		 if(argomento==4)
		 	{risultato=parseHeader(header,tipo,dimt,valore,0);
				if(risultato!=8)
					{p_f(3);
                                         p_a(tipo_di_test);
	                                 p_r(risultato);
	                                 s(tipo_di_test);
	                                 printf("%d\n",argomento);
					 return TEST_FAILED;
					}
				return TEST_PASSED;
			}
		return ARG_MISSING;
		}
	  if(tipo_di_test==11)
	  	{if(argomento==0)
			{risultato=parseHeader(badheader,tipo,dimt,valore,dimv);
			 if(risultato!=11)
			 	{p_f(3);
                                 p_a(tipo_di_test);
                                 p_r(risultato);
                                 s(tipo_di_test);
                                 printf("%d\n",argomento);
				 return TEST_FAILED;
				}
			 return TEST_PASSED;
			}
		 if((argomento==1)||(argomento==2)||(argomento==3)||(argomento==4)) 
		 	{return NOT_VALID;
			}
		 return ARG_MISSING;
		}
	if((tipo_di_test==9)||(tipo_di_test==10))
		{return NOT_VALID;
		}
	if((tipo_di_test>11)&&(tipo_di_test<=13))
		{return NOT_VALID;
		}
	
	return ARG_MISSING;
		
	 
	} 



/*

// PRIMA PAROLA

 
*/

int test_primaParola(int tipo_di_test, int argomento)
	{int risultato;
	 int risposta;
	 char parola[3]="a&\0";
	 char ris[2]="a\0";
	 char parola2[2];
	 int dim=3;
	 char emptystring[1]="\0";
		  
	 if(tipo_di_test==0)
	 	{if((argomento==0)||(argomento==1)||(argomento==2))
			{risultato=primaParola(parola,parola2,dim);
				risposta=strcmp(parola2,ris);
				if(risposta!=0)
					{p_f(4);
					 p_a(tipo_di_test);
					 p_r(risultato);
					 if(risultato==0)
					 	{printf("Spiegazione: la parola ottenuta  divera da quella aspettata\n");
							return TEST_FAILED;
						}
					 s(tipo_di_test);
					 printf("%d\n",argomento);
					 return TEST_FAILED;
					}
				return TEST_PASSED;	
			}
		 return ARG_MISSING;
		}

	 if(tipo_di_test==1)//unknown error
	 	{return NOT_IMPLEMENTED;
		}

	 if(tipo_di_test==2)//null pointer
	 	{if(argomento==0)
			{risultato=primaParola(NULL,parola2,dim);
				if(risultato!=2)
					{p_f(4);
                                         p_a(tipo_di_test);
	                                  p_r(risultato);
	                                  s(tipo_di_test);
	                                 printf("%d\n",argomento);
					 return TEST_FAILED;
					}
				return TEST_PASSED;
			}
		if(argomento==1)
			{risultato=primaParola(parola,NULL,dim);
				if(risultato!=2)
					{p_f(4);
					 p_a(tipo_di_test);
					 p_r(risultato);
					 s(tipo_di_test);
					 printf("%d\n",argomento);
					 return TEST_FAILED;
					}
				return TEST_PASSED;
			}
		if(argomento==2)
			{return NOT_VALID;
			}
		
		return ARG_MISSING;	
		}
	
	if(tipo_di_test==3)//empty string
		{if(argomento==0)
			{risultato=primaParola(emptystring,parola2,dim);
				if(risultato!=3)
					{p_f(4);
					 p_a(tipo_di_test);
					 p_r(risultato);
					 s(tipo_di_test);
					 printf("%d\n",argomento);
					 return TEST_FAILED;
					}
				return TEST_PASSED;
			}
		if((argomento==1)||(argomento==2))
			{return NOT_VALID;
			}
		
		return ARG_MISSING;
		}
	
        if((tipo_di_test>=4)&&(tipo_di_test<=7))
			{return NOT_VALID;
			}
	 
	if(tipo_di_test==8) //buffer too small
		{if(argomento==2)
			{risultato=primaParola(parola,parola2,0);
				if(risultato!=8)
					{p_f(4);
					 p_a(tipo_di_test);
					 p_r(risultato);
					 s(tipo_di_test);
					 printf("%d\n",argomento);
					 return TEST_FAILED;
					}
				return TEST_PASSED;
			}
		 if((argomento==0)||(argomento==1))
		 	{return NOT_VALID;
			}

		 return ARG_MISSING;
		}
	
	if((tipo_di_test>=9)&&(tipo_di_test<=13))
		{return NOT_VALID;
		}

	return ARG_MISSING;
       	
	}
 
/*


TEST SU TOKENEMAIL

*/


int test_tokenizzaEmail(int tipo_di_test, int argomento)
{char t[]="from ciao\nsub ciao\n\nciao ciao";
 char no_body[]="from ciao\nsub ciao\n\n";
 char emptystring[1]="\0";
 int dim=1200;
 Token *tokenArray;
 int risultato;
 char *headers;
 headers=(char *)malloc(dim*sizeof(char));
 
 tokenArray=(struct a_token *)malloc(dim*sizeof(struct a_token));
 if(tokenArray==NULL)
 	{return MEM_ALLOC_ERROR;
	}

 if(tipo_di_test==0)
 	{if(argomento==0)
		{risultato=tokenizzaEmail(t,tokenArray,dim);
		 if(risultato!=0)
		 	{
				p_f(5);
				p_a(tipo_di_test);
				p_r(risultato);
				s(tipo_di_test);
				printf("%d\n",argomento);
			 return TEST_FAILED;
			}
		 return TEST_PASSED;
		}
	 return ARG_MISSING;
	}
 
 if(tipo_di_test==1)
 	{return NOT_VALID;
	}

 if(tipo_di_test==2)
 	{if(argomento==0)
		{risultato=tokenizzaEmail(NULL,tokenArray,dim);
			if(risultato!=2)
				{p_f(5);
				 p_a(tipo_di_test);
				 p_r(risultato);
				 s(tipo_di_test);
				 printf("%d\n",argomento);
				 return TEST_FAILED;
				}
			return TEST_PASSED;
		}
	 if(argomento==1)
	 	{risultato=tokenizzaEmail(t,NULL,dim);
			 if(risultato!=2)
			       {p_f(5);
				p_a(tipo_di_test);
				p_r(risultato);
				s(tipo_di_test);
				printf("%d\n",argomento);
				return TEST_FAILED;
			       }
       			 return TEST_PASSED;
		}
	 if(argomento==2)
	 	{return NOT_VALID;
		}
	 return ARG_MISSING;
	}


  if(tipo_di_test==3)
  	{if(argomento==0)
		{risultato=tokenizzaEmail(emptystring,tokenArray,dim);
			if(risultato!=3)
				{p_f(5);
				 p_a(tipo_di_test);
				 p_r(risultato);
				 s(tipo_di_test);
				 printf("%d\n",argomento);
				 return TEST_FAILED;
				}
			return TEST_PASSED;
		}
	 if((argomento==1)||(argomento==2))
	 	{return NOT_VALID;
		}
	 return ARG_MISSING;
	}

   if((tipo_di_test>=4)&&(tipo_di_test<=7))
   	{return NOT_VALID;
	}

   if(tipo_di_test==8)
   	{if(argomento==2)
		{risultato=tokenizzaEmail(t,tokenArray,0);
			if(risultato!=8)
				{p_f(5);
				 p_a(tipo_di_test);
				 p_r(risultato);
				 s(tipo_di_test);
				 printf("%d\n",argomento);
				 return TEST_FAILED;
				}
			return TEST_PASSED;
		}
	 if((argomento==0)||(argomento==1))
	 	{return NOT_VALID;
		}
	 return ARG_MISSING;
	}
 
   if(tipo_di_test==9)
   	{return NOT_IMPLEMENTED;
	}

   if(tipo_di_test==10)
   	{if(argomento==0)
		{risultato=tokenizzaEmail(no_body,tokenArray,dim);
			if(risultato!=10)
				{p_f(5);
				 p_a(tipo_di_test);
				 p_r(risultato);
				 s(tipo_di_test);
				 printf("%d\n",argomento);
				 return TEST_FAILED;
				}
			return TEST_PASSED;
		}
	if((argomento==1)||(argomento==2))
		{return NOT_VALID;
		}
	return ARG_MISSING;
	}

   if((tipo_di_test>=11)&&(tipo_di_test<=13))
   	{return NOT_IMPLEMENTED;
	}

   return ARG_MISSING;

}

int test_printToken(int tipo_di_test,int argomento)
	{return NOT_IMPLEMENTED;
	}









