#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <strings.h>
#include "modulo1.h"
#include <ctype.h>



//////////////////////////////////////---LEGGI FILE---/////////////////////////////////////
int leggiFile(char * nomefile, int dimensione, char * testo){
 char c;
int i=0, j=0, dimensioneFile=0;
FILE *ifp1, *ifp2;
if(nomefile==NULL||testo==NULL)
return(NULL_POINTER);

if(nomefile[0]=='\0')
return (EMPTY_STRING);

/*-------------- apertura FILE ---------------------*/
  if ((ifp1 = fopen(nomefile, "r")) == NULL)
      return(FILE_MISSING);
 ifp2 = fopen(nomefile, "r");
/*------------ controllo dimensione ----------------*/

 for (j = 0; ((c = getc(ifp2)) != EOF); j++);
dimensioneFile = j * (sizeof(char));
 if (dimensioneFile==0)
return(FILE_EMPTY);

if (dimensioneFile > dimensione)
    return(BUFFER_TOO_SMALL);
/*----------- copia del file nell'array ------------*/
 for (i = 0; i < dimensioneFile-1; i++){
   testo[i] = (getc(ifp1));}
   testo[i] = '\0';
   /* printf("%s%d\n", "n:",i);*/
  return(RESULT_OK);
}/*leggiFile*/
///////////////////////////////////---ESTRAI HEADERS----///////////////////////////////////
int estraiHeaders(char * email, char * headers, int dimh){   // da fare controllo errori
int cont=0,i=0;

if (email==NULL)
return(NULL_POINTER);

if (email[0]=='\0')
return (EMPTY_STRING);

while ((email[i+1]!='\0')&&((email[i]!='\n')||(email[i+1]!='\n'))) 
  {cont++;
   i++;
}
if(dimh<cont)
  return(BUFFER_TOO_SMALL);

if(email[0]=='\n'&&email[1]=='\n')
return (HEADER_NOT_FOUND);


for(i=0;((email[i+1]!='\0')&&((email[i]!='\n')||(email[i+1]!='\n')));i++)
{headers[i]=email[i];
}

headers[i]='\n';
headers[i+1]='\0';


return(RESULT_OK);
}

//////////////////////////////////////---PRIMO HEADER---////////////////////////////////////
int primoHeader(char * headers, char * primo_header, int dim){
int i=0,cont=0;


if ((headers==NULL)||(primo_header==NULL))
return(NULL_POINTER);


if (headers[0]=='\0')
return (EMPTY_STRING);




  
while ((headers[i]!='\n')&&((headers[i+1]!='\t')||(headers[i+1]!=' ')))
  {cont++;
   i++;
}

if(dim<cont)
  return(8);
 for(i=0;(headers[i]!='\n')&&((headers[i+1]!='\t')||(headers[i+1]!=' '));i++) //sostituire con "i<cont"
 
primo_header[i]=headers[i];
primo_header[i]='\0'; 
return(0);
}
int parseHeader(char*header,char*tipo,int dimt,char*valore,int dimv)
{int i=0,val;
int lung=0;    						
int ContT=0; 						
int ContVal=0;						
int k=0;						

if (header==NULL||tipo==NULL||valore==NULL)  		
return(NULL_POINTER);                                   

if (header[0]=='\0')                                    
return (EMPTY_STRING);                                 

lung=strlen(header);                                 
for (i=0;(i<(lung))&&(header[i]!=' ');i++){            
    ContT++;}    
    ContT++;  

if(dimt<ContT)               
return (BUFFER_TOO_SMALL);  


if ((header[0]<'a'&&header[0]>'z')&&(header[0]<'A'&&header[0]>'Z')&&(header[0]<'0'&&header[0]>'9'))
return (BAD_HEADER);


for (i=0;(i<(dimt))&&(header[i]!=' ');i++)
   tipo[i]=header[i];
 tipo[i]='\0';
 val=i;
 

k=i;
for(++k;(k<(val+lung))&&(header[k]!='\0')&&(header[k]!='\t');k++) 
ContVal++;

ContVal=ContVal+1; 
if(dimv<ContVal)           
return (BUFFER_TOO_SMALL);        


int j;
for(j=0,++i;(i<(val+dimv))&&(header[i]!='\0')&&(header[i]!='\t');i++,j++)
{  valore[j]=header[i];
 
}
valore[j]= '\0';

return(0);
    }

//////////////////////////////////////---PRIMA PAROLA---//////////////////////////////////////
int primaParola(char*testo,char*parola,int dim)
{int i,j=0;
for (i=0;(testo[i]!='\0')&&((!isalpha(testo[i]))||(!isalpha(testo[i+1])));i++);    

if(testo[i]=='\0')
return(UNKNOWN_ERROR);

while(isalpha(testo[i]))
{parola[j]=testo[i];
i++;
j++;
}
parola[i]='\0';
return (0);
}












//////////////////////////////////////---TOKENIZZA EMAIL---////////////////////////////////////
int tokenizzaEmail(char *email, Token tokenArray[], int dimT){

int dimEH=200,dim=50, dimt=20, dimv=30,dimp=15;
int dimTipo,dimParola,dimValore,dimHeaders;
int pos,m=0,i, j, k=0;
char headers[dimEH], primo_header[dim], tipo[dimt], valore[dimv],parolaccia[dimp];


if (email==NULL||tokenArray==NULL)
return(NULL_POINTER);  

if (email[0]=='\0')
return (EMPTY_STRING);

if (dimT==0)
return (BUFFER_TOO_SMALL); 


estraiHeaders(email, headers, dimEH);
dimHeaders = strlen(headers);

int a=1,b=1;
while(k<dimT&&headers[m]!='\0')
{
a=primoHeader(headers+m, primo_header, dim);
b=parseHeader(primo_header, tipo, dimt, valore, dimv);
pos=0;
dimValore=strlen(valore);
/*-----------------primaParola su primoHeaders-------------*/
while (k<dimT&& valore[pos]!='\0')
{
for (;(((!isalpha(valore[pos]))||(!isalpha(valore[pos+1])))&&(valore[pos+1]!='\0'));pos++);    
if(valore[pos+1]=='\0')
break;
primaParola(valore+pos,parolaccia,dimp);
dimTipo = strlen(tipo); 

if((tokenArray[k].contesto =malloc(dimTipo*sizeof(char)))==NULL)
return(MEM_ALLOC_ERROR);
for (i=0, j=0; i < dimTipo; i++, j++){//strlen(tipo)
tokenArray[k].contesto[j] = tipo[i];}

//tokenArray[k].contesto[j]='\0';


dimParola = strlen(parolaccia);
if((tokenArray[k].parola =malloc(dimParola*sizeof(char)))==NULL)
return(MEM_ALLOC_ERROR);
for (i=0; i < dimParola;i++){
tokenArray[k].parola[i] = parolaccia[i];}
pos=pos+dimParola;
//tokenArray[k].parola[j]='\0';

k++;
}/*while*/

m=m+(strlen(primo_header))+1;
}/*primo while*/

if (k==dimT)
{if(!primaParola(valore+pos,parolaccia,dimp))
return (BUFFER_TOO_SMALL); }




/*---------------primaParola su body-----------*/
int posbody=dimHeaders, dimEmail;
char *body = email;
for(i=pos;(!isalpha(email[i]))&&(email[i]!='\0');i++)
if(email[i]=='\0')
return (BODY_NOT_FOUND);
dimEmail = strlen(email) - dimHeaders;
while ((k<dimT) && (k<dimEmail) && (email[posbody]!='\0')){
for (;((!isalpha(email[posbody]))||((!isalpha(email[posbody+1])))&&((email[posbody+1]!='\0')));posbody++);

if(email[posbody+1]=='\0')
break;
primaParola(email+posbody,parolaccia,dimp);

tokenArray[k].contesto = NULL;

dimParola = strlen(parolaccia);
if((tokenArray[k].parola =malloc(dimParola*sizeof(char)))==NULL)
return(MEM_ALLOC_ERROR);
for (i=0; i < dimParola;i++){
tokenArray[k].parola[i] = parolaccia[i];}
tokenArray[k].parola[i] = '\0';
posbody = posbody + dimParola;
k++;
}/*while*/
if(k<dimt)
{tokenArray[k].parola=NULL;
tokenArray[k].contesto=NULL;
}
if (k==dimT)
{if(!primaParola(email+posbody,parolaccia,dimp))
return (BUFFER_TOO_SMALL); }


return (0);
}
//////////////////////////////////////////---PrintToken---///////////////////////////////////////////

int printTokens(Token tokenArray[], int dimT)
{int i=0;
for (i=0;i<dimT&&(tokenArray[i].parola!=NULL);i++)
{if(tokenArray[i].contesto==NULL)
     {printf("%s\n",tokenArray[i].parola);}
else
     {printf("%s*%s\n",tokenArray[i].contesto,tokenArray[i].parola);}
}
}







