  #include <stdio.h>
  #include <stdlib.h>
  #include <string.h>
  #include "modulo1.h"

/* NOTA: manca la funzione "int tokenizzaEmail(char * email, Token tokenArray[], int dimT)"! */


// funzione che copia da un file i primi 'dimensione' caratteri nel blocco di memoria 'testo'
// e mette nella variabile 'dimensione' il numero di caratteri letti
int leggiFile(char * nomefile, int dimensione, char * testo)
{
    FILE *filePtr;

    int i, c=0;
    
    if((!nomefile)||(!testo)) return NULL_POINTER;
    if(*nomefile=='\0') return EMPTY_STRING;
    if(dimensione==-1){
                         testo="";
                         return RESULT_OK;
                         }

/* NOTA: manca il test per FILE_MISSING! */

    if((filePtr=fopen(nomefile, "r"))==NULL){
                                fclose(filePtr);
                                printf("file non leggibile. Controllare di avere i diritti di accesso adeguati.");
                                return FILE_UNREADABLE;
                                }

    while(!feof(filePtr)) //conta la lunghezza del file
    {
    fscanf(filePtr, "%c", &i);
    c++;}
    
    if(c==1)
    {
            *testo='\0';
            return FILE_EMPTY;
    }

    if(c>dimensione-1)
    {
    for(i=0;i<dimensione-1;i++)
    {
    fscanf(filePtr,"%c",testo);
    testo++;
    }
    return BUFFER_TOO_SMALL;
    }

    rewind(filePtr);

//fine dei test preliminari..

    for(i=0;i<c;i++)
    {
    fscanf(filePtr,"%c",testo);
    testo++;
    }

    fclose(filePtr);
    return RESULT_OK;
}

// funzione che individua le intestazioni della email e le copia nel blocco di memoria 'headers' di lunghezza 'dimh'
int estraiHeaders(char * email, char * headers, int dimh)
{
    char* flashback=email;
    char* email2; //legge il carattere successivo
    email2=email+1;
    int headers_lenght=0;

    if((!email)||(!headers)) return NULL_POINTER;
    if(*email=='\0') return EMPTY_STRING;
    while((*email!='\n')&&(*email2!='\n')) //calcola la lunghezza dell'header
    {
       headers_lenght++;
       email++;
       email2++;
    }

    email=flashback; //ripristina email - inutile?
    email2=email+1;

    if(headers_lenght>=dimh-1) return BUFFER_TOO_SMALL;
    if((*email=='\n')||(*email=='\0')) return HEADER_NOT_FOUND;

    // fine tests..
    while((*email!='\n')||(*email2!='\n')) //lettura header
    {
       *headers=*email;
       headers++;
       email++;
       email2++;
    }
    return RESULT_OK;
}

// funzione che estrae il primo header dagli headers e lo copia in primo_header
int primoHeader(char * headers, char * primo_header, int dim)
{
    char *cph=headers;
    char internal_buffer[1000];
    char *internal_bufferPtr=&internal_buffer[0];
    int ij;

    if((!headers)||(!primo_header)) return NULL_POINTER;
    if(*headers=='\0') return EMPTY_STRING;

    for(ij=0;ij<=strlen(headers);ij++){
                     *internal_bufferPtr=*cph;
                     internal_bufferPtr++;
                     cph++;
                     if(*cph=='\n')
                     {
                                  cph++;
                                  if((*cph==' ')||(*cph=='\t'))
                                  {
                                             cph--;
                                             continue;
                                  }
                     else break;
                     }
    }
    *internal_bufferPtr='\0';

    if(strlen(internal_buffer)>=dim) return BUFFER_TOO_SMALL;

    strcpy(primo_header, internal_buffer);
    return RESULT_OK;
}

// funzione che estrae il tipo ed il valore di uno header
int parseHeader(char * header, char * tipo, int dimt, char * valore, int dimv)
{
    if((!header)||(!tipo)||(!valore)) return NULL_POINTER;
    if(*header=='\0') return EMPTY_STRING;
    char tipo2[1000];
    char valore2[1000];
    sscanf(header, "%s%s", tipo2, valore2);
    if(strlen(tipo2)>dimt) return BUFFER_TOO_SMALL;
    else strcpy(tipo, tipo2);
    if(strlen(valore2)>dimv) return BUFFER_TOO_SMALL;
    else strcpy(valore, valore2);
    return RESULT_OK;
}

// funzione che estrae la prima parola da una stringa
int primaParola(char * testo, char * parola, int dim)
{
    if((!testo)||(!parola)) return NULL_POINTER;
    if(*testo=='\0') return EMPTY_STRING;

    char parola2[100];
    char * parola2Ptr=&parola2[0];

    while(*testo!='\0')
    {
    if(((*testo>='0')&&(*testo<='9'))||((*testo>='A')&&(*testo<='z')))
    {
       while(((*testo>='0')&&(*testo<='9'))||((*testo>='A')&&(*testo<='z'))){
       *parola2Ptr=*testo;
       parola2Ptr++;
       testo++;
       }
       break;
    }
    testo++;
    }
    *parola2Ptr='\0';
    if(strlen(parola2)>dim)return BUFFER_TOO_SMALL;
    strcpy(parola, parola2);
    if(parola2=="") return BODY_NOT_FOUND;
    return RESULT_OK;
}

// funzione che estrae i primi dimT token dalla email
int tokenizzaEmail(char * email, Token tokenArray[], int dimT)
{
    return RESULT_OK;
}

// funzione che stampa i token uno per riga nel formato 'contesto*parola' oppure 'parola'
int printTokens(Token tokenArray[], int dimT)
{
    /* memo: fare checks... */

    int w;
    for(w=0;w<dimT;w++)
    {
       if(tokenArray[w].contesto==NULL) printf("%s\n", tokenArray[w].parola);
       else printf("%s*%s\n", tokenArray[w].contesto, tokenArray[w].parola);
    }
    return RESULT_OK;
}

