#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "modulo1.h"
#define dimtoken 500

int leggiFile(char * nomefile, int dimensione, char * testo) {

		FILE *fp;
		char car;
		int i;

		if (access (nomefile, 0)) return FILE_MISSING;
		if (access(nomefile, 4)) return FILE_UNREADABLE;
		if (access(nomefile, 2)) return FILE_UNWRITABLE;
		if ((nomefile==NULL)||(dimensione==0)) return NULL_POINTER;
		fp = fopen(nomefile, "r");
		if ((car=getc(fp))==EOF) return FILE_EMPTY;
		*testo=car;
		testo++;
		for (i=0; i<=dimensione-2; i++){

			car=getc(fp);
			*testo=car;

			if (*testo==EOF) {
				*testo = '\0';
				fclose(fp);
				return RESULT_OK;
			}
		testo++;
		}
		testo--;
		*testo = '\0';
		return BUFFER_TOO_SMALL;
};

int estraiHeaders(char* email, char* headers, int dimh) {

		int i=0;

		do {
			if (i>dimh-2) return BUFFER_TOO_SMALL;

			if (*email=='\n') {
				*headers=*email;
				email++;
				headers++;
				i++;

				if (i>dimh-2) return BUFFER_TOO_SMALL;

				if (*email=='\n') {
					*email='\0';
					*headers='\0';
					return RESULT_OK;
				} else {
					*headers=*email;
					email++;
					headers++;
					i++;
				}

			} else {
				*headers=*email;
				email++;
				headers++;
				i++;
			}

		} while(!0);

};


int primoHeader(char * headers, char * primo_header, int dim){

		int i=0;

		do {

			if (i>dim-2) return BUFFER_TOO_SMALL;

			if (*headers == '\n') {
				*primo_header=*headers;
				primo_header++;
				headers++;
				i++;


				if (i>dim-2) return BUFFER_TOO_SMALL;
				if ((*headers!=' ') && (*headers!='\t')) {
					*primo_header='\0';
					headers--;
					return RESULT_OK;
				}
			}
			*primo_header=*headers;
			primo_header++;
			headers++;
			i++;
		}while(!0);

};

int parseHeader (char * header, char * tipo, int dimt, char * valore, int dimv) {

		int i=0;
		char car;

		car=*header;


		while (*header!=' ') {

			if (*header=='\0') return BAD_HEADER;

			if (i>dimt-2) {
				*tipo='\0';
				return BUFFER_TOO_SMALL;
			}
			*tipo=*header;
			tipo++;
			header++;
			i++;
		}
		*tipo='\0';

		header++;

		i=0;

		while (*header!='\0') {

			if (i>dimv-2) {
				*valore='\0';
				return BUFFER_TOO_SMALL;
			}
			*valore=*header;
			valore++;
			header++;
			i++;
		}
		*valore='\0';

		return RESULT_OK;

};


int primaParola(char * testo, char * parola, int dim) {

		int i=0;
		char car;


		while(*testo!=' ') {

				if (i>dim-2) return BUFFER_TOO_SMALL;

				car=*testo;

				if ((isdigit(car)) || (isalpha(car))) *parola=*testo ;

				parola++;
				testo++;
				i++;
		}
		*parola='\0';
		return RESULT_OK;

};



int tokenizzaEmail(char * email, Token tokenArray[], int dimT) {

		char *headers;
		char *primo_header;
		char *header;
		char *tipo;
		char *valore;
		char *parola;
		int p=0;


		headers=(char*)malloc(dimtoken*(sizeof(char)));
		primo_header=(char*)malloc(dimtoken*(sizeof(char)));
		header=(char*)malloc(dimtoken*(sizeof(char)));
		tipo=(char*)malloc(dimtoken*(sizeof(char)));
		valore=(char*)malloc(dimtoken*(sizeof(char)));
		parola=(char*)malloc(dimtoken*(sizeof(char)));

		if (!headers) return MEM_ALLOC_ERROR;
		if (!primo_header) return MEM_ALLOC_ERROR;
		if (!header) return MEM_ALLOC_ERROR;
		if (!tipo) return MEM_ALLOC_ERROR;
		if (!valore) return MEM_ALLOC_ERROR;
		if (!parola) return MEM_ALLOC_ERROR;

		if (p=estraiHeaders(email, headers, dimtoken)) return p;
		if (p=primoHeader(headers, primo_header, dimtoken)) return p;
		if (p=primoHeader(headers, primo_header, dimtoken)) return p;
		if (p=parseHeader(primo_header, tipo, dimtoken, valore, dimtoken)) return p;
		if (p=primaParola(email, parola, dimtoken)) return p;




		printf("HEADERS:\n  %s\n", headers);
		printf("PRIMO HEADER:\n  %s\n", primo_header);
		printf("TIPO:\n  %s\n", tipo);
		printf("VALORE\n  %s\n", valore);
		printf("PAROLA:\n  %s\n", parola);
		return RESULT_OK;

};

int printTokens(Token tokenArray[], int dimT) {

	return RESULT_OK;

};

