#include<stdio.h>
#include<stdlib.h>
#include "testModulo1.h"

void printErr(char *nFunz, int aspRes, int reaRes, char *comnts);

int test_leggiFile(int tipo_di_test, int n_argomento){
   int r;
   switch(tipo_di_test){
      case(2): //NULL_POINTER
      
         if(n_argomento==0){//Primo
            r = leggiFile(NULL, 5, "pippo");
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("leggiFile", tipo_di_test, r, "La funzione non controlla se il primo arg  un puntatore nullo");
               return r;               
            }
         }else if(n_argomento==1){//Secondo
            return NOT_VALID;
         }else if(n_argomento==2){//Terzo arg
            r = leggiFile("pippo", 5, NULL);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("leggiFile", tipo_di_test, r, "La funzione non controlla se il terzo arg  un puntatore nullo");
               return r;               
            }
         }else{
            return ARG_MISSING;
         }
         break;
      case(3): //NULL_POINTER
         
         if(n_argomento==0){//Primo
            r = leggiFile("", 5, "pippo");
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("leggiFile", tipo_di_test, r, "La funzione non controlla se il primo arg  una stringa vuota");
               return r;               
            }
         }else if(n_argomento==1){//Secondo
            return NOT_VALID;
         }else if(n_argomento==2){//Terzo arg
            return NOT_VALID;
         }else{
            return ARG_MISSING;
         }
         break;
      default:
         return NOT_IMPLEMENTED;
   }

}

int test_estraiHeaders(int tipo_di_test, int n_argomento){
int r;
   switch(tipo_di_test){
      case(2): //NULL_POINTER  
         if(n_argomento==0){//Primo
            r = estraiHeaders(NULL, "pippo", 5);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("estraiHeaders", tipo_di_test, r, "La funzione non controlla se il primo arg  un puntatore nullo");
               return r;               
            }
         }else if(n_argomento==1){//Terzo arg
            r = estraiHeaders("pippo", NULL, 5);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("estraiHeaders", tipo_di_test, r, "La funzione non controlla se il secondo arg  un puntatore nullo");
               return r;               
            }
         }else if(n_argomento==2){//Secondo
            return NOT_VALID;
         }else{
            return ARG_MISSING;
         }
         break;
      case(3): //STRINGA EMPTY
         
         if(n_argomento==0){//Primo
            r = estraiHeaders("", "pippo", 5);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("estraiHeades", tipo_di_test, r, "La funzione non controlla se il primo arg  una stringa vuota");
               return r;               
            }
         }else if(n_argomento==1){//Secondo
            return NOT_VALID;
         }else if(n_argomento==2){//Terzo arg
            return NOT_VALID;
         }else{
            return ARG_MISSING;
         }
         break;
      default:
         return NOT_IMPLEMENTED;
   }
}
int test_primoHeader(int tipo_di_test, int n_argomento){
   int r;
   switch(tipo_di_test){
      case(2): //NULL_POINTER  
         if(n_argomento==0){//Primo
            r = primoHeader(NULL, "pippo", 5);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("primoHeader", tipo_di_test, r, "La funzione non controlla se il primo arg  un puntatore nullo");
               return r;               
            }
         }else if(n_argomento==1){//Terzo arg
            r = primoHeader("pippo", NULL, 5);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("primoHeader", tipo_di_test, r, "La funzione non controlla se il secondo arg  un puntatore nullo");
               return r;               
            }
         }else if(n_argomento==2){//Secondo
            return NOT_VALID;
         }else{
            return ARG_MISSING;
         }
         break;
      case(3): //STRINGA EMPTY
         
         if(n_argomento==0){//Primo
            r = primoHeader("", "pippo", 5);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("primoHeader", tipo_di_test, r, "La funzione non controlla se il primo arg  una stringa vuota");
               return r;               
            }
         }else if(n_argomento==1){//Secondo
            return NOT_VALID;
         }else if(n_argomento==2){//Terzo arg
            return NOT_VALID;
         }else{
            return ARG_MISSING;
         }
         break;
      default:
         return NOT_IMPLEMENTED;
   }
}

int test_parseHeader(int tipo_di_test, int n_argomento){
   int r;
   switch(tipo_di_test){
      case(2): //NULL_POINTER  
         if(n_argomento==0){//Primo
            r = parseHeader(NULL, "pippo", 5, "pippo", 5);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("parseHeader", tipo_di_test, r, "La funzione non controlla se il primo arg  un puntatore nullo");
               return r;               
            }
         }else if(n_argomento==1){//Terzo arg
            r = parseHeader("pippo", NULL, 5, "pippo", 5);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("parseHeader", tipo_di_test, r, "La funzione non controlla se il secondo arg  un puntatore nullo");
               return r;               
            }
         }else if(n_argomento==2){//Secondo
            return NOT_VALID;
         }else if(n_argomento==3){//Terzo arg
            r = parseHeader("pippo", "pippo", 5, NULL, 5);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("primaParola", tipo_di_test, r, "La funzione non controlla se il quarto arg  un puntatore nullo");
               return r;               
            }
         }else if(n_argomento==4){//Terzo arg
            return NOT_VALID;
         }else{
            return ARG_MISSING;
         }
         break;
      case(3): //NULL_POINTER  
         if(n_argomento==0){//Primo
            r = parseHeader("", "pippo", 5, "pippo", 5);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("parseHeader", tipo_di_test, r, "La funzione non controlla se il primo arg  una stringa vuota");
               return r;               
            }
         }else if(n_argomento==1){//Terzo arg
            r = parseHeader("pippo", "", 5, "pippo", 5);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("parseHeader", tipo_di_test, r, "La funzione non controlla se il secondo arg  una stringa vuota");
               return r;               
            }
         }else if(n_argomento==2){//Secondo
            return NOT_VALID;
         }else if(n_argomento==3){//Terzo arg
            r = parseHeader("pippo", "pippo", 5, "", 5);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("primaParola", tipo_di_test, r, "La funzione non controlla se il quarto arg  una stringa vuota");
               return r;               
            }
         }else if(n_argomento==4){//Terzo arg
            return NOT_VALID;
         }else{
            return ARG_MISSING;
         }
         break;
      default:
         return NOT_IMPLEMENTED;
   }
}

int test_primaParola(int tipo_di_test, int n_argomento){
   int r;
   switch(tipo_di_test){
      case(2): //NULL_POINTER  
         if(n_argomento==0){//Primo
            r = primaParola(NULL, "pippo", 5);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("primaParola", tipo_di_test, r, "La funzione non controlla se il primo arg  un puntatore nullo");
               return r;               
            }
         }else if(n_argomento==1){//Terzo arg
            r = primaParola("pippo", NULL, 5);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("primaParola", tipo_di_test, r, "La funzione non controlla se il secondo arg  un puntatore nullo");
               return r;               
            }
         }else if(n_argomento==2){//Secondo
            return NOT_VALID;
         }else{
            return ARG_MISSING;
         }
         break;
      case(3): //STRINGA EMPTY
         
         if(n_argomento==0){//Primo
            r = primaParola("", "pippo", 5);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("primaParola", tipo_di_test, r, "La funzione non controlla se il primo arg  una stringa vuota");
               return r;               
            }
         }else if(n_argomento==1){//Secondo
            r = primaParola("", "pippo", 5);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("primaParola", tipo_di_test, r, "La funzione non controlla se il secondo arg  una stringa vuota");
               return r;               
            }
    
         }else if(n_argomento==2){//Terzo arg
            return NOT_VALID;
         }else{
            return ARG_MISSING;
         }
         break;
      default:
         return NOT_IMPLEMENTED;
   }
}

int test_tokenizzaEmail(int tipo_di_test, int n_argomento){
   int r;
   switch(tipo_di_test){
      case(2): //NULL_POINTER  
         if(n_argomento==0){//Primo
            Token tok[4];
            r = tokenizzaEmail(NULL, tok, 4);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("tokenizzaEmail", tipo_di_test, r, "La funzione non controlla se il primo arg  un puntatore nullo");
               return r;               
            }
         }else if(n_argomento==1){//Terzo arg
            return NOT_VALID;
         }else if(n_argomento==2){//Secondo
            return NOT_VALID;
         }else{
            return ARG_MISSING;
         }
         break;
      case(3): //buff too small
         if(n_argomento==0){
            Token tok[4];
            r = tokenizzaEmail("", tok, 5);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("tokenizzaEmail", tipo_di_test, r, "La funzione non controlla se il primo arg  una stringa vuota");
               return r;               
            }
         }else if(n_argomento==1){
            return NOT_VALID;
         }else if(n_argomento==2){
            return NOT_VALID;
         }else{
            return ARG_MISSING;
         }
      default:
         return NOT_IMPLEMENTED;
   }
}

int test_printTokens(int tipo_di_test, int n_argomento){
   int r;
   switch(tipo_di_test){
      case(2): //NULL_POINTER  
         if(n_argomento==0){//Primo
            Token tok[4];
            r = printTokens(NULL, 4);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("printTokens", tipo_di_test, r, "La funzione non controlla se il primo arg  un puntatore nullo");
               return r;               
            }
         }else if(n_argomento==1){//Terzo arg
            return NOT_VALID;
         }else{
            return ARG_MISSING;
         }
         break;
      case(8): //buff too small
         if(n_argomento==0){
            return NOT_VALID;
         }else if(n_argomento==1){
            Token tok[4];
            r = printTokens(tok, 0);
            if(r == tipo_di_test){
               return TEST_PASSED;
            }else{
               printErr("printTokens", tipo_di_test, r, "La funzione non controlla se il buffer  troppo piccolo");
               return r;               
            }
         }else{
            return ARG_MISSING;
         }
      default:
         return NOT_IMPLEMENTED;
   }
}

void printErr(char *nFunz, int aspRes, int reaRes, char *comnts){
   char *err[13] = {"RESULT_OK", "UNKNOWN_ERROR", "NULL_POINTER", "EMPTY_STRING", "FILE_MISSING", "FILE_UNREADABLE", "FILE_UNWRITABLE", "FILE_EMPTY", "BUFFER_TOO_SMALL", "HEADER_NOT_FOUND", "BODY_NOT_FOUND", "BAD_HEADER", "MEM_ALLOC_ERROR"};
   
   printf("Test Fallito:\nfunzione testata: %s\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: %s\n", nFunz, err[aspRes], err[reaRes], comnts);
}

