// --------------------PROGETTO FILTRO ANTISPAM--------------------------------//


// testModulo1.c
// Gabriele Tarantino 698294


#include <stdio.h>
#include <stdlib.h>
#include "testModulo1.h"

//se un test fallisce lei si occupa di dare le specifiche dell'errore
int failed(char *f, char* cod, int i){

char risultato[12][50];
strcpy(risultato[0], "RESULT_OK\0");
strcpy(risultato[1], "UNKNOWN_ERROR\0");
strcpy(risultato[2], "NULL_POINTER\0");
strcpy(risultato[3], "EMPTY_STRING\0");
strcpy(risultato[4], "FILE_MISSING\0");
strcpy(risultato[5], "FILE_UNREADABLE\0");
strcpy(risultato[6], "FILE_EMPTY\0");
strcpy(risultato[7], "FILE_UNREADABLE\0");
strcpy(risultato[8], "BUFFER_TOO_SMALL\0");
strcpy(risultato[9], "HEADER_NOT_FOUND\0");
strcpy(risultato[10], "BODY_NOT_FOUND\0");
strcpy(risultato[11], "BAD_HEADER\0");
strcpy(risultato[12], "MEM_ALLOC_ERROR\0");

printf("TEST_FAILED          %s\n\nErrore generato: %s\nCodice risultato: %s\n\nDescrizione:\nla funzione %s \nnon  in grado di eseguire correttamente \nil controllo su %s \n\n"
,f,cod,risultato[i],f,cod);

}


int test_leggiFile(int tipo, int arg){
char nomeFile[11]={'e','m','a','i','l','1','.','t','x','t','\0'};
 char *testo;
  int i=0;
  int dim = 100;
  FILE *fp;
  testo = malloc(sizeof(char)*dim);
  while(i++<dim-1)testo[i]='0';
  if(!(arg<3 && arg>=0))return ARG_MISSING;
  switch(tipo){
  case RESULT_OK :
    if(!arg)if(!(i=leggiFile(nomeFile,dim,testo)) && testo[i] != '0')return TEST_PASSED;
      else return failed("leggiFile(nomeFile,dim,testo)","RESULT_OK",i);
      else return NOT_VALID;
 return NOT_VALID;
  case NULL_POINTER:
	 if((!arg)||(arg == 1))if(NULL_POINTER == (i=leggiFile(NULL,dim,NULL)))return TEST_PASSED;
	 else return failed("leggiFile(NULL,dim,NULL)","NULL_POINTER",i);
	else return NOT_VALID;
  case EMPTY_STRING:
    nomeFile[0]='\0';
	 if(!arg)if(EMPTY_STRING == (i=leggiFile(nomeFile,dim,testo)))return TEST_PASSED;
	 else return failed("leggiFile(nomeFile,dim,testo)","EMPTY_STRING",i);
      else return NOT_VALID;
  case  FILE_MISSING:
	  if(!arg)if(FILE_MISSING == (i=leggiFile("file-missing",dim,testo)))return TEST_PASSED;
	 else return failed("leggiFile(file-missing,dim,testo)","FILE_MISSING",i);
    else return NOT_VALID;
  case FILE_UNREADABLE:
    if(!arg)if(FILE_UNREADABLE == (i=leggiFile("file-unreadable",dim,testo))) return TEST_PASSED;
     else return failed("leggiFile(file-unreadable,dim,testo)","FILE_UNREADABLE",i);
       else return NOT_VALID;
  case FILE_EMPTY:
	 if(!arg)if(FILE_EMPTY == (i=leggiFile("file-empty",dim,testo)))return TEST_PASSED;
	 else return failed("leggiFile(file-empty,dim,testo)","FILE_EMPTY",i);
    else return NOT_VALID;
    break;
  default:
    return NOT_VALID;
  }
}
int test_estraiHeaders(int tipo, int arg){
  char email[100], headers[100]={'0'};
    int dim = 100, i=0;
  if(!(arg<3 && arg>=0))return ARG_MISSING;
  email[0] = 'e';
    email[1] = '\n';
    email[2] = '\n';
  switch(tipo){
  case RESULT_OK:
	  if(!arg)if(!(i=estraiHeaders(email,headers,dim)) && headers[i] !='0')return TEST_PASSED;
    else return failed("estraiHeaders(email,headers,dim)","RESULT_OK",i);
	    else return NOT_VALID;
  case NULL_POINTER:
    if((arg == 1)||(!arg))if(NULL_POINTER == (i=estraiHeaders(NULL,NULL,dim)))return TEST_PASSED;
    else return failed("estraiHeaders(NULL,NULL,dim)","NULL_POINTER",i);
      else return NOT_VALID;
  case EMPTY_STRING:
	email[0] = '\0';
    if(!arg)if(EMPTY_STRING == (i=estraiHeaders(email,headers,dim)))return TEST_PASSED;
	 else return failed("estraiHeaders(email,headers,dim)","EMPTY_STRING",i);
      else return NOT_VALID;
  case BUFFER_TOO_SMALL:
  if(arg == 2)if(BUFFER_TOO_SMALL == (i=estraiHeaders(email,headers,0)))return TEST_PASSED;
	 else return failed("estraiHeaders(email,headers,0)","BUFFER_TOO_SMALL",i);
  else return NOT_VALID;
 case HEADER_NOT_FOUND:
    email[0] = '\n';
  if(!arg)if(HEADER_NOT_FOUND == (i=estraiHeaders(email,headers,dim)))return TEST_PASSED;
	 else return failed("estraiHeaders(email,headers,dim)","HEADER_NOT_FOUND",i);
      else return NOT_VALID;
  default:
    return NOT_VALID;
  }
}
int test_primoHeader(int tipo, int arg){
  char primo_header[100] = {'0'};
  int dim = 100, i=0;
 char headers[300];
  if(!(arg<3 && arg>=0))return ARG_MISSING;
  switch(tipo){
  case RESULT_OK:
    if(!arg)if(!(i=primoHeader(headers, primo_header,dim)) &&primo_header[0] != '0')return TEST_PASSED;
    else return failed("primoHeader(headers, primo_header,dim)","",i);
    else  NOT_VALID;
      case NULL_POINTER:
    if(!arg)if(NULL_POINTER == (i=primoHeader(NULL, primo_header,dim)))return TEST_PASSED;
    else return failed("primoHeader(NULL, primo_header,dim)","NULL_POINTER",i);
  if(arg == 1)if(NULL_POINTER == primoHeader(headers, NULL,dim))return TEST_PASSED;
    else return failed("primoHeader(headers, NULL,dim)","NULL_POINTER",i);
      else return NOT_VALID;
 case EMPTY_STRING:
	 headers[0] = '\0';
    if(!arg)if(EMPTY_STRING == (i=primoHeader(headers,primo_header,dim)))return TEST_PASSED;
    else return failed(" primoHeader(headers,primo_header,dim)","EMPTY_STRING",i);
      else return NOT_VALID;
 case BUFFER_TOO_SMALL:
	  if(arg == 2)if(BUFFER_TOO_SMALL == (i=primoHeader(headers,primo_header,0)))return TEST_PASSED;
	  else return failed(" primoHeader(headers,primo_header,0)","BUFFER_TOO_SMALL",i);
    else return NOT_VALID;
 case BAD_HEADER:
	 headers[0] = ':';
	  if(!arg)if(BAD_HEADER == (i=primoHeader(headers,primo_header,dim)))return TEST_PASSED;
	  else return failed(" primoHeader(headers,primo_header,dim)","BAD_HEADER",i);
    else return NOT_VALID;
  default:
    return NOT_VALID;
  }
}
int test_parseHeader(int tipo_, int arg){
int dim = 100,i;
char valore[100] ={'0'};
char tipo[100] ={'0'};
char primo_header[100];
 primo_header[0]='e';
 primo_header[1]=' ';
 primo_header[2]='e';
 primo_header[3]='\0';
  if(!(arg<6 && arg>=0))return ARG_MISSING;
  switch(tipo_){
case RESULT_OK :
    if(!arg)if(!(i=parseHeader(primo_header,tipo,dim,valore,dim)) && tipo[0] != '0' && valore[0] != '0')return TEST_PASSED;
    else return failed("parseHeader(primo_header,tipo,dim,valore,dim)","RESULT_OK",i);
      else return NOT_VALID;
     case NULL_POINTER:
    if((arg!=2)&&(arg!=4))if(NULL_POINTER == (i=parseHeader(NULL,NULL,dim,NULL,dim)))return TEST_PASSED;
    else return failed("parseHeader(NULL,NULL,dim,NULL,dim)","NULL_POINTER",i);
      else return NOT_VALID;
case EMPTY_STRING:
	primo_header[0] = '\0';
    if(!arg)if(EMPTY_STRING == (i=parseHeader(primo_header,tipo,dim, valore,dim)))return TEST_PASSED;
    else return failed("parseHeader(primo_header,tipo,dim, valore,dim)","EMPTY_STRING",i);
      else return NOT_VALID;
case BUFFER_TOO_SMALL:
	  if(arg == 2)if(BUFFER_TOO_SMALL == (i=parseHeader(primo_header,tipo,0,valore ,0)))return TEST_PASSED;
	  else return failed("parseHeader(primo_header,tipo,0,valore ,0)","BUFFER_TOO_SMALL",i);
    else return NOT_VALID;
case BAD_HEADER:
	 primo_header[0] = 'r';
         primo_header[1] = ' ';
         primo_header[2] = '\0';
	  if(!arg)if(BAD_HEADER == (i=parseHeader(primo_header,tipo,dim,valore,dim)))return TEST_PASSED;
	  else return failed("parseHeader(primo_header,tipo,dim,valore,dim)","BAD_HEADER",i);
    else return NOT_VALID;
  default:
    return NOT_VALID;
  }
}
int test_primaParola(int tipo, int arg){
  char email[100];
  char prima_parola[100] = {'0'};
  int dim = 100, i=0;
  if(!(arg<3 && arg>=0))return ARG_MISSING;
  switch(tipo){
  case RESULT_OK:
  email[0] = 'e';
  email[1] = 'e';
  email[2] = ' ';
  email[0] = '\0';
  if(!arg)if(!(i=primaParola(email,prima_parola,dim)) && prima_parola[0] != '0')return TEST_PASSED;
  else return failed("primaParola(email,prima_parola,dim)","RESULT_OK",i);
  else return NOT_VALID;
  case NULL_POINTER:
  if((!arg)||(arg == 1))if(NULL_POINTER == (i=primaParola(NULL,NULL,dim)))return TEST_PASSED;
  else return failed("primaParola(NULL,NULL,dim)","NULL_POINTER",i);
  else return NOT_VALID;
  case EMPTY_STRING:
  if(!arg)return NOT_IMPLEMENTED;
      else return NOT_VALID;
  case BUFFER_TOO_SMALL:
  if(arg == 2)if(BUFFER_TOO_SMALL== (i=primaParola(email,prima_parola,0)))return TEST_PASSED;
  else return failed("primaParola(email,prima_parola,0)","BUFFER_TOO_SMALL",i);
  else return NOT_VALID;
  default:
  return NOT_VALID;
  }
}
int test_tokenizzaEmail(int tipo, int arg){
char email[100];
Token array[100];
int dim=100;
 int i=0;
 email[0] = 't';
 email[1] = ' ';
 email[2] = 'c';
 email[3] = '\n';
 email[4] = '\n';
 email[5] = 'c';
 email[6] = 'c';
 email[7] = '\0';
  if(!(arg<3 && arg>=0))return ARG_MISSING;
  switch(tipo){
  case RESULT_OK:
    if(!arg){
        if(!(i=tokenizzaEmail(email,array,dim)))return TEST_PASSED;
        else return failed("tokenizzaEmail(email,array,dim)","RESULT_OK",i);
    }else return NOT_VALID;
  case NULL_POINTER:
    if((!arg)||(arg == 1))if(NULL_POINTER == (i=tokenizzaEmail(NULL,NULL,dim)))return TEST_PASSED;
  else return failed("tokenizzaEmail(NULL,NULL,dim)","NULL_POINTER",i);
      else return NOT_VALID;
case EMPTY_STRING:
  email[0]= '\0';
if(!arg)if(EMPTY_STRING == (i=tokenizzaEmail(email,array,dim)))return TEST_PASSED;
  else return failed("tokenizzaEmail(email,array,dim)","EMPTY_STRING",i);
      else return NOT_VALID;
case BODY_NOT_FOUND:
  email[0]='t';
  email[1]=' ';
  email[2]='t';
  email[3]='\n';
  email[4]='\n';
  email[5]='\0';
  if(!arg)if(BODY_NOT_FOUND == (i=tokenizzaEmail(email,array,dim)))return TEST_PASSED;
  else return failed("tokenizzaEmail(email,array,dim)","BODY_NOT_FOUND",i);
    else return NOT_VALID;
case MEM_ALLOC_ERROR:
    return NOT_IMPLEMENTED;
  default:
  return NOT_VALID;
  }
}

int test_printTokens(int tipo, int arg){
Token array[100]={NULL};
int dim = 100;
int i=0;
  if(!(arg<3 && arg>=0))return ARG_MISSING;
  switch(tipo){
case RESULT_OK:
    if(!arg)if(!(i=printTokens(array,dim)))return TEST_PASSED;
      else return failed("printTokens(array,dim)","RESULT_OK",i);
      else return NOT_VALID;
case NULL_POINTER:
    if(!arg)if(NULL_POINTER == (i=printTokens(NULL,dim)))return TEST_PASSED;
      else return failed("printTokens(NULL,dim)","NULL_POINTER",i);
      else return NOT_VALID;
case BUFFER_TOO_SMALL:
    if(!arg)if(BUFFER_TOO_SMALL == (i=printTokens(array,0)))return TEST_PASSED;
      else return failed("printTokens(array,dim)","BUFFER_TOO_SMALL",i);
      else return NOT_VALID;
  default:
  return NOT_VALID;
  }
}

