
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

#define alfabeto (carattere >= 'a') && (carattere <= 'z')
#define ALFABETO (carattere >= 'A') && (carattere <= 'Z')
#define numero (carattere >= '0') && (carattere <= '9')

/*
#define RESULT_OK		0	// la funzione ha avuto successo
#define UNKNOWN_ERROR		1	// errore sconosciuto
#define NULL_POINTER		2	// uno degli argomenti della funzione era NULL
#define EMPTY_STRING		3	// uno degli argomenti era una stringa vuota
#define FILE_MISSING		4	// il file non esiste
#define FILE_UNREADABLE		5	// il file non  leggibile
#define FILE_UNWRITABLE		6	// il file non  scrivibile
#define FILE_EMPTY		7	// il file  vuoto
#define BUFFER_TOO_SMALL	8	// il blocco di memoria (o vettore) passato non  sufficiente a contenere i dati
#define HEADER_NOT_FOUND	9	// lo header del messaggio non esiste
#define BODY_NOT_FOUND		10	// il corpo del messaggio non esiste
#define BAD_HEADER		11	// una riga degli headers non segue la sintassi giusta
#define MEM_ALLOC_ERROR		12	// non si  potuto allocare un blocco di memoria
#define LAST_CODE		13	// (da non usare) numero di codici di errore definiti

typedef struct a_token
{ char  parola[25];		// la parola estratta dalla email MAX_dim 25
  char  contesto[9];		// il contesto: nome dello header oppure NULL (body)
} Token;
*/
/*
int leggiFile(char * , int , char * );
int estraiHeaders(char * , char * , int );
int estraiTesto(char * ,char *);
int formatta_headers(char * );
int formatta_testo(char * );
int primoHeader(char * , char * , int );
int parseHeader(char * , char * , int , char * , int );
int primaParola(char * , char * , int );
int taglia_frase(char * , int );
int conta_parole(char * );
int tokenizzaEmail(char * , Token * , int);
int printTokens(Token * , int );
*/
int conta_parole(char * testo)
{ int i=0;
  int conta=0;
  char carattere;
  while(testo[i]!='\0')
   { carattere=testo[i];
     if(alfabeto||ALFABETO||numero)
      { carattere=testo[i+1];
        if(alfabeto||ALFABETO||numero)
         { carattere=testo[i];
           while(alfabeto||ALFABETO||numero)
            {i++;
	     carattere=testo[i];
	    }
	   conta++;
	   if(testo[i]=='\0')
	     break;
	 }
      }
     i++;
   }
  return conta;
}

int leggiFile(char * nomefile, int dimensione, char * testo)
{ FILE *pt_file;
  struct stat info;
  int dim_file=-1;
  char carattere;
  int i=0,j=0;
  if(nomefile==NULL)
      return(NULL_POINTER);
  if(testo==NULL)
      return(NULL_POINTER);
  if(nomefile[0]=='\0')
      return(EMPTY_STRING);
  if (stat(nomefile,&info))
      return(FILE_MISSING);
  if((pt_file=fopen(nomefile,"r"))==NULL)
      return(FILE_UNREADABLE);
  dim_file=info.st_size;
  if (dim_file<=0)
      return(FILE_EMPTY);
  for(i=0;i<dimensione-1;i++)
   { carattere=(getc(pt_file));
     if(carattere==EOF)
        break;
     testo[j++]=carattere;
   }
  testo[j]='\0';
  if(dim_file>=dimensione)
      return(BUFFER_TOO_SMALL);
  return(RESULT_OK);
}

int primaParola(char * testo, char * parola, int dim)
{ int i=0,j=0;
  char carattere;
  if(testo==NULL)
      return(NULL_POINTER);
  if(parola==NULL)
      return(NULL_POINTER);
  if(testo[0]=='\0')
      return(EMPTY_STRING);
  while(testo[i]!='\0')
   { carattere=testo[i];
     if(alfabeto||ALFABETO||numero)
      { carattere=testo[i+1];
        if(alfabeto||ALFABETO||numero)
         { carattere=testo[i];
           while(alfabeto||ALFABETO||numero)
            { if(testo[i]!=' ')
               { parola[j]=testo[i];
                 if(j>=dim-1)
                  return(BUFFER_TOO_SMALL);
                 j++;i++;
                 carattere=testo[i];
               }
              else
                 break;
	    }
	   parola[j]='\0';
	   return(RESULT_OK);
         }
      }
     i++;
   }
  return(UNKNOWN_ERROR);//Non ci sono PAROLE nel testo!!Solo caratteri non ALFANUMERICI
}

int estraiHeaders(char * email, char * headers, int dimh)
{ int i=0,b=0,val=-1;
  if(email==NULL)
      return(NULL_POINTER);
  if(headers==NULL)
      return(NULL_POINTER);
  if(email[0]=='\0')
      return(EMPTY_STRING);
  //Controllo ke l'email sia formattata correttamente
  val=formatta_headers(email);
  if(val!=0)
   return(val);
  val=formatta_testo(email);
  if(val!=0)
   return(val);
  while(i<dimh-2)
   { if((email[i]=='\n')&&(email[i+1]=='\n'))
      { b=1;
        break;
      }
     headers[i]=email[i];
     i++;
   }
  headers[i]='\n';
  headers[i+1]='\0';
  if(b==0)
   if((email[i]!='\n')||(email[i+1]!='\n'))
     return(BUFFER_TOO_SMALL);
  return(RESULT_OK);
}

int estraiTesto(char *email, char *testo)
{ int i=0,k=0;
  while(email[i]!='\0')
   { if(email[i]=='\n')
      if(email[i+1]=='\n')
        break;
     i++;
   }
  i=i+2;
  while(email[i]!='\0')
   { testo[k]=email[i];
     k++;
     i++;
   }
  testo[k]='\0';
  return 0;
}

int formatta_headers(char *email)//Controlla se l'email_header  formattata correttamente!!
{ int i=0,x=0,trov=0,h=0,a=0,sub=0;
  char from[5]="From";
  char to[3]="To";
  char subject[8]="Subject";
  char prova[8];
  prova[4]='\0';
  while(email[i+3]!='\0')//Controllo ke ci sia almeno un From
   { prova[0]=email[i];
     prova[1]=email[i+1];
     prova[2]=email[i+2];
     prova[3]=email[i+3];
     if((x=strcmp(from,prova))!=0)
       i++;
     else
      { trov++;
        break;
      }
   }
  i=0;
  prova[2]='\0';
  while(email[i+2]!='\0')//Controllo ke ci sia almeno un To
   { prova[0]=email[i];
     prova[1]=email[i+1];
     if((x=strcmp(to,prova))!=0)
       i++;
     else
      { trov++;
        break;
      }
   }
  i=0;
  prova[7]='\0';
  while(email[i+7]!='\0')//Controllo ke ci sia almeno un Subject
   { prova[0]=email[i];
     prova[1]=email[i+1];
     prova[2]=email[i+2];
     prova[3]=email[i+3];
     prova[4]=email[i+4];
     prova[5]=email[i+5];
     prova[6]=email[i+6];
     if((x=strcmp(subject,prova))!=0)
       i++;
     else
      { trov++;
        break;
      }
   }
  if(trov<3)
    return(HEADER_NOT_FOUND);
  if(trov>3)
    return(BAD_HEADER);
  if(email[0]!='F')
     return(BAD_HEADER);
  if(email[4]==':')
   { if(email[5]!=' ')
       return(BAD_HEADER);
     else i=6;
   }
  if((email[4]!=' ')&&(email[4]!=':'))
     return(BAD_HEADER);
  if(email[4]==' ')
   i=5;
  while(email[i]!='\0')
  {
    if((email[i]=='\n')&&(email[i+1]=='\n'))
     break;
    if(sub==0)
      if((email[i]==' ')||(email[i]=='	'))
         return(BAD_HEADER);
    if(email[i]=='\n')
     {
      if(email[i+1]!=' ')
       {if(email[i+1]!='	')
      { if(a==0)
        {prova[0]=email[i+1];
        prova[1]=email[i+2];
        prova[2]='\0';
        if((x=strcmp(to,prova))!=0)
          return(BAD_HEADER);
        else
         {
          a=1;
	   if(email[i+3]!=':')
            { if(email[i+3]!=' ');
                 return(BAD_HEADER);
            }
           if(email[i+3]==':')
            {
	      if(email[i+4]!=' ')
                 return(BAD_HEADER);
              else i=i+4;
            }
           if(email[i+3]==' ')
              i=i+5;
	   }}
	else{
        prova[0]=email[i+1];
        prova[1]=email[i+2];
        prova[2]=email[i+3];
        prova[3]=email[i+4];
        prova[4]=email[i+5];
        prova[5]=email[i+6];
        prova[6]=email[i+7];
        prova[7]='\0';
        if((x=strcmp(subject,prova))!=0)
          return(BAD_HEADER);
        else
         {sub=1;
	 if(email[i+8]!=' ')
	   {if(email[i+8]!=':')
             return(BAD_HEADER);
           }
	   if(email[i+8]==':')
            { if(email[i+9]!=' ')
                 return(BAD_HEADER);
              else i=i+9;
            }
           if(email[i+8]==' ')
              i=i+8;
       }
     }}else i++;}else i++;}
     i++;
  }
  return(RESULT_OK);
}

int formatta_testo(char *email)//Controlla se il testo dell'email c'!!
{ int i=0;
  while(email[i]!='\0')
   { if(email[i]=='\n')
      if(email[i+1]=='\n')
        break;
     i++;
   }
  if(email[i+2]=='\0')
   return(BODY_NOT_FOUND);
  return(RESULT_OK);

}

int primoHeader(char * headers, char * primo_header, int dim)
{ int i=0,b=0;
  if(primo_header==NULL)
      return(NULL_POINTER);
  if(headers==NULL)
      return(NULL_POINTER);
  if(headers[0]=='\0')
      return(EMPTY_STRING);
  while(i<dim-1)
   { if(headers[i]=='\n')
      { if((headers[i+1]!=' ')&&(headers[i+1]!='	'))
         { b=1;
           break;
         }
      }
     primo_header[i]=headers[i];
     i++;
   }
  primo_header[i]='\0';
  if(b==0)
   { if(headers[i]!='\n')
       return(BUFFER_TOO_SMALL);
      else
        if((headers[i+1]==' ')||(headers[i+1]=='	'))
         return(BUFFER_TOO_SMALL);
   }
  return(RESULT_OK);
}

int parseHeader(char * header, char * tipo, int dimt, char * valore, int dimv)
{ char from[5]="From";
  char to[3]="To";
  char subject[8]="Subject";
  char prova[8];
  int x=1,i=0,j=0;
  if(header==NULL)
      return(NULL_POINTER);
  if(tipo==NULL)
      return(NULL_POINTER);
  if(valore==NULL)
      return(NULL_POINTER);
  if(header[0]=='\0')
      return(EMPTY_STRING);
  prova[0]=header[0];
  prova[1]=header[1];
  prova[2]='\0';
  if((x=strcmp(to,prova))==0)
   {
    if(header[2]==':')
     { if(dimt<4)
         return(BUFFER_TOO_SMALL);
     }
    else
     if(dimt<3)
         return(BUFFER_TOO_SMALL);
    }
  prova[2]=header[2];
  prova[3]=header[3];
  prova[4]='\0';
  if((x=strcmp(from,prova))==0)
   {
    if(header[4]==':')
     { if(dimt<6)
         return(BUFFER_TOO_SMALL);
     }
    else
     if(dimt<5)
         return(BUFFER_TOO_SMALL);
   }
  prova[4]=header[4];
  prova[5]=header[5];
  prova[6]=header[6];
  prova[7]='\0';
  if((x=strcmp(subject,prova))==0)
   {
    if(header[7]==':')
     { if(dimt<9)
         return(BUFFER_TOO_SMALL);
     }
    else
     if(dimt<8)
         return(BUFFER_TOO_SMALL);
   }
   while(header[i]!=' ')
      { tipo[i]=header[i];
         i++;
      }
     tipo[i]='\0';
   i++;
   while(header[i]!='\0')
    { if(j>=dimv-1)
       return(BUFFER_TOO_SMALL);
      valore[j]=header[i];
      i++;
      j++;
    }
   valore[j]='\0';
  return(RESULT_OK);
}

int taglia_frase(char *frase, int pos)
{ int i=0;
  if(frase[pos]=='\0')
   return -1;
  while(frase[pos]!='\0')
   { frase[i]=frase[pos];
     i++;pos++;
   }
  frase[i]='\0';
  return 1;
}

int tokenizzaEmail(char * email, Token tokenArray[], int dimT)
{ int val=-1,dim1=200,dim2=65,dimt=10,dimv=50,dim3=15,dim_body=400;
  char head[dim1],primo_h[dim2],tip[dimt],valor[dimv],par[dim3],body[dim_body];
  int i=0,x=0,j=0,num=0,y=0,k=0;
  char carattere;
  char null='\0';
  if(email==NULL)
      return(NULL_POINTER);
  if(email[0]=='\0')
      return(EMPTY_STRING);
  //inizializzo tokenArray!!!!!
  for(i=0;i<dimT;i++)
   tokenArray[i].parola[0]='\0';
  i=0;
  //Estraggo gli Headers
  val=estraiHeaders(email,head,dim1);
  if(val!=0)
   return(val);
  int h=-1;
  for(j=0;j<3;j++)
   { val=primoHeader(head,primo_h,dim2);
     if(val!=0)
      return(val);
     y=strlen(primo_h);
     y++;
     taglia_frase(head,y);
     val=parseHeader(primo_h,tip,dimt,valor,dimv);
     if(val!=0)
       return(val);
     num=conta_parole(valor);
     x=0;
     for(i=0;i<num;i++)
      { val=primaParola(valor,par,dim3);
        if(val!=0)
         return(val);
	h++;
	strcpy(tokenArray[h].parola,par);
	strcpy(tokenArray[h].contesto,tip);
	k=0;x=0;
	while(valor[k]!='\0')
         { carattere=valor[k];
	   if(alfabeto||ALFABETO||numero)
            { carattere=valor[k+1];
              if(alfabeto||ALFABETO||numero)
                break;
	    }
	   else
              x++;
	   k++;
	 }
        x=x+strlen(par);
        x++;
        taglia_frase(valor,x);
      }
   }
  //Ho tokenizzato gli Headers
  if(h>=dimT-1)
    return(BUFFER_TOO_SMALL);
  //Tokenizzo il testo
  estraiTesto(email,body);
  num=conta_parole(body);
  for(i=0;i<num;i++)
      { val=primaParola(body,par,dim3);
        if(val!=0)
         return(val);
        h++;
        strcpy(tokenArray[h].parola,par);
        tokenArray[h].contesto[0]='\0';
        k=0;x=0;
	while(body[k]!='\0')
         { carattere=body[k];
	   if(alfabeto||ALFABETO||numero)
            { carattere=body[k+1];
              if(alfabeto||ALFABETO||numero)
                break;
	    }
	   else
              x++;
	   k++;
	 }
        x=x+strlen(par);
        x++;
        taglia_frase(body,x);
      }
 if(h>=dimT-1)
    return(BUFFER_TOO_SMALL);
 return (RESULT_OK);
}

int printTokens(Token tokenArray[], int dimT)
{ int i=0;
  if(tokenArray==NULL)
      return(NULL_POINTER);
  while(tokenArray[i].parola[0]!='\0')
   { if(tokenArray[i].contesto[0]=='\0')
       printf("%s\n",tokenArray[i].parola);
     else
       printf("%s*%s\n",tokenArray[i].contesto,tokenArray[i].parola);
     i++;
   }
  return(RESULT_OK);
}


