#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include "modulo1.h"
#include "testModulo1.h"


int leggiFile(char* nomefile,int dimensione,char* testo)
{
	int j=0;
	char carattere;
	FILE *email;
	
   if(nomefile == NULL || testo == NULL)
      return NULL_POINTER;
		
	email=fopen(nomefile,"r");
	if(!email)	return EMPTY_STRING;
	
	
	carattere=fgetc(email);

   if(!email)
      return FILE_UNREADABLE;
	
	if(carattere==EOF) return FILE_EMPTY;

	while((j<dimensione)&&(carattere!=EOF))
	{
		testo[j]=carattere;
		carattere=fgetc(email);
		j++;
	}
		testo[j]='\0';

	return RESULT_OK;
}


int estraiHeaders(char * email,char * headers,int dimh)
{
	int j=0;
	if(email[0]=='\0') return EMPTY_STRING;
	   
	   if(email == NULL || headers == NULL)
      return NULL_POINTER;

	do
	{
	if(j>=dimh)
	{
		headers[j]='\0';
		return BUFFER_TOO_SMALL;
	}
	headers[j]=email[j];
	j++;
	}while((email[j]!='\n')&&(email[j-1]!='\n'));

	return RESULT_OK;
}

int primoHeader(char * headers, char * primo_header, int dim)
{
int j=0;

if(headers[0]=='\0') return EMPTY_STRING;
   
  if(headers == NULL || primo_header == NULL)
      return NULL_POINTER;

while(j<dim)
{
primo_header[j]=headers[j];
if(j+1<dim)
	if(headers[j]=='\n')
		if(headers[j+1]!=32 && headers[j+1]!=9)
		{
			primo_header[j+1]='\0';
			return RESULT_OK;
		}
j++;
}
primo_header[j]='\0';

return BUFFER_TOO_SMALL;
}

int parseHeader(char * header, char * tipo, int dimt, char * valore, int dimv)
{
int i=0,j=0;

if(header[0]=='\0') return EMPTY_STRING;

if(header == NULL || tipo == NULL || valore == NULL)
      return NULL_POINTER;

while(i<dimt)
{
tipo[i]=header[i];
if(tipo[i]==':')
{
	tipo[i+1]='\0';
	break;
}

i++;
}

if(i==dimt) return BUFFER_TOO_SMALL;
i=i+2;
while(j<dimv)
{
	valore[j]=header[i];
	if(valore[j]=='\0') return RESULT_OK;
	j++; i++;
}
valore[j]='\0';
return BUFFER_TOO_SMALL;
}

int primaParola(char * testo, char * parola, int dim)
{
int i=0,j=0;
if(testo[0]='\0') return EMPTY_STRING;

if(testo == NULL || parola == NULL)
      return NULL_POINTER;

while(isalpha(testo[i])==0) i++;

while(j<dim)
{
if(isalpha(testo[i])==1) parola[j]=testo[i];
else{
	parola[j]='\0';
	return RESULT_OK;
}
i++;
j++;
}
parola[j]='\0';
return BUFFER_TOO_SMALL;
}


int tokenizzaEmail(char * email, Token tokenArray[], int dimT)
{
   if(email == NULL || tokenArray == NULL)
      return NULL_POINTER;
}

int printTokens(Token tokenArray[], int dimT)
{
   if(tokenArray == NULL)
      return NULL_POINTER;
}

