#include <stdlib.h>
#include <stdio.h>
#include "modulo1.h"
#include <string.h>
#define dimH 500 

char * refreshBuf(char *testo, int dim){
	char *Buf;
	int leght = 0, i = 0;
	leght = (strlen(testo) - dim)+1;
	Buf = (char*)malloc(sizeof(char) * leght);
	while(testo[dim] != '\0'){
		Buf[i] = testo[dim];
		i++;
		dim++;
	}
	free(testo);
	return Buf;
}

int leggiFile(char *nomefile, int dimensione, char *testo){
  FILE *fp;
  struct stat *info;
  char c;
  int i = 0;
  if(access(nomefile, 0))return FILE_MISSING;
  //if(access(nomefile, 4)) return FILE_UNREADABLE;
  if(access(nomefile, 2))return FILE_UNWRITABLE;
  if(!(fp = fopen(nomefile, "r")))return FILE_UNREADABLE;
  for(i = 0;i < dimensione-1;i++){
  testo[i] = getc(fp);
	if(testo[i] == EOF){
		testo[i] = '\0';
		return RESULT_OK;
  	}
  }
}

int estraiHeaders(char * email, char * headers, int dimh){
	int i = 0;
	for(i = 0; i < dimh-1; i++){
		if(email[i] == '\n' && email[i+1] == '\n'){
			headers[i] = '\0';
			return RESULT_OK;
		}
		headers[i] = email[i];
	}
	return BUFFER_TOO_SMALL;
}

int primoHeader(char * headers, char * primo_header, int dim){
	int i = 0;
	if(headers[i] == '\0')return EMPTY_STRING;
	for(i = 0; i < dim-1; i++){
		if(headers[i] == '\n' && !((headers[i+1] == ' ') || (headers[i+1] == '\t')) || headers[i] == '\0'){
				primo_header[i] = '\0';
				return RESULT_OK;
		}
		else	primo_header[i] = headers[i];
	}
	return BUFFER_TOO_SMALL;
}

int parseHeader(char * header, char * tipo, int dimt, char * valore, int dimv){
	int i = 0, j = 0;
	while(header[i] != ' '){
		if(header[i] == '\0')return BAD_HEADER;
		if(i >= dimv-1)return BUFFER_TOO_SMALL;
		tipo[i] = header[i++];
	}
	tipo[i] = '\0';
	i++;
	for(j = 0; j < dimv; j++){
		if(header[i] != '\0'){
		valore[j] = header[i++];
		}
		else{
			 if(j >= dimv-1)return BUFFER_TOO_SMALL;
			 valore[j+1] = '\0';
			 return RESULT_OK;
		}
	} 
 return BUFFER_TOO_SMALL;
}
int primaParola(char * testo, char * parola, int dim){
	int i = 0,j = 0;
	if(testo[i] == '\0')return EMPTY_STRING;
	while(testo[i] != '\0'){
	   if(i+1 >= dim-1)return BUFFER_TOO_SMALL;
	   if((testo[i] <= 'Z' && testo[i] >= 'A')||(testo[i]<= 'z' && testo[i] >= 'a')||(testo[i] <= '9' && testo[i] >= '0')){
	   if((testo[i+1]<= 'Z' && testo[i+1] >= 'A')||(testo[i+1] <= 'z' && testo[i+1] >='a')||(testo[i+1] <= '9' && testo[i+1] >= '0')){
	   while((testo[i] <= 'Z' && testo[i] >= 'A')||(testo[i] <= 'z' && testo[i] >= 'a')||(testo[i] <= '9' && testo[i] >= '0')){
		   parola[j] = testo[i];
		   testo[i] = '#';
		   //system("PAUSE");
		   //printf("%c\n", parola[j]);
		   i++;
		   if(j++ >= dim-2)return BUFFER_TOO_SMALL;  
	   }
				parola[j] = '\0';
				return RESULT_OK;
	   }else {
        testo[i] = '#';
        i++;
        }
	   }else i++;  
	}
	parola[j] = '\0';
	return EMPTY_STRING;
}

int tokenizzaEmail(char * email, Token tokenArray[], int dimT){
	char *headers, *parola, *primo_header, *tipo, *valore;
	int i = 0, j = 0, p = 0;
	if(!(parola = (char*)malloc(sizeof(char) * dimH)))return MEM_ALLOC_ERROR;
	if(!(headers = (char*)malloc(sizeof(char) * dimH)))return MEM_ALLOC_ERROR;
	if(!(primo_header = (char*)malloc(sizeof(char) * dimH)))return MEM_ALLOC_ERROR;
	if(!(tipo = (char*)malloc(sizeof(char) * dimH)))return MEM_ALLOC_ERROR;
	if(!(valore =  (char*)malloc(sizeof(char) * dimH)))return MEM_ALLOC_ERROR;
	//------------------------------------------tokenizza
	if(i = estraiHeaders(email, headers, dimH))return i;
	else{	//aggiorna buffer della maile tokenizza lo header
		email = refreshBuf(email, strlen(headers));
		  do{ //fino a quando il Buf nn vuoto estrae il primo header e aggiorna headers
			if(i = primoHeader(headers, primo_header, dimH))return i;
			else{
			   headers = refreshBuf(headers, strlen(primo_header)+1);
				if(i = parseHeader(primo_header, tipo, dimH, valore, dimH))return i;
				else{
					if((i = primaParola(valore, parola, dimH))||(parola[i] == '\0'))
						return BAD_HEADER;
					else{	//salve tutte le parole di valore fino a dim = 0
						tokenArray[j].contesto = malloc(sizeof(char) * dimH);
						while(tipo[i] != '\0')tokenArray[j].contesto[i] = tipo[i++];
						tokenArray[j].contesto[i] = '\0';
						i = 0;
						tokenArray[j].parola = malloc(sizeof(char) * dimH);
						while(parola[i] != '\0')tokenArray[j].parola[i] = parola[i++];
						tokenArray[j].parola[i] = '\0';
						j++; if(j > dimT-1)return BUFFER_TOO_SMALL;
						i = 0;
						while(valore[i] != '\0'){
                              if(!(i = primaParola(valore, parola, dimH))){
                                tokenArray[j].contesto = malloc(sizeof(char) * dimH);
                              	while(tipo[i] != '\0')tokenArray[j].contesto[i] = tipo[i++];
								tokenArray[j].contesto[i] = '\0';
								i = 0;
                                tokenArray[j].parola = malloc(sizeof(char) * dimH);
                                while(parola[i] != '\0')tokenArray[j].parola[i] = parola[i++];
                                tokenArray[j].parola[i] = '\0';
                                if(j++ > dimT-1)return BUFFER_TOO_SMALL;
                              }
                              else valore[i]='\0';
                        }
        
					}
				}
			}
		}while(strlen(headers));
		i = 0;
		    if(!(i = primaParola(email, parola, dimH))){
		          tokenArray[j].parola = malloc(sizeof(char) * dimH);
                        while(parola[i] != '\0')tokenArray[j].parola[i] = parola[i++];
                        tokenArray[j].parola[i] = '\0';
                        if(j++ > dimT-1)return BUFFER_TOO_SMALL;
		    }else return BODY_NOT_FOUND;
		while(email[i] != '\0'){
            if(!(i = primaParola(email, parola, dimH))){
                        tokenArray[j].parola = malloc(sizeof(char) * dimH);
                        while(parola[i] != '\0')tokenArray[j].parola[i] = parola[i++];
                        tokenArray[j].parola[i] = '\0';
                        if(j++ > dimT-1)return BUFFER_TOO_SMALL;
            }else{
                        free(email);
                        return RESULT_OK;
            }
        }
	}
	return RESULT_OK;
}
int printTokens(Token tokenArray[], int dimT){
    int j = 0;
    if(!tokenArray[j].parola)return UNKNOWN_ERROR;
    while(tokenArray[j].parola != NULL){
        if(tokenArray[j].contesto != NULL)
                printf("%s*%s\n",tokenArray[j].contesto,tokenArray[j].parola);
        else
                printf("%s\n",tokenArray[j].parola);
        j++;
    }
    return RESULT_OK;
}
