//#include"modulo1.h"
//#include"test_modulo1.h"

#include <unistd.h> //per la stat


#include<stdlib.h>
#include<stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>

#include<string.h>


/*
#define RESULT_OK               0       // la funzione ha avuto successo
#define UNKNOWN_ERROR           1       // errore sconosciuto
#define NULL_POINTER            2       // uno degli argomenti della funzioneera NULL
#define EMPTY_STRING            3       // uno degli argomenti era una stringavuota
#define FILE_MISSING            4       // il file non esiste
#define FILE_UNREADABLE         5       // il file non Ú leggibile
#define FILE_UNWRITABLE         6       // il file non Ú scrivibile
#define FILE_EMPTY              7       // il file Ú vuoto
#define BUFFER_TOO_SMALL        8       // il blocco di memoria (o vettore)passato non Ú sufficiente a contenere i dati
#define HEADER_NOT_FOUND        9       // lo header del messaggio non esiste
#define BODY_NOT_FOUND          10      // il corpo del messaggio non esiste
#define BAD_HEADER              11      // una riga degli headers non segue lasintassi giusta
#define MEM_ALLOC_ERROR         12      // non si Ú potuto allocare un blocco dimemoria
#define LAST_CODE               13      // (da non usare) numero di codici dierrore definiti

///////////////////////////////////////////////////////////////////////////////////////////////
//// Definizione della struttura dati che contiene un token
/////////////////////////////////////////////////////////////////////////////////////////////////
//
//

typedef struct a_token {
	char * parola;		// la parola estratta dalla email (headers o body)
	char * contesto;	// il contesto: nome dello header oppure NULL (body)
		} Token;


int leggiFile(char * nomefile, int dimensione, char * testo);
// funzione che individua le intestazioni della email e le copia nel blocco di memoria 'headers' di lunghezza 'dimh'
 int estraiHeaders(char * email, char * headers, int dimh);

 				// funzione che estrae il primo header dagli headers e lo copia in primo_header
int primoHeader(char * headers, char * primo_header, int dim);
		// 								// funzione che estrae il tipo ed il valore di uno header
	int parseHeader(char * header, char * tipo, int dimt, char * valore, int dimv);
// funzione che estrae la prima parola da una stringa
int primaParola(char * testo, char * parola, int dim);
		//
 																// funzione che estrae i primi dimT token dalla email
int tokenizzaEmail(char * email, Token tokenArray[], int dimT);
																				// funzione che stampa i token uno per riga nel formato 'contesto*parola' oppure 'parola'
 int printTokens(Token tokenArray[], int dimT);
*/








//LEGGE IL FILE



//#include"modulo1.h"
//#include"test_modulo1.h"


int leggiFile(char *nomefile, int dimensione, char *testo)
{FILE* fd;
 struct stat buf;
 int n=0;
 char c;
 int stato;

 if(nomefile==NULL)
        {return NULL_POINTER;
        }
                   
 if(dimensione<=0)
 	{return BUFFER_TOO_SMALL;
	}
 stato=stat(nomefile,&buf);

// testare la stat???
 //if(stato==-1)
 //	{printf("errore nella stat");
//	 return UNKNOWN_ERROR;
//	}

  
//testa se Ú un file regolare(cioÚ se il file esiste)
  
 if(S_ISREG(buf.st_mode)==0)
	{return FILE_MISSING;	 
	}

//testa se il file Ú leggibile(tramite la maschera dei bits basta)
 
//printf("uid=%d\n",buf.st_uid);
 fd = fopen(nomefile , "r");
 if(fd==NULL)
 	{
	 return FILE_UNREADABLE;
	}
 
 if(!(buf.st_mode&0222))
	{
	 return FILE_UNWRITABLE;
	}

 
 


 //da vedere se &#136; giusta come ritorno
 if(testo == NULL)
	{return NULL_POINTER;
	}

//fd = fopen(nomefile , "r");


 if(fgetc(fd) == EOF)               
 	{return FILE_EMPTY;
	}

 rewind(fd);                         // riavvolgo aperto :)

 while(n < (dimensione))
	 {c = fgetc(fd);                    // appoggio ogni lettera in app
	  if(c != EOF)
		{
		 testo[n] = c;
		 n++;     
		}
	   else
		{testo[n]='\0';
		  return RESULT_OK;
		}		 
	 }

 return BUFFER_TOO_SMALL; 

}


//ESTRAE HEADER


int estraiHeaders(char *email, char *headers, int dimh)
{int n=0;
 int i=0;
 int j=0;
 int lunghezza;
 char *app;
 app=(char *)malloc(dimh*sizeof(char));
	if(app==NULL)
		{return MEM_ALLOC_ERROR;
		}
 if(email==NULL)
 	{return NULL_POINTER;
	}
 
 if(email[0]==':')
 	{return BAD_HEADER;
	}
 
 if(dimh<=0)
 	{return BUFFER_TOO_SMALL;
	}

  if(email[0]=='\0')
	          {return EMPTY_STRING;
			          }

  if(email[0]=='\n')
  	{return HEADER_NOT_FOUND;
	}

 
 while(n<dimh)
 	{if(email[n]!='\n')
		{headers[n]=email[n];
		 }
	 else 
		{if(email[n+1]=='\n')
			{ headers[n+1]='\0';                                                                             
			 lunghezza=strlen(email);
			 n=n+2;//così salta i due '\n' e parte dal body
                         for(i=n;i<=lunghezza;i++)
                        	 {app[j]=email[i];
                                  j++;                                                                                                                       
}
                          lunghezza=strlen(app);
	                  for(i=0;i<=lunghezza;i++)
				  {email[i]=app[i];                                                                                                         
}                                                                                                                                                                                                                         	
			 return RESULT_OK;
			}
		 headers[n]=email[n];
		}
	 n++;

	}
headers[n]='\0';
return BUFFER_TOO_SMALL;
}


//ESTRAE PRIMO HEADER

int primoHeader(char *headers, char *primo_header, int dim)
{int n=0;
 int i=0;
 int j=0;
 int lunghezza;
 char *app;
 app=(char *)malloc(dim*sizeof(char));

 if(headers==NULL)
	 	{return NULL_POINTER;
		}
 
 if(headers[0]==':')
	         {return BAD_HEADER;
			         }


   if(primo_header==NULL)
	           {return NULL_POINTER;
			           }

    if(dim<=0)
	            {return BUFFER_TOO_SMALL;
			            }

     if(headers[0]=='\0')
	             {return EMPTY_STRING;
			             }
     
 while(n<dim)
	 {
		 
	 if(headers[n]=='\n')
	 	{if((headers[n+1]!=' ')&&(headers[n+1]!='\t'))
			{
			 primo_header[n]='\0';
			 lunghezza=strlen(headers);
			 n=n+1; //così salta lo '\n' finale

	 		 for(i=n;i<=lunghezza;i++)
			 	{app[j]=headers[i];
				 j++;
				}
			 
			 lunghezza=strlen(app);
			 
			 for(i=0;i<=lunghezza;i++)
			 	{headers[i]=app[i];
				}
			 
			 return RESULT_OK;
			}
		}
	 primo_header[n]=headers[n];
	 n++;
	 
	 

	 }
 primo_header[n]='\0';
 return BUFFER_TOO_SMALL;
}


//PARSE HEADER


int parseHeader(char * header, char * tipo, int dimt, char * valore, int dimv)
{int n=0;
 int j=0;


 if(header==NULL)
	 {return NULL_POINTER;
	 }
 if(header[0]==':')
	         {return BAD_HEADER;
			         }

  if(tipo==NULL)
	          {return NULL_POINTER;
			          }
   if(valore==NULL)
	           {return NULL_POINTER;
			           }

     if(header[0]=='\0')
	             {return EMPTY_STRING;
			             }

     if(dimv<=0)
	             {return BUFFER_TOO_SMALL;
			             }
     if(dimt<=0)
	             {return BUFFER_TOO_SMALL;
			             }

 while(n<dimt)
 	{if(header[n]==' ') //finisce il tipo
		{tipo[n]='\0';
		 break;
		}
		
	tipo[n]=header[n];
	n++;
	}
 n++;
while(j<dimv)
 	{if(header[n]!='\0')
		{valore[j]=header[n];
			 j++;
			 n++;
		}
	 else
	 	{valore[j]=header[n];
		 return RESULT_OK;
		}
	 
	}

 return BUFFER_TOO_SMALL;	
}




//PRIMA PAROLA

int primaParola(char * testo, char * parola, int dim)
{
 int n=0;
 int j=0;
 int lunghezza=0;
 int i=0;
 int count=0;//tipo "semaforo" i caratteri(devono essere almeno due)
 int k=100;

 // printf("testo=%s\n",testo);
 char *app;
 app=(char *)malloc(dim*sizeof(char));
 if(testo==NULL)
	         {
			          return NULL_POINTER;
				          }
  if(parola==NULL)
	          {return NULL_POINTER;
			          }
   if(testo[0]=='\0')
	           {return EMPTY_STRING;
			           }
    if(dim<=0)
	            {
			             return BUFFER_TOO_SMALL;
				             }
 
 
 
 lunghezza=strlen(testo);
// printf("lunghezza=%d\n",lunghezza);
 if(testo[j]==':')
	{return BAD_HEADER;
	}
 
 while(n<dim)
	{//printf("%c %d\n",testo[j],j);
	 if(testo[j]=='\0')
		{parola[n]=testo[j];
		 testo[0]='\0';
		 return RESULT_OK;
		}
	
	
if((testo[j]>=65)&&(testo[j]<=90)||(testo[j]>=97)&&(testo[j]<=122)||(testo[j]>=48)&&(testo[j]<=57))
		{parola[n]=testo[j];
		n++;
		count=1;
		}
	 
	 else{	 if(count!=0) //specie di semaforo, controlla se non Ú la prima lettera
			{parola[n]='\0';
			 j++; //perchÚ trova una lettera che non v  

			 //si usa per togliere l'ultima parte letta dal testo iniziale;
			for(n=j;n<=lunghezza;n++)
			 	{app[i]=testo[n];
//				 printf("%c ",app[n]);
				 i++;
				}
			 lunghezza=strlen(app);
			 for(n=0;n<=lunghezza;n++)
				 {testo[n]=app[n];
				 }
//			 printf("app=%s\n",app);
//			 printf("testo=%s\n",testo);
			 
		 	 return RESULT_OK;
			}
	
	 }
	 j++;
	}
return BUFFER_TOO_SMALL;
}



//TOKENIZZAZIONE EMAIL
int tokenizzaEmail(char *email,Token tokenArray[],int dimT)
{int count1=0,count2=0,count3=0;
 int n=0;
 int dim=1024;
 int ret;
 int i=0;
 int lunghezza_valore,lunghezza_testo,lunghezza_headers,lunghezza_parola;
 char *buffer_parola;
 char *app;
 char *backup_email,*backup_email2;
 int count_tipo=0;
 int count_valore=0;
 app=(char *)malloc(dim*sizeof(char));

 int stop;
 int k;
 int lunghezza_token;

 
 
//non sò se da mettere ma servono per la preparazione della tokenizzazione 
 char *testo, *headers, *primo_header, *header, *tipo, *valore, *prima_parola;
 int dimensione, torna,dimt,dimv;
 int j=0;


if(email==NULL)
	        {return NULL_POINTER;
			        }

 if(dimT<=0)
	         {return BUFFER_TOO_SMALL;
			         }

  if(tokenArray==NULL)
	          {return NULL_POINTER;
			          }

   if(email[0]=='\0')
	           {return EMPTY_STRING;
			           }



 
//allocazione memoria degli headers DA FARE???
 headers=(char *)malloc(dim*(sizeof(char)));
 	if(headers==NULL)
	                  {return MEM_ALLOC_ERROR;
				                                   }
 primo_header = (char *)malloc(sizeof(char)*dim);
  if(primo_header==NULL)
	                   {return MEM_ALLOC_ERROR;
				                                    }
  
 prima_parola=(char *)malloc(dim*sizeof(char));
 if(prima_parola==NULL)
	                  {return MEM_ALLOC_ERROR;
				                                   }
 tipo = (char *)malloc(sizeof(char)*dim);
 if(tipo==NULL)
	                  {return MEM_ALLOC_ERROR;
				                                   }
 
 valore=(char *)malloc(sizeof(char)*dim);
 if(valore==NULL)
	                  {return MEM_ALLOC_ERROR;
				                                   }

 char *app_tipo;

// tokenArray[0].parola="popadkpaokd\n\0";
// printf("%s\n",tokenArray[0].parola);
 
 while(n<dimT)
 	{ret=estraiHeaders(email,headers,dim);
	 lunghezza_testo=strlen(email);
	 lunghezza_headers=strlen(headers);
	 backup_email=strdup(email); 
	 while(lunghezza_headers!=0)
	 	{ret=primoHeader(headers,primo_header,dim);
	          ret=parseHeader(primo_header,tipo,dim,valore,dim);
		  while(tipo[0]!='\0')
		  { 	ret=primaParola(tipo,prima_parola,dim);
			 lunghezza_parola=strlen(prima_parola);
			  
			 if(lunghezza_parola>1)
				{
				 app_tipo=strdup(prima_parola);
				}
			 lunghezza_valore=strlen(valore);
			 while(valore[0]!='\0')
				            {				   
				         	ret=primaParola(valore,prima_parola, dim);
						lunghezza_parola=strlen(prima_parola);
						 if(lunghezza_parola>1)
						    	 {
							  tokenArray[n].parola=strdup(app_tipo);
							  tokenArray[n].contesto=strdup(prima_parola);
							  n++;
					    		} 			
						 lunghezza_valore=strlen(valore);
					   }
		}
		lunghezza_headers=strlen(headers);
		
	 }	 

	if(backup_email[0]=='\0')
	                {return BODY_NOT_FOUND;
				                }
	//TOKENIZZAZIONE BODY
	lunghezza_testo=strlen(backup_email);
	while(lunghezza_testo!=0)
		{ret=primaParola(backup_email,prima_parola, dim);
			lunghezza_parola=strlen(prima_parola);
			//test per non mettere un token minore di 2 caratteri
				if(lunghezza_parola>1){
						tokenArray[n].parola=NULL;
						tokenArray[n].contesto=strdup(prima_parola);
						n++;
			                        }
		lunghezza_testo=strlen(backup_email);	
		}
		
	return RESULT_OK;
       	
	 
	}


return BUFFER_TOO_SMALL; 
}


int printTokens(Token tokenArray[],int dimT)
	{int n=0;


 	if(dimT<=0)
		{return BUFFER_TOO_SMALL;
		}
		
	  if(tokenArray[0].parola==NULL)
	                  {return NULL_POINTER;
			                }
         if(tokenArray[0].contesto==NULL)
                       {return NULL_POINTER;
	                      }		       
	 while(n<dimT)
	 	{if(tokenArray[n].parola!=NULL)
			{printf("%s*%s\n",tokenArray[n].parola,tokenArray[n].contesto);
			 n++;
			}
		else	
			{printf("%s\n",tokenArray[n].contesto);
			n++;
			}
		if((tokenArray[n].parola==NULL)&&(tokenArray[n].contesto==NULL))
			{return RESULT_OK;
			}
		}
		
	 return BUFFER_TOO_SMALL;
	}
	







